/* DUPLICATOR MYSQL SCRIPT CREATED ON : September 7, 2013, 5:52 pm */

SET FOREIGN_KEY_CHECKS = 0;

CREATE TABLE `wp_commentmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8_unicode_ci,
  PRIMARY KEY (`meta_id`),
  KEY `comment_id` (`comment_id`),
  KEY `meta_key` (`meta_key`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `wp_comments` (
  `comment_ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_post_ID` bigint(20) unsigned NOT NULL DEFAULT '0',
  `comment_author` tinytext COLLATE utf8_unicode_ci NOT NULL,
  `comment_author_email` varchar(100) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `comment_author_url` varchar(200) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `comment_author_IP` varchar(100) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `comment_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_content` text COLLATE utf8_unicode_ci NOT NULL,
  `comment_karma` int(11) NOT NULL DEFAULT '0',
  `comment_approved` varchar(20) COLLATE utf8_unicode_ci NOT NULL DEFAULT '1',
  `comment_agent` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `comment_type` varchar(20) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `comment_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`comment_ID`),
  KEY `comment_post_ID` (`comment_post_ID`),
  KEY `comment_approved_date_gmt` (`comment_approved`,`comment_date_gmt`),
  KEY `comment_date_gmt` (`comment_date_gmt`),
  KEY `comment_parent` (`comment_parent`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `wp_duplicator` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `token` varchar(25) COLLATE utf8_unicode_ci NOT NULL,
  `packname` varchar(250) COLLATE utf8_unicode_ci NOT NULL,
  `zipname` varchar(250) COLLATE utf8_unicode_ci NOT NULL,
  `zipsize` int(11) DEFAULT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `owner` varchar(60) COLLATE utf8_unicode_ci NOT NULL,
  `settings` longtext COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `wp_links` (
  `link_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `link_url` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `link_name` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `link_image` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `link_target` varchar(25) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `link_description` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `link_visible` varchar(20) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'Y',
  `link_owner` bigint(20) unsigned NOT NULL DEFAULT '1',
  `link_rating` int(11) NOT NULL DEFAULT '0',
  `link_updated` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `link_rel` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `link_notes` mediumtext COLLATE utf8_unicode_ci NOT NULL,
  `link_rss` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`link_id`),
  KEY `link_visible` (`link_visible`)
) ENGINE=MyISAM AUTO_INCREMENT=8 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `wp_options` (
  `option_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `option_name` varchar(64) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `option_value` longtext COLLATE utf8_unicode_ci NOT NULL,
  `autoload` varchar(20) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'yes',
  PRIMARY KEY (`option_id`),
  UNIQUE KEY `option_name` (`option_name`)
) ENGINE=MyISAM AUTO_INCREMENT=368 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `wp_postmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8_unicode_ci,
  PRIMARY KEY (`meta_id`),
  KEY `post_id` (`post_id`),
  KEY `meta_key` (`meta_key`)
) ENGINE=MyISAM AUTO_INCREMENT=224 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `wp_posts` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_author` bigint(20) unsigned NOT NULL DEFAULT '0',
  `post_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content` longtext COLLATE utf8_unicode_ci NOT NULL,
  `post_title` text COLLATE utf8_unicode_ci NOT NULL,
  `post_excerpt` text COLLATE utf8_unicode_ci NOT NULL,
  `post_status` varchar(20) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'publish',
  `comment_status` varchar(20) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'open',
  `ping_status` varchar(20) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'open',
  `post_password` varchar(20) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `post_name` varchar(200) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `to_ping` text COLLATE utf8_unicode_ci NOT NULL,
  `pinged` text COLLATE utf8_unicode_ci NOT NULL,
  `post_modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_modified_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content_filtered` longtext COLLATE utf8_unicode_ci NOT NULL,
  `post_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `guid` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `menu_order` int(11) NOT NULL DEFAULT '0',
  `post_type` varchar(20) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'post',
  `post_mime_type` varchar(100) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `comment_count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`),
  KEY `post_name` (`post_name`),
  KEY `type_status_date` (`post_type`,`post_status`,`post_date`,`ID`),
  KEY `post_parent` (`post_parent`),
  KEY `post_author` (`post_author`)
) ENGINE=MyISAM AUTO_INCREMENT=35 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `wp_term_relationships` (
  `object_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_taxonomy_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_order` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`object_id`,`term_taxonomy_id`),
  KEY `term_taxonomy_id` (`term_taxonomy_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `wp_term_taxonomy` (
  `term_taxonomy_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `term_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `taxonomy` varchar(32) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `description` longtext COLLATE utf8_unicode_ci NOT NULL,
  `parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_taxonomy_id`),
  UNIQUE KEY `term_id_taxonomy` (`term_id`,`taxonomy`),
  KEY `taxonomy` (`taxonomy`)
) ENGINE=MyISAM AUTO_INCREMENT=7 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `wp_terms` (
  `term_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(200) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `slug` varchar(200) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `term_group` bigint(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_id`),
  UNIQUE KEY `slug` (`slug`),
  KEY `name` (`name`)
) ENGINE=MyISAM AUTO_INCREMENT=7 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `wp_usermeta` (
  `umeta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8_unicode_ci,
  PRIMARY KEY (`umeta_id`),
  KEY `user_id` (`user_id`),
  KEY `meta_key` (`meta_key`)
) ENGINE=MyISAM AUTO_INCREMENT=21 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `wp_users` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_login` varchar(60) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `user_pass` varchar(64) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `user_nicename` varchar(50) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `user_email` varchar(100) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `user_url` varchar(100) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `user_registered` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `user_activation_key` varchar(60) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `user_status` int(11) NOT NULL DEFAULT '0',
  `display_name` varchar(250) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`),
  KEY `user_login_key` (`user_login`),
  KEY `user_nicename` (`user_nicename`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;


/* INSERT TABLE DATA: wp_commentmeta */
INSERT INTO `wp_commentmeta` VALUES("1", "1", "_wp_trash_meta_status", "1");
INSERT INTO `wp_commentmeta` VALUES("2", "1", "_wp_trash_meta_time", "1378240127");

/* INSERT TABLE DATA: wp_comments */
INSERT INTO `wp_comments` VALUES("1", "1", "Mr WordPress", "", "http://wordpress.org/", "", "2013-09-02 12:53:12", "2013-09-02 12:53:12", "Hi, this is a comment.<br />To delete a comment, just log in and view the post&#039;s comments. There you will have the option to edit or delete them.", "0", "trash", "", "", "0", "0");

/* INSERT TABLE DATA: wp_duplicator */
INSERT INTO `wp_duplicator` VALUES("1", "522b67d55f8b88336", "20130907_catlovers", "522b67d55f8b88336_20130907_catlovers_package.zip", "0", "2013-09-07 17:52:21", "catlover", "a:4:{s:14:\"plugin_version\";s:5:\"0.4.6\";s:4:\"type\";s:6:\"Manual\";s:6:\"status\";s:5:\"Error\";s:5:\"notes\";s:0:\"\";}");

/* INSERT TABLE DATA: wp_links */
INSERT INTO `wp_links` VALUES("1", "http://codex.wordpress.org/", "Documentation", "", "", "", "Y", "1", "0", "0000-00-00 00:00:00", "", "", "");
INSERT INTO `wp_links` VALUES("2", "http://wordpress.org/news/", "WordPress Blog", "", "", "", "Y", "1", "0", "0000-00-00 00:00:00", "", "", "http://wordpress.org/news/feed/");
INSERT INTO `wp_links` VALUES("3", "http://wordpress.org/extend/ideas/", "Suggest Ideas", "", "", "", "Y", "1", "0", "0000-00-00 00:00:00", "", "", "");
INSERT INTO `wp_links` VALUES("4", "http://wordpress.org/support/", "Support Forum", "", "", "", "Y", "1", "0", "0000-00-00 00:00:00", "", "", "");
INSERT INTO `wp_links` VALUES("5", "http://wordpress.org/extend/plugins/", "Plugins", "", "", "", "Y", "1", "0", "0000-00-00 00:00:00", "", "", "");
INSERT INTO `wp_links` VALUES("6", "http://wordpress.org/extend/themes/", "Themes", "", "", "", "Y", "1", "0", "0000-00-00 00:00:00", "", "", "");
INSERT INTO `wp_links` VALUES("7", "http://planet.wordpress.org/", "WordPress Planet", "", "", "", "Y", "1", "0", "0000-00-00 00:00:00", "", "", "");

/* INSERT TABLE DATA: wp_options */
INSERT INTO `wp_options` VALUES("362", "_site_transient_timeout_theme_roots", "1378577991", "yes");
INSERT INTO `wp_options` VALUES("363", "_site_transient_theme_roots", "a:6:{s:16:\"custom-community\";s:7:\"/themes\";s:9:\"pet-world\";s:7:\"/themes\";s:12:\"twentyeleven\";s:7:\"/themes\";s:9:\"twentyten\";s:7:\"/themes\";s:14:\"twentythirteen\";s:7:\"/themes\";s:12:\"twentytwelve\";s:7:\"/themes\";}", "yes");
INSERT INTO `wp_options` VALUES("3", "siteurl", "http://blogsforsales.com/cat", "yes");
INSERT INTO `wp_options` VALUES("4", "blogname", "Cat Lovers", "yes");
INSERT INTO `wp_options` VALUES("5", "blogdescription", "", "yes");
INSERT INTO `wp_options` VALUES("6", "users_can_register", "0", "yes");
INSERT INTO `wp_options` VALUES("7", "admin_email", "anton@herbalcuresandremedies.info", "yes");
INSERT INTO `wp_options` VALUES("8", "start_of_week", "1", "yes");
INSERT INTO `wp_options` VALUES("9", "use_balanceTags", "0", "yes");
INSERT INTO `wp_options` VALUES("10", "use_smilies", "1", "yes");
INSERT INTO `wp_options` VALUES("11", "require_name_email", "1", "yes");
INSERT INTO `wp_options` VALUES("12", "comments_notify", "1", "yes");
INSERT INTO `wp_options` VALUES("13", "posts_per_rss", "10", "yes");
INSERT INTO `wp_options` VALUES("14", "rss_use_excerpt", "0", "yes");
INSERT INTO `wp_options` VALUES("15", "mailserver_url", "mail.example.com", "yes");
INSERT INTO `wp_options` VALUES("16", "mailserver_login", "login@example.com", "yes");
INSERT INTO `wp_options` VALUES("17", "mailserver_pass", "password", "yes");
INSERT INTO `wp_options` VALUES("18", "mailserver_port", "110", "yes");
INSERT INTO `wp_options` VALUES("19", "default_category", "1", "yes");
INSERT INTO `wp_options` VALUES("20", "default_comment_status", "open", "yes");
INSERT INTO `wp_options` VALUES("21", "default_ping_status", "open", "yes");
INSERT INTO `wp_options` VALUES("22", "default_pingback_flag", "1", "yes");
INSERT INTO `wp_options` VALUES("24", "posts_per_page", "10", "yes");
INSERT INTO `wp_options` VALUES("25", "date_format", "F j, Y", "yes");
INSERT INTO `wp_options` VALUES("26", "time_format", "g:i a", "yes");
INSERT INTO `wp_options` VALUES("27", "links_updated_date_format", "F j, Y g:i a", "yes");
INSERT INTO `wp_options` VALUES("28", "links_recently_updated_prepend", "<em>", "yes");
INSERT INTO `wp_options` VALUES("29", "links_recently_updated_append", "</em>", "yes");
INSERT INTO `wp_options` VALUES("30", "links_recently_updated_time", "120", "yes");
INSERT INTO `wp_options` VALUES("31", "comment_moderation", "0", "yes");
INSERT INTO `wp_options` VALUES("32", "moderation_notify", "1", "yes");
INSERT INTO `wp_options` VALUES("33", "permalink_structure", "", "yes");
INSERT INTO `wp_options` VALUES("34", "gzipcompression", "0", "yes");
INSERT INTO `wp_options` VALUES("35", "hack_file", "0", "yes");
INSERT INTO `wp_options` VALUES("36", "blog_charset", "UTF-8", "yes");
INSERT INTO `wp_options` VALUES("37", "moderation_keys", "", "no");
INSERT INTO `wp_options` VALUES("38", "active_plugins", "a:2:{i:0;s:25:\"duplicator/duplicator.php\";i:1;s:35:\"wp-image-finder/wp-image-finder.php\";}", "yes");
INSERT INTO `wp_options` VALUES("39", "home", "http://blogsforsales.com/cat", "yes");
INSERT INTO `wp_options` VALUES("40", "category_base", "", "yes");
INSERT INTO `wp_options` VALUES("41", "ping_sites", "http://rpc.pingomatic.com/", "yes");
INSERT INTO `wp_options` VALUES("42", "advanced_edit", "0", "yes");
INSERT INTO `wp_options` VALUES("43", "comment_max_links", "2", "yes");
INSERT INTO `wp_options` VALUES("44", "gmt_offset", "0", "yes");
INSERT INTO `wp_options` VALUES("45", "default_email_category", "1", "yes");
INSERT INTO `wp_options` VALUES("46", "recently_edited", "a:5:{i:0;s:88:\"/home/anton241/public_html/blogsforsales.com/cat/wp-content/themes/pet-world/sidebar.php\";i:1;s:85:\"/home/anton241/public_html/blogsforsales.com/cat/wp-content/themes/pet-world/page.php\";i:2;s:86:\"/home/anton241/public_html/blogsforsales.com/cat/wp-content/themes/pet-world/index.php\";i:3;s:87:\"/home/anton241/public_html/blogsforsales.com/cat/wp-content/themes/pet-world/header.php\";i:4;s:86:\"/home/anton241/public_html/blogsforsales.com/cat/wp-content/themes/pet-world/style.css\";}", "no");
INSERT INTO `wp_options` VALUES("47", "template", "pet-world", "yes");
INSERT INTO `wp_options` VALUES("48", "stylesheet", "pet-world", "yes");
INSERT INTO `wp_options` VALUES("49", "comment_whitelist", "1", "yes");
INSERT INTO `wp_options` VALUES("50", "blacklist_keys", "", "no");
INSERT INTO `wp_options` VALUES("51", "comment_registration", "0", "yes");
INSERT INTO `wp_options` VALUES("53", "html_type", "text/html", "yes");
INSERT INTO `wp_options` VALUES("54", "use_trackback", "0", "yes");
INSERT INTO `wp_options` VALUES("55", "default_role", "subscriber", "yes");
INSERT INTO `wp_options` VALUES("56", "db_version", "24448", "yes");
INSERT INTO `wp_options` VALUES("57", "uploads_use_yearmonth_folders", "1", "yes");
INSERT INTO `wp_options` VALUES("58", "upload_path", "", "yes");
INSERT INTO `wp_options` VALUES("59", "blog_public", "1", "yes");
INSERT INTO `wp_options` VALUES("60", "default_link_category", "2", "yes");
INSERT INTO `wp_options` VALUES("61", "show_on_front", "posts", "yes");
INSERT INTO `wp_options` VALUES("62", "tag_base", "", "yes");
INSERT INTO `wp_options` VALUES("63", "show_avatars", "1", "yes");
INSERT INTO `wp_options` VALUES("64", "avatar_rating", "G", "yes");
INSERT INTO `wp_options` VALUES("65", "upload_url_path", "", "yes");
INSERT INTO `wp_options` VALUES("66", "thumbnail_size_w", "150", "yes");
INSERT INTO `wp_options` VALUES("67", "thumbnail_size_h", "150", "yes");
INSERT INTO `wp_options` VALUES("68", "thumbnail_crop", "1", "yes");
INSERT INTO `wp_options` VALUES("69", "medium_size_w", "300", "yes");
INSERT INTO `wp_options` VALUES("70", "medium_size_h", "300", "yes");
INSERT INTO `wp_options` VALUES("71", "avatar_default", "mystery", "yes");
INSERT INTO `wp_options` VALUES("74", "large_size_w", "1024", "yes");
INSERT INTO `wp_options` VALUES("75", "large_size_h", "1024", "yes");
INSERT INTO `wp_options` VALUES("76", "image_default_link_type", "file", "yes");
INSERT INTO `wp_options` VALUES("77", "image_default_size", "", "yes");
INSERT INTO `wp_options` VALUES("78", "image_default_align", "", "yes");
INSERT INTO `wp_options` VALUES("79", "close_comments_for_old_posts", "0", "yes");
INSERT INTO `wp_options` VALUES("80", "close_comments_days_old", "14", "yes");
INSERT INTO `wp_options` VALUES("81", "thread_comments", "1", "yes");
INSERT INTO `wp_options` VALUES("82", "thread_comments_depth", "5", "yes");
INSERT INTO `wp_options` VALUES("83", "page_comments", "0", "yes");
INSERT INTO `wp_options` VALUES("84", "comments_per_page", "50", "yes");
INSERT INTO `wp_options` VALUES("85", "default_comments_page", "newest", "yes");
INSERT INTO `wp_options` VALUES("86", "comment_order", "asc", "yes");
INSERT INTO `wp_options` VALUES("87", "sticky_posts", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("88", "widget_categories", "a:2:{i:2;a:4:{s:5:\"title\";s:0:\"\";s:5:\"count\";i:0;s:12:\"hierarchical\";i:0;s:8:\"dropdown\";i:0;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("89", "widget_text", "a:3:{i:2;a:3:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:196:\"<center><a href=\"http://e7ca76tkvee2fx5d2-d-fy7k7l.hop.clickbank.net/\"><img src=\"http://blogsforsales.com/cat/wp-content/uploads/2013/09/NMBC180x260.jpg\" alt=\"alt text\" style=\"border:none;\" /></a>\";s:6:\"filter\";b:0;}i:3;a:3:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:508:\"<center><SCRIPT charset=\"utf-8\" type=\"text/javascript\" src=\"http://ws-na.amazon-adsystem.com/widgets/q?rt=tf_cw&ServiceVersion=20070822&MarketPlace=US&ID=V20070822%2FUS%2Ffreetos-20%2F8010%2Fef9f5d4f-3a46-4ee8-bd37-19a92504bfe9&Operation=GetScriptTemplate\"> </SCRIPT> <NOSCRIPT><A HREF=\"http://ws-na.amazon-adsystem.com/widgets/q?rt=tf_cw&ServiceVersion=20070822&MarketPlace=US&ID=V20070822%2FUS%2Ffreetos-20%2F8010%2Fef9f5d4f-3a46-4ee8-bd37-19a92504bfe9&Operation=NoScript\">Amazon.com Widgets</A></NOSCRIPT>\";s:6:\"filter\";b:0;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("90", "widget_rss", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("91", "timezone_string", "", "yes");
INSERT INTO `wp_options` VALUES("93", "embed_size_w", "", "yes");
INSERT INTO `wp_options` VALUES("94", "embed_size_h", "600", "yes");
INSERT INTO `wp_options` VALUES("95", "page_for_posts", "0", "yes");
INSERT INTO `wp_options` VALUES("96", "page_on_front", "0", "yes");
INSERT INTO `wp_options` VALUES("97", "default_post_format", "0", "yes");
INSERT INTO `wp_options` VALUES("98", "initial_db_version", "19470", "yes");
INSERT INTO `wp_options` VALUES("99", "wp_user_roles", "a:5:{s:13:\"administrator\";a:2:{s:4:\"name\";s:13:\"Administrator\";s:12:\"capabilities\";a:62:{s:13:\"switch_themes\";b:1;s:11:\"edit_themes\";b:1;s:16:\"activate_plugins\";b:1;s:12:\"edit_plugins\";b:1;s:10:\"edit_users\";b:1;s:10:\"edit_files\";b:1;s:14:\"manage_options\";b:1;s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:6:\"import\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:8:\"level_10\";b:1;s:7:\"level_9\";b:1;s:7:\"level_8\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:12:\"delete_users\";b:1;s:12:\"create_users\";b:1;s:17:\"unfiltered_upload\";b:1;s:14:\"edit_dashboard\";b:1;s:14:\"update_plugins\";b:1;s:14:\"delete_plugins\";b:1;s:15:\"install_plugins\";b:1;s:13:\"update_themes\";b:1;s:14:\"install_themes\";b:1;s:11:\"update_core\";b:1;s:10:\"list_users\";b:1;s:12:\"remove_users\";b:1;s:9:\"add_users\";b:1;s:13:\"promote_users\";b:1;s:18:\"edit_theme_options\";b:1;s:13:\"delete_themes\";b:1;s:6:\"export\";b:1;}}s:6:\"editor\";a:2:{s:4:\"name\";s:6:\"Editor\";s:12:\"capabilities\";a:34:{s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;}}s:6:\"author\";a:2:{s:4:\"name\";s:6:\"Author\";s:12:\"capabilities\";a:10:{s:12:\"upload_files\";b:1;s:10:\"edit_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;s:22:\"delete_published_posts\";b:1;}}s:11:\"contributor\";a:2:{s:4:\"name\";s:11:\"Contributor\";s:12:\"capabilities\";a:5:{s:10:\"edit_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;}}s:10:\"subscriber\";a:2:{s:4:\"name\";s:10:\"Subscriber\";s:12:\"capabilities\";a:2:{s:4:\"read\";b:1;s:7:\"level_0\";b:1;}}}", "yes");
INSERT INTO `wp_options` VALUES("100", "widget_search", "a:2:{i:2;a:1:{s:5:\"title\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("101", "widget_recent-posts", "a:2:{i:2;a:2:{s:5:\"title\";s:0:\"\";s:6:\"number\";i:5;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("102", "widget_recent-comments", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("325", "nav_menu_options", "a:2:{i:0;b:0;s:8:\"auto_add\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("103", "widget_archives", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("104", "widget_meta", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("105", "sidebars_widgets", "a:3:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:5:{i:0;s:8:\"search-2\";i:1;s:6:\"text-2\";i:2;s:14:\"recent-posts-2\";i:3;s:12:\"categories-2\";i:4;s:6:\"text-3\";}s:13:\"array_version\";i:3;}", "yes");
INSERT INTO `wp_options` VALUES("114", "current_theme", "Pet World", "yes");
INSERT INTO `wp_options` VALUES("153", "cron", "a:5:{i:1378576747;a:3:{s:16:\"wp_version_check\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:17:\"wp_update_plugins\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:16:\"wp_update_themes\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1378576764;a:1:{s:19:\"wp_scheduled_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1378583391;a:1:{s:26:\"upgrader_scheduled_cleanup\";a:1:{s:32:\"b76accc01229b487518cb150a88235da\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:34;}}}}i:1378585770;a:1:{s:30:\"wp_scheduled_auto_draft_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}s:7:\"version\";i:2;}", "yes");
INSERT INTO `wp_options` VALUES("201", "uninstall_plugins", "a:1:{s:25:\"duplicator/duplicator.php\";s:20:\"duplicator_uninstall\";}", "no");
INSERT INTO `wp_options` VALUES("202", "link_manager_enabled", "1", "yes");
INSERT INTO `wp_options` VALUES("364", "_site_transient_timeout_wporg_theme_feature_list", "1378587054", "yes");
INSERT INTO `wp_options` VALUES("365", "_site_transient_wporg_theme_feature_list", "a:5:{s:6:\"Colors\";a:15:{i:0;s:5:\"black\";i:1;s:4:\"blue\";i:2;s:5:\"brown\";i:3;s:4:\"gray\";i:4;s:5:\"green\";i:5;s:6:\"orange\";i:6;s:4:\"pink\";i:7;s:6:\"purple\";i:8;s:3:\"red\";i:9;s:6:\"silver\";i:10;s:3:\"tan\";i:11;s:5:\"white\";i:12;s:6:\"yellow\";i:13;s:4:\"dark\";i:14;s:5:\"light\";}s:7:\"Columns\";a:6:{i:0;s:10:\"one-column\";i:1;s:11:\"two-columns\";i:2;s:13:\"three-columns\";i:3;s:12:\"four-columns\";i:4;s:12:\"left-sidebar\";i:5;s:13:\"right-sidebar\";}s:5:\"Width\";a:2:{i:0;s:11:\"fixed-width\";i:1;s:14:\"flexible-width\";}s:8:\"Features\";a:19:{i:0;s:8:\"blavatar\";i:1;s:10:\"buddypress\";i:2;s:17:\"custom-background\";i:3;s:13:\"custom-colors\";i:4;s:13:\"custom-header\";i:5;s:11:\"custom-menu\";i:6;s:12:\"editor-style\";i:7;s:21:\"featured-image-header\";i:8;s:15:\"featured-images\";i:9;s:15:\"flexible-header\";i:10;s:20:\"front-page-post-form\";i:11;s:19:\"full-width-template\";i:12;s:12:\"microformats\";i:13;s:12:\"post-formats\";i:14;s:20:\"rtl-language-support\";i:15;s:11:\"sticky-post\";i:16;s:13:\"theme-options\";i:17;s:17:\"threaded-comments\";i:18;s:17:\"translation-ready\";}s:7:\"Subject\";a:3:{i:0;s:7:\"holiday\";i:1;s:13:\"photoblogging\";i:2;s:8:\"seasonal\";}}", "yes");
INSERT INTO `wp_options` VALUES("160", "_site_transient_timeout_browser_26ca8ea8e60136335e5e56fd8bbfc4d6", "1378749564", "yes");
INSERT INTO `wp_options` VALUES("161", "_site_transient_browser_26ca8ea8e60136335e5e56fd8bbfc4d6", "a:9:{s:8:\"platform\";s:7:\"Windows\";s:4:\"name\";s:17:\"Internet Explorer\";s:7:\"version\";s:4:\"10.0\";s:10:\"update_url\";s:51:\"http://www.microsoft.com/windows/internet-explorer/\";s:7:\"img_src\";s:45:\"http://s.wordpress.org/images/browsers/ie.png\";s:11:\"img_src_ssl\";s:44:\"https://wordpress.org/images/browsers/ie.png\";s:15:\"current_version\";s:1:\"9\";s:7:\"upgrade\";b:0;s:8:\"insecure\";b:0;}", "yes");
INSERT INTO `wp_options` VALUES("162", "dashboard_widget_options", "a:4:{s:25:\"dashboard_recent_comments\";a:1:{s:5:\"items\";i:5;}s:24:\"dashboard_incoming_links\";a:5:{s:4:\"home\";s:28:\"http://blogsforsales.com/cat\";s:4:\"link\";s:104:\"http://blogsearch.google.com/blogsearch?scoring=d&partner=wordpress&q=link:http://blogsforsales.com/cat/\";s:3:\"url\";s:137:\"http://blogsearch.google.com/blogsearch_feeds?scoring=d&ie=utf-8&num=10&output=rss&partner=wordpress&q=link:http://blogsforsales.com/cat/\";s:5:\"items\";i:10;s:9:\"show_date\";b:0;}s:17:\"dashboard_primary\";a:7:{s:4:\"link\";s:26:\"http://wordpress.org/news/\";s:3:\"url\";s:31:\"http://wordpress.org/news/feed/\";s:5:\"title\";s:14:\"WordPress Blog\";s:5:\"items\";i:2;s:12:\"show_summary\";i:1;s:11:\"show_author\";i:0;s:9:\"show_date\";i:1;}s:19:\"dashboard_secondary\";a:7:{s:4:\"link\";s:28:\"http://planet.wordpress.org/\";s:3:\"url\";s:33:\"http://planet.wordpress.org/feed/\";s:5:\"title\";s:20:\"Other WordPress News\";s:5:\"items\";i:5;s:12:\"show_summary\";i:0;s:11:\"show_author\";i:0;s:9:\"show_date\";i:0;}}", "yes");
INSERT INTO `wp_options` VALUES("350", "_transient_timeout_feed_b9388c83948825c1edaef0d856b7b109", "1378619156", "no");
INSERT INTO `wp_options` VALUES("351", "_transient_feed_b9388c83948825c1edaef0d856b7b109", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n	\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:72:\"\n		\n		\n		\n		\n		\n		\n				\n\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"WordPress Plugins » View: Most Popular\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"http://wordpress.org/plugins/browse/popular/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"WordPress Plugins » View: Most Popular\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 07 Sep 2013 17:15:41 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"http://bbpress.org/?v=1.1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:15:{i:0;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:24:\"Jetpack by WordPress.com\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"http://wordpress.org/plugins/jetpack/#post-23862\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 20 Jan 2011 02:21:38 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"23862@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:104:\"Supercharge your WordPress site with powerful features previously only available to WordPress.com users.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:24:\"Michael Adams (mdawaffe)\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"Akismet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"http://wordpress.org/plugins/akismet/#post-15\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 09 Mar 2007 22:11:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"15@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:98:\"Akismet checks your comments against the Akismet web service to see if they look like spam or not.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"All in One SEO Pack\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"http://wordpress.org/plugins/all-in-one-seo-pack/#post-753\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 30 Mar 2007 20:08:18 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"753@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:86:\"WordPress SEO plugin to automatically optimize your Wordpress blog for Search Engines.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"uberdose\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Contact Form 7\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"http://wordpress.org/plugins/contact-form-7/#post-2141\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 02 Aug 2007 12:45:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"2141@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"Just another contact form plugin. Simple but flexible.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Takayuki Miyoshi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"WordPress SEO by Yoast\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"http://wordpress.org/plugins/wordpress-seo/#post-8321\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 01 Jan 2009 20:34:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"8321@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:131:\"Improve your WordPress SEO: Write better content and have a fully optimized WordPress site using the WordPress SEO plugin by Yoast.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Joost de Valk\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"NextGEN Gallery\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/plugins/nextgen-gallery/#post-1169\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 23 Apr 2007 20:08:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"1169@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:122:\"The most popular WordPress gallery plugin and one of the most popular plugins of all time with over 7.5 million downloads.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Alex Rabe\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"WordPress Importer\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/plugins/wordpress-importer/#post-18101\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 20 May 2010 17:42:45 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"18101@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:101:\"Import posts, pages, comments, custom fields, categories, tags and more from a WordPress export file.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Brian Colinger\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"WooCommerce - excelling eCommerce\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"http://wordpress.org/plugins/woocommerce/#post-29860\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 05 Sep 2011 08:13:36 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"29860@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:97:\"WooCommerce is a powerful, extendable eCommerce plugin that helps you sell anything. Beautifully.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"WooThemes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Better WP Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/plugins/better-wp-security/#post-21738\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 22 Oct 2010 22:06:05 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"21738@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:107:\"The easiest, most effective way to secure WordPress. Improve the security of any WordPress site in seconds.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"ChrisWiegman\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"W3 Total Cache\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/plugins/w3-total-cache/#post-12073\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 29 Jul 2009 18:46:31 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"12073@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:132:\"Easy Web Performance Optimization (WPO) using caching: browser, page, object, database, minify and content delivery network support.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Frederick Townes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"Captcha\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"http://wordpress.org/plugins/captcha/#post-26129\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 27 Apr 2011 05:53:50 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"26129@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"This plugin allows you to implement super security captcha form into web forms.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"bestwebsoft\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Wordfence Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wordpress.org/plugins/wordfence/#post-29832\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 04 Sep 2011 03:13:51 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"29832@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:148:\"Wordfence Security is a free enterprise class security plugin that includes a firewall, virus scanning, real-time traffic with geolocation and more.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"mmaunder\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:24:\"Fast Secure Contact Form\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"http://wordpress.org/plugins/si-contact-form/#post-12636\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 27 Aug 2009 01:20:04 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"12636@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:131:\"A super customizable contact form that lets your visitors send you email. Blocks all automated spammers. No templates to mess with.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Mike Challis\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"Google XML Sitemaps\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"http://wordpress.org/plugins/google-sitemap-generator/#post-132\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 09 Mar 2007 22:31:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"132@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:105:\"This plugin will generate a special XML sitemap which will help search engines to better index your blog.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"Arnee\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"Really Simple CAPTCHA\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:61:\"http://wordpress.org/plugins/really-simple-captcha/#post-9542\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 09 Mar 2009 02:17:35 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"9542@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:138:\"Really Simple CAPTCHA is a CAPTCHA module intended to be called from other plugins. It is originally created for my Contact Form 7 plugin.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Takayuki Miyoshi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:45:\"http://wordpress.org/plugins/rss/view/popular\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:10:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Sat, 07 Sep 2013 17:45:56 GMT\";s:12:\"content-type\";s:23:\"text/xml; charset=UTF-8\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:7:\"expires\";s:29:\"Sat, 07 Sep 2013 17:50:41 GMT\";s:13:\"cache-control\";s:0:\"\";s:6:\"pragma\";s:0:\"\";s:13:\"last-modified\";s:31:\"Sat, 07 Sep 2013 17:15:41 +0000\";s:4:\"x-nc\";s:11:\"HIT lax 249\";}s:5:\"build\";s:14:\"20130902175941\";}", "no");
INSERT INTO `wp_options` VALUES("352", "_transient_timeout_feed_mod_b9388c83948825c1edaef0d856b7b109", "1378619156", "no");
INSERT INTO `wp_options` VALUES("333", "_transient_feed_f7bd8ef9f0b32599824d5a7fa4084588", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:4:\"\n  \n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:33:\"\n    \n    \n    \n    \n    \n    \n  \";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:3:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"link:http://blogsforsales.com/cat/ - Google Blog Search\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:92:\"http://www.google.com/search?ie=utf-8&q=link:http://blogsforsales.com/cat/&tbm=blg&tbs=sbd:1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:86:\"Your search - <b>link:http://blogsforsales.com/cat/</b> - did not match any documents.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://a9.com/-/spec/opensearch/1.1/\";a:3:{s:12:\"totalResults\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:10:\"startIndex\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:12:\"itemsPerPage\";a:1:{i:0;a:5:{s:4:\"data\";s:2:\"10\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:10:{s:12:\"content-type\";s:28:\"text/xml; charset=ISO-8859-1\";s:4:\"date\";s:29:\"Sat, 07 Sep 2013 17:45:55 GMT\";s:7:\"expires\";s:2:\"-1\";s:13:\"cache-control\";s:18:\"private, max-age=0\";s:10:\"set-cookie\";a:2:{i:0;s:143:\"PREF=ID=acdda68e3a5803b9:FF=0:TM=1378575955:LM=1378575955:S=7NKVl6tagdtdSvSn; expires=Mon, 07-Sep-2015 17:45:55 GMT; path=/; domain=.google.com\";i:1;s:212:\"NID=67=lt8s0LKrzBlFLiBBBYUZ2hZ4PUocj8_UcAuEeSIZ3S4zBPOz0yzwR-dlMI6BTY4ijF2eIrpDipoFPBvLJSyhWPbUVv9irAibF_G5crMgk3vmL5IvY915hVq6anLrAttQ; expires=Sun, 09-Mar-2014 17:45:55 GMT; path=/; domain=.google.com; HttpOnly\";}s:3:\"p3p\";s:122:\"CP=\"This is not a P3P policy! See http://www.google.com/support/accounts/bin/answer.py?hl=en&answer=151657 for more info.\"\";s:6:\"server\";s:3:\"gws\";s:16:\"x-xss-protection\";s:13:\"1; mode=block\";s:15:\"x-frame-options\";s:10:\"SAMEORIGIN\";s:18:\"alternate-protocol\";s:7:\"80:quic\";}s:5:\"build\";s:14:\"20130902175941\";}", "no");
INSERT INTO `wp_options` VALUES("340", "_transient_timeout_feed_mod_ac0b00fe65abe10e0c5b588f3ed8c7ca", "1378619155", "no");
INSERT INTO `wp_options` VALUES("341", "_transient_feed_mod_ac0b00fe65abe10e0c5b588f3ed8c7ca", "1378575955", "no");
INSERT INTO `wp_options` VALUES("342", "_transient_timeout_dash_4077549d03da2e451c8b5f002294ff51", "1378619155", "no");
INSERT INTO `wp_options` VALUES("343", "_transient_dash_4077549d03da2e451c8b5f002294ff51", "<div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'http://wordpress.org/news/2013/08/oscar/\' title=\'The latest and greatest WordPress, version 3.6, is now live to the world and includes a beautiful new blog-centric theme, bullet-proof autosave and post locking, a revamped revision browser, native support for audio and video embeds, and improved integrations with Spotify, Rdio, and SoundCloud. Here’s a video that shows off some of the features using […]\'>WordPress 3.6 “Oscar”</a> <span class=\"rss-date\">August 1, 2013</span><div class=\'rssSummary\'>The latest and greatest WordPress, version 3.6, is now live to the world and includes a beautiful new blog-centric theme, bullet-proof autosave and post locking, a revamped revision browser, native support for audio and video embeds, and improved integrations with Spotify, Rdio, and SoundCloud. Here’s a video that shows off some of the features using […]</div></li><li><a class=\'rsswidget\' href=\'http://wordpress.org/news/2013/07/wordpress-3-6-release-candidate-2/\' title=\'The second release candidate for WordPress 3.6 is now available for download and testing. We’re down to only a few remaining issues, and the final release should be available in a matter of days. In RC2, we’ve tightened up some aspects of revisions, autosave, and the media player, and fixed some bugs that were spotted […]\'>WordPress 3.6 Release Candidate 2</a> <span class=\"rss-date\">July 24, 2013</span><div class=\'rssSummary\'>The second release candidate for WordPress 3.6 is now available for download and testing. We’re down to only a few remaining issues, and the final release should be available in a matter of days. In RC2, we’ve tightened up some aspects of revisions, autosave, and the media player, and fixed some bugs that were spotted […]</div></li></ul></div>", "no");
INSERT INTO `wp_options` VALUES("338", "_transient_timeout_feed_ac0b00fe65abe10e0c5b588f3ed8c7ca", "1378619155", "no");
INSERT INTO `wp_options` VALUES("339", "_transient_feed_ac0b00fe65abe10e0c5b588f3ed8c7ca", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:50:\"\n	\n	\n	\n	\n	\n	\n	\n	\n	\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"WordPress News\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"http://wordpress.org/news\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"WordPress News\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:13:\"lastBuildDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 01 Aug 2013 21:49:34 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"http://wordpress.org/?v=3.7-alpha-25157\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:10:{i:0;a:6:{s:4:\"data\";s:42:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"WordPress 3.6 “Oscar”\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"http://wordpress.org/news/2013/08/oscar/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"http://wordpress.org/news/2013/08/oscar/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 01 Aug 2013 21:43:22 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2661\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:368:\"The latest and greatest WordPress, version 3.6, is now live to the world and includes a beautiful new blog-centric theme, bullet-proof autosave and post locking, a revamped revision browser, native support for audio and video embeds, and improved integrations with Spotify, Rdio, and SoundCloud. Here&#8217;s a video that shows off some of the features using [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:18626:\"<p>The latest and greatest WordPress, version 3.6, is now <a href=\"http://wordpress.org/download/\">live to the world</a> and includes a beautiful new blog-centric theme, bullet-proof autosave and post locking, a revamped revision browser, native support for audio and video embeds, and improved integrations with Spotify, Rdio, and SoundCloud. Here&#8217;s a video that shows off some of the features using our cast of professional actors:</p>\n<div id=\"v-UmhwbWJH-1\" class=\"video-player\"><embed id=\"v-UmhwbWJH-1-video\" src=\"http://s0.videopress.com/player.swf?v=1.03&amp;guid=UmhwbWJH&amp;isDynamicSeeking=true\" type=\"application/x-shockwave-flash\" width=\"692\" height=\"388\" title=\"Introducing WordPress 3.6 &quot;Oscar&quot;\" wmode=\"direct\" seamlesstabbing=\"true\" allowfullscreen=\"true\" allowscriptaccess=\"always\" overstretch=\"true\"></embed></div>\n<p>We&#8217;re calling this release &#8220;Oscar&#8221; in honor of the great jazz pianist <a href=\"http://en.wikipedia.org/wiki/Oscar_Peterson\">Oscar Peterson</a>. Here&#8217;s a bit more about some of the new features, which you can also find on the about page in your dashboard after you upgrade.</p>\n<h3>User Features</h3>\n<p><img class=\"alignright\" alt=\"\" src=\"https://wordpress.org/images/core/3.6/twentythirteen.png\" width=\"300\" /></p>\n<ul>\n<li>The <strong>new Twenty Thirteen theme</strong> inspired by modern art puts focus on your content with a colorful, single-column design made for media-rich blogging.</li>\n<li><strong>Revamped Revisions</strong> save every change and the new interface allows you to scroll easily through changes to see line-by-line who changed what and when.</li>\n<li><strong>Post Locking</strong> and <strong>Augmented Autosave</strong> will especially be a boon to sites where more than a single author is working on a post. Each author now has their own autosave stream, which stores things locally as well as on the server (so much harder to lose something) and there&#8217;s an interface for taking over editing of a post, as demonstrated beautifully by our bearded buddies in the video above.</li>\n<li><strong>Built-in HTML5 media player</strong> for native audio and video embeds with no reliance on external services.</li>\n<li>The <strong>Menu Editor</strong> is now much easier to understand and use.</li>\n</ul>\n<h3>Developer features</h3>\n<ul>\n<li>A new audio/video API gives you access to metadata like ID3 tags.</li>\n<li>You can now choose HTML5 markup for things like comment and search forms, and comment lists.</li>\n<li>Better filters for how revisions work, so you can store a different amount of history for different post types.</li>\n<li>Tons more <a href=\"http://codex.wordpress.org/Version_3.6\">listed on the Codex</a>, and of course you can always <a href=\"http://core.trac.wordpress.org/query?status=closed&amp;group=resolution&amp;milestone=3.6\">browse the over 700 closed tickets</a>.</li>\n</ul>\n<h3>The Band</h3>\n<p>This release was led by <a href=\"http://markjaquith.com/\">Mark Jaquith</a> and <a href=\"http://geekreprieve.com/\">Aaron Campbell</a>, and included contributions from the following fine folks. Pull up some Oscar Peterson on your music service of choice, or vinyl if you have it, and check out some of their profiles:</p>\n<p><a href=\"http://profiles.wordpress.org/technosailor\">Aaron Brazell</a>, <a href=\"http://profiles.wordpress.org/aaroncampbell\">Aaron D. Campbell</a>, <a href=\"http://profiles.wordpress.org/aaronholbrook\">Aaron Holbrook</a>, <a href=\"http://profiles.wordpress.org/jorbin\">Aaron Jorbin</a>, <a href=\"http://profiles.wordpress.org/kawauso\">Adam Harley</a>, <a href=\"http://profiles.wordpress.org/adamsilverstein\">adamsilverstein</a>, <a href=\"http://profiles.wordpress.org/akted\">AK Ted</a>, <a href=\"http://profiles.wordpress.org/xknown\">Alex Concha</a>, <a href=\"http://profiles.wordpress.org/alexkingorg\">Alex King</a>, <a href=\"http://profiles.wordpress.org/viper007bond\">Alex Mills (Viper007Bond)</a>, <a href=\"http://profiles.wordpress.org/momo360modena\">Amaury Balmer</a>, <a href=\"http://profiles.wordpress.org/sabreuse\">Amy Hendrix (sabreuse)</a>, <a href=\"http://profiles.wordpress.org/anatolbroder\">Anatol Broder</a>, <a href=\"http://profiles.wordpress.org/nacin\">Andrew Nacin</a>, <a href=\"http://profiles.wordpress.org/azaozz\">Andrew Ozz</a>, <a href=\"http://profiles.wordpress.org/andrewryno\">Andrew Ryno</a>, <a href=\"http://profiles.wordpress.org/andy\">Andy Skelton</a>, <a href=\"http://profiles.wordpress.org/gorgoglionemeister\">Antonio</a>, <a href=\"http://profiles.wordpress.org/apimlott\">apimlott</a>, <a href=\"http://profiles.wordpress.org/awellis13\">awellis13</a>, <a href=\"http://profiles.wordpress.org/barry\">Barry</a>, <a href=\"http://profiles.wordpress.org/beaulebens\">Beau Lebens</a>, <a href=\"http://profiles.wordpress.org/belloswan\">BelloSwan</a>, <a href=\"http://profiles.wordpress.org/bilalcoder\">bilalcoder</a>, <a href=\"http://profiles.wordpress.org/bananastalktome\">Billy (bananastalktome)</a>, <a href=\"http://profiles.wordpress.org/bobbingwide\">bobbingwide</a>, <a href=\"http://profiles.wordpress.org/bobbravo2\">Bob Gregor</a>, <a href=\"http://profiles.wordpress.org/bradparbs\">bradparbs</a>, <a href=\"http://profiles.wordpress.org/bradyvercher\">Brady Vercher</a>, <a href=\"http://profiles.wordpress.org/kraftbj\">Brandon Kraft</a>, <a href=\"http://profiles.wordpress.org/brianlayman\">Brian Layman</a>, <a href=\"http://profiles.wordpress.org/beezeee\">Brian Zeligson</a>, <a href=\"http://profiles.wordpress.org/bpetty\">Bryan Petty</a>, <a href=\"http://profiles.wordpress.org/chmac\">Callum Macdonald</a>, <a href=\"http://profiles.wordpress.org/carldanley\">Carl Danley</a>, <a href=\"http://profiles.wordpress.org/caspie\">Caspie</a>, <a href=\"http://profiles.wordpress.org/charlestonsw\">Charleston Software Associates</a>, <a href=\"http://profiles.wordpress.org/cheeserolls\">cheeserolls</a>, <a href=\"http://profiles.wordpress.org/chipbennett\">Chip Bennett</a>, <a href=\"http://profiles.wordpress.org/c3mdigital\">Chris Olbekson</a>, <a href=\"http://profiles.wordpress.org/cochran\">Christopher Cochran</a>, <a href=\"http://profiles.wordpress.org/cfinke\">Christopher Finke</a>, <a href=\"http://profiles.wordpress.org/chriswallace\">Chris Wallace</a>, <a href=\"http://profiles.wordpress.org/corvannoorloos\">Cor van Noorloos</a>, <a href=\"http://profiles.wordpress.org/crazycoders\">crazycoders</a>, <a href=\"http://profiles.wordpress.org/danielbachhuber\">Daniel Bachhuber</a>, <a href=\"http://profiles.wordpress.org/mzaweb\">Daniel Dvorkin (MZAWeb)</a>, <a href=\"http://profiles.wordpress.org/redsweater\">Daniel Jalkut (Red Sweater)</a>, <a href=\"http://profiles.wordpress.org/daniloercoli\">daniloercoli</a>, <a href=\"http://profiles.wordpress.org/dannydehaan\">Danny de Haan</a>, <a href=\"http://profiles.wordpress.org/csixty4\">Dave Ross</a>, <a href=\"http://profiles.wordpress.org/dfavor\">David Favor</a>, <a href=\"http://profiles.wordpress.org/jdtrower\">David Trower</a>, <a href=\"http://profiles.wordpress.org/davidwilliamson\">David Williamson</a>, <a href=\"http://profiles.wordpress.org/dd32\">Dion Hulse</a>, <a href=\"http://profiles.wordpress.org/dllh\">dllh</a>, <a href=\"http://profiles.wordpress.org/ocean90\">Dominik Schilling (ocean90)</a>, <a href=\"http://profiles.wordpress.org/dovyp\">dovyp</a>, <a href=\"http://profiles.wordpress.org/drewapicture\">Drew Jaynes (DrewAPicture)</a>, <a href=\"http://profiles.wordpress.org/dvarga\">dvarga</a>, <a href=\"http://profiles.wordpress.org/cais\">Edward Caissie</a>, <a href=\"http://profiles.wordpress.org/elfin\">elfin</a>, <a href=\"http://profiles.wordpress.org/empireoflight\">Empireoflight</a>, <a href=\"http://profiles.wordpress.org/ericlewis\">Eric Andrew Lewis</a>, <a href=\"http://profiles.wordpress.org/ethitter\">Erick Hitter</a>, <a href=\"http://profiles.wordpress.org/ericmann\">Eric Mann</a>, <a href=\"http://profiles.wordpress.org/evansolomon\">Evan Solomon</a>, <a href=\"http://profiles.wordpress.org/faishal\">faishal</a>, <a href=\"http://profiles.wordpress.org/feedmeastraycat\">feedmeastraycat</a>, <a href=\"http://profiles.wordpress.org/frank-klein\">Frank Klein</a>, <a href=\"http://profiles.wordpress.org/f-j-kaiser\">Franz Josef Kaiser</a>, <a href=\"http://profiles.wordpress.org/fstop\">FStop</a>, <a href=\"http://profiles.wordpress.org/mintindeed\">Gabriel Koen</a>, <a href=\"http://profiles.wordpress.org/garyc40\">Gary Cao</a>, <a href=\"http://profiles.wordpress.org/garyj\">Gary Jones</a>, <a href=\"http://profiles.wordpress.org/gcorne\">gcorne</a>, <a href=\"http://profiles.wordpress.org/geertdd\">GeertDD</a>, <a href=\"http://profiles.wordpress.org/soulseekah\">Gennady Kovshenin</a>, <a href=\"http://profiles.wordpress.org/georgestephanis\">George Stephanis</a>, <a href=\"http://profiles.wordpress.org/gish\">gish</a>, <a href=\"http://profiles.wordpress.org/tivnet\">Gregory Karpinsky</a>, <a href=\"http://profiles.wordpress.org/hakre\">hakre</a>, <a href=\"http://profiles.wordpress.org/hbanken\">hbanken</a>, <a href=\"http://profiles.wordpress.org/hebbet\">hebbet</a>, <a href=\"http://profiles.wordpress.org/helen\">Helen Hou-Sandi</a>, <a href=\"http://profiles.wordpress.org/helgatheviking\">helgatheviking</a>, <a href=\"http://profiles.wordpress.org/hirozed\">hirozed</a>, <a href=\"http://profiles.wordpress.org/hurtige\">hurtige</a>, <a href=\"http://profiles.wordpress.org/hypertextranch\">hypertextranch</a>, <a href=\"http://profiles.wordpress.org/iandunn\">Ian Dunn</a>, <a href=\"http://profiles.wordpress.org/ipstenu\">Ipstenu (Mika Epstein)</a>, <a href=\"http://profiles.wordpress.org/jakub\">jakub</a>, <a href=\"http://profiles.wordpress.org/h4ck3rm1k3\">James Michael DuPont</a>, <a href=\"http://profiles.wordpress.org/jbutkus\">jbutkus</a>, <a href=\"http://profiles.wordpress.org/jeremyfelt\">Jeremy Felt</a>, <a href=\"http://profiles.wordpress.org/jerrysarcastic\">Jerry Bates (JerrySarcastic)</a>, <a href=\"http://profiles.wordpress.org/jayjdk\">Jesper Johansen (Jayjdk)</a>, <a href=\"http://profiles.wordpress.org/joehoyle\">Joe Hoyle</a>, <a href=\"http://profiles.wordpress.org/joen\">Joen Asmussen</a>, <a href=\"http://profiles.wordpress.org/jkudish\">Joey Kudish</a>, <a href=\"http://profiles.wordpress.org/johnbillion\">John Blackbourn (johnbillion)</a>, <a href=\"http://profiles.wordpress.org/johnjamesjacoby\">John James Jacoby</a>, <a href=\"http://profiles.wordpress.org/jond3r\">Jonas Bolinder (jond3r)</a>, <a href=\"http://profiles.wordpress.org/desrosj\">Jonathan Desrosiers</a>, <a href=\"http://profiles.wordpress.org/jonbishop\">Jon Bishop</a>, <a href=\"http://profiles.wordpress.org/duck_\">Jon Cave</a>, <a href=\"http://profiles.wordpress.org/jcastaneda\">Jose Castaneda</a>, <a href=\"http://profiles.wordpress.org/josephscott\">Joseph Scott</a>, <a href=\"http://profiles.wordpress.org/jvisick77\">Josh Visick</a>, <a href=\"http://profiles.wordpress.org/jrbeilke\">jrbeilke</a>, <a href=\"http://profiles.wordpress.org/jrf\">jrf</a>, <a href=\"http://profiles.wordpress.org/devesine\">Justin de Vesine</a>, <a href=\"http://profiles.wordpress.org/justinsainton\">Justin Sainton</a>, <a href=\"http://profiles.wordpress.org/kadamwhite\">kadamwhite</a>, <a href=\"http://profiles.wordpress.org/trepmal\">Kailey (trepmal)</a>, <a href=\"http://profiles.wordpress.org/karmatosed\">karmatosed</a>, <a href=\"http://profiles.wordpress.org/ryelle\">Kelly Dwan</a>, <a href=\"http://profiles.wordpress.org/keoshi\">keoshi</a>, <a href=\"http://profiles.wordpress.org/kovshenin\">Konstantin Kovshenin</a>, <a href=\"http://profiles.wordpress.org/obenland\">Konstantin Obenland</a>, <a href=\"http://profiles.wordpress.org/ktdreyer\">ktdreyer</a>, <a href=\"http://profiles.wordpress.org/kurtpayne\">Kurt Payne</a>, <a href=\"http://profiles.wordpress.org/kwight\">kwight</a>, <a href=\"http://profiles.wordpress.org/lancewillett\">Lance Willett</a>, <a href=\"http://profiles.wordpress.org/leewillis77\">Lee Willis (leewillis77)</a>, <a href=\"http://profiles.wordpress.org/lessbloat\">lessbloat</a>, <a href=\"http://profiles.wordpress.org/settle\">Mantas Malcius</a>, <a href=\"http://profiles.wordpress.org/maor\">Maor Chasen</a>, <a href=\"http://profiles.wordpress.org/macbrink\">Marcel Brinkkemper</a>, <a href=\"http://profiles.wordpress.org/marcuspope\">MarcusPope</a>, <a href=\"http://profiles.wordpress.org/mark-k\">Mark-k</a>, <a href=\"http://profiles.wordpress.org/markjaquith\">Mark Jaquith</a>, <a href=\"http://profiles.wordpress.org/markmcwilliams\">Mark McWilliams</a>, <a href=\"http://profiles.wordpress.org/markoheijnen\">Marko Heijnen</a>, <a href=\"http://profiles.wordpress.org/mjbanks\">Matt Banks</a>, <a href=\"http://profiles.wordpress.org/mboynes\">Matthew Boynes</a>, <a href=\"http://profiles.wordpress.org/matthewruddy\">MatthewRuddy</a>, <a href=\"http://profiles.wordpress.org/mattwiebe\">Matt Wiebe</a>, <a href=\"http://profiles.wordpress.org/maxcutler\">Max Cutler</a>, <a href=\"http://profiles.wordpress.org/melchoyce\">Mel Choyce</a>, <a href=\"http://profiles.wordpress.org/mgibbs189\">mgibbs189</a>, <a href=\"http://profiles.wordpress.org/fanquake\">Michael</a>, <a href=\"http://profiles.wordpress.org/mdawaffe\">Michael Adams (mdawaffe)</a>, <a href=\"http://profiles.wordpress.org/tw2113\">Michael Beckwith</a>, <a href=\"http://profiles.wordpress.org/mfields\">Michael Fields</a>, <a href=\"http://profiles.wordpress.org/mikehansenme\">Mike Hansen</a>, <a href=\"http://profiles.wordpress.org/dh-shredder\">Mike Schroder</a>, <a href=\"http://profiles.wordpress.org/dimadin\">Milan Dinic</a>, <a href=\"http://profiles.wordpress.org/mitchoyoshitaka\">mitcho (Michael Yoshitaka Erlewine)</a>, <a href=\"http://profiles.wordpress.org/batmoo\">Mohammad Jangda</a>, <a href=\"http://profiles.wordpress.org/najamelan\">najamelan</a>, <a href=\"http://profiles.wordpress.org/Nao\">Naoko Takano</a>, <a href=\"http://profiles.wordpress.org/alex-ye\">Nashwan Doaqan</a>, <a href=\"http://profiles.wordpress.org/niallkennedy\">Niall Kennedy</a>, <a href=\"http://profiles.wordpress.org/nickdaugherty\">Nick Daugherty</a>, <a href=\"http://profiles.wordpress.org/celloexpressions\">Nick Halsey</a>, <a href=\"http://profiles.wordpress.org/ninnypants\">ninnypants</a>, <a href=\"http://profiles.wordpress.org/norcross\">norcross</a>, <a href=\"http://profiles.wordpress.org/paradiseporridge\">ParadisePorridge</a>, <a href=\"http://profiles.wordpress.org/pauldewouters\">Paul</a>, <a href=\"http://profiles.wordpress.org/pdclark\">Paul Clark</a>, <a href=\"http://profiles.wordpress.org/pavelevap\">pavelevap</a>, <a href=\"http://profiles.wordpress.org/petemall\">Pete Mall</a>, <a href=\"http://profiles.wordpress.org/westi\">Peter Westwood</a>, <a href=\"http://profiles.wordpress.org/phill_brown\">Phill Brown</a>, <a href=\"http://profiles.wordpress.org/mordauk\">Pippin Williamson</a>, <a href=\"http://profiles.wordpress.org/pollett\">Pollett</a>, <a href=\"http://profiles.wordpress.org/nprasath002\">Prasath Nadarajah</a>, <a href=\"http://profiles.wordpress.org/programmin\">programmin</a>, <a href=\"http://profiles.wordpress.org/rachelbaker\">rachelbaker</a>, <a href=\"http://profiles.wordpress.org/ramiy\">Rami Yushuvaev</a>, <a href=\"http://profiles.wordpress.org/redpixelstudios\">redpixelstudios</a>, <a href=\"http://profiles.wordpress.org/reidburke\">reidburke</a>, <a href=\"http://profiles.wordpress.org/retlehs\">retlehs</a>, <a href=\"http://profiles.wordpress.org/greuben\">Reuben Gunday</a>, <a href=\"http://profiles.wordpress.org/rlerdorf\">rlerdorf</a>, <a href=\"http://profiles.wordpress.org/rodrigosprimo\">Rodrigo Primo</a>, <a href=\"http://profiles.wordpress.org/roulandf\">roulandf</a>, <a href=\"http://profiles.wordpress.org/rovo89\">rovo89</a>, <a href=\"http://profiles.wordpress.org/ryanduff\">Ryan Duff</a>, <a href=\"http://profiles.wordpress.org/ryanhellyer\">Ryan Hellyer</a>, <a href=\"http://profiles.wordpress.org/rmccue\">Ryan McCue</a>, <a href=\"http://profiles.wordpress.org/zeo\">Safirul Alredha</a>, <a href=\"http://profiles.wordpress.org/saracannon\">sara cannon</a>, <a href=\"http://profiles.wordpress.org/scholesmafia\">scholesmafia</a>, <a href=\"http://profiles.wordpress.org/sc0ttkclark\">Scott Kingsley Clark</a>, <a href=\"http://profiles.wordpress.org/coffee2code\">Scott Reilly</a>, <a href=\"http://profiles.wordpress.org/wonderboymusic\">Scott Taylor</a>, <a href=\"http://profiles.wordpress.org/scribu\">scribu</a>, <a href=\"http://profiles.wordpress.org/tenpura\">Seisuke Kuraishi (tenpura)</a>, <a href=\"http://profiles.wordpress.org/sergej\">Sergej</a>, <a href=\"http://profiles.wordpress.org/sergeybiryukov\">Sergey Biryukov</a>, <a href=\"http://profiles.wordpress.org/sim\">Simon Hampel</a>, <a href=\"http://profiles.wordpress.org/simonwheatley\">Simon Wheatley</a>, <a href=\"http://profiles.wordpress.org/siobhan\">Siobhan</a>, <a href=\"http://profiles.wordpress.org/sirzooro\">sirzooro</a>, <a href=\"http://profiles.wordpress.org/slene\">slene</a>, <a href=\"http://profiles.wordpress.org/solarissmoke\">solarissmoke</a>, <a href=\"http://profiles.wordpress.org/srinig\">SriniG</a>, <a href=\"http://profiles.wordpress.org/stephenh1988\">Stephen Harris</a>, <a href=\"http://profiles.wordpress.org/storkontheroof\">storkontheroof</a>, <a href=\"http://profiles.wordpress.org/sunnyratilal\">Sunny Ratilal</a>, <a href=\"http://profiles.wordpress.org/sweetie089\">sweetie089</a>, <a href=\"http://profiles.wordpress.org/tar\">Tar</a>, <a href=\"http://profiles.wordpress.org/tlovett1\">Taylor Lovett</a>, <a href=\"http://profiles.wordpress.org/thomasvanderbeek\">Thomas van der Beek</a>, <a href=\"http://profiles.wordpress.org/n7studios\">Tim Carr</a>, <a href=\"http://profiles.wordpress.org/tjsingleton\">tjsingleton</a>, <a href=\"http://profiles.wordpress.org/tobiasbg\">TobiasBg</a>, <a href=\"http://profiles.wordpress.org/toscho\">toscho</a>, <a href=\"http://profiles.wordpress.org/taupecat\">Tracy Rotton</a>, <a href=\"http://profiles.wordpress.org/travishoffman\">TravisHoffman</a>, <a href=\"http://profiles.wordpress.org/uuf6429\">uuf6429</a>, <a href=\"http://profiles.wordpress.org/lightningspirit\">Vitor Carvalho</a>, <a href=\"http://profiles.wordpress.org/wojtek\">wojtek</a>, <a href=\"http://profiles.wordpress.org/wpewill\">wpewill</a>, <a href=\"http://profiles.wordpress.org/wraithkenny\">WraithKenny</a>, <a href=\"http://profiles.wordpress.org/wycks\">wycks</a>, <a href=\"http://profiles.wordpress.org/xibe\">Xavier Borderie</a>, <a href=\"http://profiles.wordpress.org/yoavf\">Yoav Farhi</a>, <a href=\"http://profiles.wordpress.org/thelastcicada\">Zachary Brown</a>, <a href=\"http://profiles.wordpress.org/tollmanz\">Zack Tollman</a>, <a href=\"http://profiles.wordpress.org/zekeweeks\">zekeweeks</a>, <a href=\"http://profiles.wordpress.org/ziegenberg\">ziegenberg</a>, and <a href=\"http://profiles.wordpress.org/viniciusmassuchetto\">viniciusmassuchetto</a>.</p>\n<p>Time to upgrade!</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"http://wordpress.org/news/2013/08/oscar/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"WordPress 3.6 Release Candidate 2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"http://wordpress.org/news/2013/07/wordpress-3-6-release-candidate-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"http://wordpress.org/news/2013/07/wordpress-3-6-release-candidate-2/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 24 Jul 2013 07:25:10 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:7:\"Testing\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2649\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:341:\"The second release candidate for WordPress 3.6 is now available for download and testing. We&#8217;re down to only a few remaining issues, and the final release should be available in a matter of days. In RC2, we&#8217;ve tightened up some aspects of revisions, autosave, and the media player, and fixed some bugs that were spotted [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Mark Jaquith\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:1325:\"<p>The second release candidate for WordPress 3.6 is now available for download and testing.</p>\n<p>We&#8217;re down to only a few remaining issues, and the final release should be available in a matter of days. In RC2, we&#8217;ve tightened up some aspects of revisions, autosave, and the media player, and fixed some bugs that were spotted in RC1. Please test this release candidate as much as you can, so we can deliver a smooth final release!</p>\n<p><strong>Think you&#8217;ve found a bug?</strong> Please post to the <a href=\"http://wordpress.org/support/forum/alphabeta/\">Alpha/Beta area in the support forums</a>.</p>\n<p><strong>Developers,</strong> please continue to test your plugins and themes, so that if there is a compatibility issue, we can figure it out before the final release. You can find our <a href=\"http://core.trac.wordpress.org/report/6\">list of known issues here</a>.</p>\n<p>To test WordPress 3.6, try the <a href=\"http://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you&#8217;ll want &#8220;bleeding edge nightlies&#8221;). Or you can <a href=\"http://wordpress.org/wordpress-3.6-RC2.zip\">download the release candidate here (zip)</a>.</p>\n<p><em>Revisions so smooth</em><br />\n<em>We autosave your changes</em><br />\n<em>Data loss begone!</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"http://wordpress.org/news/2013/07/wordpress-3-6-release-candidate-2/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"WordPress 3.6 Release Candidate\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"http://wordpress.org/news/2013/07/wordpress-3-6-release-candidate/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:75:\"http://wordpress.org/news/2013/07/wordpress-3-6-release-candidate/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 13 Jul 2013 03:23:17 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:7:\"Testing\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2639\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:344:\"The first release candidate for WordPress 3.6 is now available. We hope to ship WordPress 3.6 in a couple weeks. But to do that, we really need your help! If you haven&#8217;t tested 3.6 yet, there&#8217;s no time like the present. (But please: not on a live production site, unless you&#8217;re feeling especially adventurous.) Think [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Mark Jaquith\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:1504:\"<p>The first release candidate for WordPress 3.6 is now available.</p>\n<p>We hope to ship WordPress 3.6 in a couple weeks. But to do that, we really need your help! If you haven&#8217;t tested 3.6 yet, there&#8217;s no time like the present. (But please: not on a live production site, unless you&#8217;re feeling especially adventurous.)</p>\n<p><strong>Think you&#8217;ve found a bug?</strong> Please post to the <a href=\"http://wordpress.org/support/forum/alphabeta/\">Alpha/Beta area in the support forums</a>. If any known issues come up, you’ll be able to <a href=\"http://core.trac.wordpress.org/report/6\">find them here</a>. <strong>Developers,</strong> please test your plugins and themes, so that if there is a compatibility issue, we can sort it out before the final release.</p>\n<p>To test WordPress 3.6, try the <a href=\"http://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you&#8217;ll want &#8220;bleeding edge nightlies&#8221;). Or you can <a href=\"http://wordpress.org/wordpress-3.6-RC1.zip\">download the release candidate here (zip)</a>.</p>\n<p>As you may have heard, we backed the Post Format UI feature out of the release. On the other hand, our slick new revisions browser had some extra time to develop. You should see it with 200+ revisions loaded — scrubbing back and forth at lightning speed is a thing of beauty.</p>\n<p><em>Delayed, but still loved</em><br />\n<em>The release will be out soon</em><br />\n<em>Test it, por favor</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"http://wordpress.org/news/2013/07/wordpress-3-6-release-candidate/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"Annual WordPress Survey &amp; WCSF\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"http://wordpress.org/news/2013/07/annual-wordpress-survey-wcsf/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"http://wordpress.org/news/2013/07/annual-wordpress-survey-wcsf/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 09 Jul 2013 23:50:29 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:9:\"Community\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:6:\"Events\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2625\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:347:\"It&#8217;s time for our third annual user and developer survey! If you&#8217;re a WordPress user, developer, or business, we want your feedback. Just like previous years, we&#8217;ll share the data at the upcoming WordCamp San Francisco (WCSF). Results will also be sent to each survey respondent. It only takes a few minutes to fill out [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:1242:\"<p><img class=\"alignright\" alt=\"\" align=\"right\" src=\"http://wpdotorg.files.wordpress.com/2013/07/wcsf-2013.jpg\" width=\"278\" height=\"185\" />It&#8217;s time for our third annual user and developer survey! If you&#8217;re a WordPress user, developer, or business, we want your feedback. Just like previous years, we&#8217;ll share the data at the upcoming <a href=\"http://2013.sf.wordcamp.org/\">WordCamp San Francisco</a> (WCSF). Results will also be sent to each survey respondent.</p>\n<p>It only takes a few minutes to <a href=\"http://wp-survey.polldaddy.com/s/wp-2013\">fill out the survey</a>, which will provide an overview of how people use WordPress.</p>\n<p>If you missed past State of the Word keynotes, be sure to check out them out for survey results from <a href=\"http://wordpress.org/news/2011/08/state-of-the-word/\">2011</a> and <a href=\"http://ma.tt/2012/08/state-of-the-word-2012/\">2012</a>.</p>\n<p>Speaking of WCSF, if you didn&#8217;t get a ticket or are too far away to attend, you can still <a href=\"http://2013.sf.wordcamp.org/tickets/\">get a ticket for the live stream</a>! Watch the live video stream from the comfort of your home on July 26 and 27; WCSF t-shirt, or any shirt, optional.</p>\n<p>I hope to see you there.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"http://wordpress.org/news/2013/07/annual-wordpress-survey-wcsf/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"WordPress 3.5.2 Maintenance and Security Release\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wordpress.org/news/2013/06/wordpress-3-5-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/news/2013/06/wordpress-3-5-2/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 21 Jun 2013 19:54:26 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2612\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:380:\"WordPress 3.5.2 is now available. This is the second maintenance release of 3.5, fixing 12 bugs. This is a security release for all previous versions and we strongly encourage you to update your sites immediately. The WordPress security team resolved seven security issues, and this release also contains some additional security hardening. The security fixes included: [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2549:\"<p>WordPress 3.5.2 is now available. This is the second maintenance release of 3.5, fixing <a href=\"http://core.trac.wordpress.org/query?status=closed&amp;group=resolution&amp;milestone=3.5.2\">12 bugs</a>. <strong>This is a security release for all previous versions and we strongly encourage you to update your sites immediately.</strong> The WordPress security team resolved seven security issues, and this release also contains some additional security hardening.</p>\n<p>The security fixes included:</p>\n<ul>\n<li>Blocking server-side request forgery attacks, which could potentially enable an attacker to gain access to a site.</li>\n<li>Disallow contributors from improperly publishing posts, reported by <a href=\"http://kovshenin.com/\">Konstantin Kovshenin</a>, or reassigning the post&#8217;s authorship, reported by <a href=\"http://www.sharefaith.com/\">Luke Bryan</a>.</li>\n<li>An update to the SWFUpload external library to fix cross-site scripting vulnerabilities. Reported by <a href=\"http://ma.la\">mala</a> and <a href=\"http://mars.iti.pk.edu.pl/~grucha/\">Szymon Gruszecki</a>. (Developers: More on SWFUpload <a href=\"http://make.wordpress.org/core/2013/06/21/secure-swfupload/\">here</a>.)</li>\n<li>Prevention of a denial of service attack, affecting sites using password-protected posts.</li>\n<li>An update to an external TinyMCE library to fix a cross-site scripting vulnerability. Reported by <a href=\"http://twitter.com/rinakikun\">Wan Ikram</a>.</li>\n<li>Multiple fixes for cross-site scripting. Reported by <a href=\"http://webapplicationsecurity.altervista.org/\">Andrea Santese</a> and Rodrigo.</li>\n<li>Avoid disclosing a full file path when a upload fails. Reported by <a href=\"http://hauntit.blogspot.de/\">Jakub Galczyk</a>.</li>\n</ul>\n<p>We appreciated <a href=\"http://codex.wordpress.org/FAQ_Security\">responsible disclosure</a> of these issues directly to our security team. For more information on the changes, see the <a href=\"http://codex.wordpress.org/Version_3.5.2\">release notes</a> or consult <a href=\"http://core.trac.wordpress.org/log/branches/3.5?rev=24498&amp;stop_rev=23347\">the list of changes</a>.</p>\n<p><a href=\"http://wordpress.org/wordpress-3.5.2.zip\">Download WordPress 3.5.2</a> or update now from the Dashboard → Updates menu in your site’s admin area.</p>\n<p><em>Also:</em> <strong>WordPress 3.6 Beta 4:</strong> If you are testing WordPress 3.6, please note that <a href=\"http://wordpress.org/wordpress-3.6-beta4.zip\">WordPress 3.6 Beta 4</a> (zip) includes fixes for these security issues.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2013/06/wordpress-3-5-2/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:42:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Ten Good Years\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"http://wordpress.org/news/2013/05/ten-good-years/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"http://wordpress.org/news/2013/05/ten-good-years/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 31 May 2013 17:54:35 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Meta\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2606\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:343:\"It&#8217;s been ten years since we started this thing, and what a long way we&#8217;ve come. From a discussion between myself and Mike Little about forking our favorite blogging software, to powering 18% of the web. It&#8217;s been a crazy, exciting, journey, and one that won&#8217;t stop any time soon. At ten years, it&#8217;s fun [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:9852:\"<p><img class=\"alignright\" alt=\"\" align=\"right\" src=\"http://wpdotorg.files.wordpress.com/2013/05/wp10.jpg\" width=\"316\" height=\"164\" />It&#8217;s been ten years since we started this thing, and what a long way we&#8217;ve come. From a discussion between myself and <a href=\"http://mikelittle.org/\">Mike Little</a> about <a href=\"http://ma.tt/2003/01/the-blogging-software-dilemma/\">forking our favorite blogging software</a>, to powering 18% of the web. It&#8217;s been a crazy, exciting, journey, and one that won&#8217;t stop any time soon.</p>\n<p>At ten years, it&#8217;s fun to reflect on our beginnings. We launched WordPress on 27th May 2003, but that wasn&#8217;t inception. Go back far enough, and you can <a href=\"http://zengun.org/weblog/archives/2001/06/post1958/\">read a post by Michel Valdrighi</a> who, frustrated by the self-hosted blogging platforms available, decided to write his own software; &#8220;b2, a PHP+MySQL alternative to Blogger and GreyMatter.&#8221; b2 was easy to install, easy to configure, and easy for developers to extend. Of all the blogging platforms out there, <a href=\"http://cafelog.com\">b2</a> was the right one for me: I could write my content and get it on the web quickly and painlessly.</p>\n<p>Sometimes, however, life gets in the way. In 2002, Michel stopped maintaining b2. Over time, security flaws became apparent and updates were needed and, while the b2 community could write patches and fixes, no one was driving the software forward. We were lucky that Michel decided to release b2 under the GPL; the software may have been abandoned, but we weren&#8217;t without options. A fork was always a possibility. That was where it stood in January 2003, when <a href=\"http://ma.tt/2003/01/the-blogging-software-dilemma/\">I posted about forking b2</a> and <a href=\"http://ma.tt/2003/01/the-blogging-software-dilemma/#comment-445\">Mike responded</a>. The rest, as they say, is history.</p>\n<p>From the very beginning to the present day, I&#8217;ve been impressed by the thought, care, and dedication that WordPress&#8217; developers have demonstrated. Each one has brought his or her unique perspective, each individual has strengthened the whole. It would be impossible to thank each of them here individually, but their achievements speak for themselves. In WordPress 1.2 the new Plugin API made it easy for developers to extend WordPress. In the same release <code>gettext()</code> internationalization opened WordPress up to every language (hat tip: <a href=\"http://ryan.boren.me/\">Ryan Boren</a> for spending hours wrapping strings with gettext). In WordPress 1.5 our Theme system made it possible for WordPress users to quickly change their site&#8217;s design: there was huge resistance to the theme system from the wider community at the time, but can you imagine WordPress without it? Versions 2.7, 2.8, and 2.9 saw improvements that let users install and update their plugins and themes with one click. WordPress has seen a redesign by <a href=\"http://v2.happycog.com/create/wordpress/?p=design/wordpress/\">happycog</a> (2.3) and gone under extensive user testing and redesign (<a href=\"http://www.slideshare.net/edanzico/riding-the-crazyhorse-future-generation-wordpress-presentation\">Crazyhorse</a>, Liz Danzico and Jen Mylo, WordPress 2.5). In WordPress 3.0 we merged WordPress MU with WordPress &#8212; a huge job but 100% worth it. And in WordPress 3.5 we revamped the media uploader to make it easier for people to get their images, video, and media online.</p>\n<p>In sticking to our commitment to user experience, we&#8217;ve done a few things that have made us unpopular. The <a href=\"http://tech.gaeatimes.com/index.php/archive/wordpress-wysiwyg-editor-is-a-disaster/\">WYSIWYG editor</a> was hated by many, especially those who felt that if you have a blog you should know HTML. Some developers hated that we stuck with our code, refusing to rewrite, but it&#8217;s always been the users that matter: better a developer lose sleep than a site break for a user. Our code isn&#8217;t always beautiful, after all, when WordPress was created most of us were still learning PHP, but we try to make a flawless experience for users.</p>\n<p>It&#8217;s not all about developers. WordPress&#8217; strength lies in the diversity of its community. From the start, we wanted a low barrier to entry and we came up with our &#8220;famous 5 minute install&#8221;. This brought on board users from varied technical background: people who didn&#8217;t write code wanted to help make WordPress better. If you couldn&#8217;t write code, it didn&#8217;t matter: you could answer a question in the support forums, write documentation, translate WordPress, or build your friends and family a WordPress website. There is <a href=\"https://make.wordpress.org/\">space in the community</a> for anyone with a passion for WordPress.</p>\n<p>It&#8217;s been wonderful to see all of the people who have used WordPress to build their home on the internet. Early on <a href=\"http://wordpress.org/news/2004/04/switchers/\">we got excited</a> by <a href=\"http://wordpress.org/news/2004/04/more-switchers/\">switchers</a>. From a community of tinkerers we grew, as writers such as <a href=\"http://ma.tt/2004/05/om-malik/\">Om Malik</a>, <a href=\"http://dougal.gunters.org/blog/2004/05/15/mark-pilgrim-switches/\">Mark Pilgrim</a>, and <a href=\"http://ma.tt/2004/07/mollycom-switches/\">Molly Holzschlag</a> made the switch to WordPress. Our commitment to effortless publishing quickly paid off and has continued to do so: <strong>the WordPress 1.2 release saw 822 downloads per day, our latest release, WordPress 3.5, has seen 145,692 per day.</strong></p>\n<p>I&#8217;m continually amazed by what people have built with WordPress. I&#8217;ve seen <a href=\"http://justintimberlake.com/main/\">musicians</a> and <a href=\"http://ma.tt/2013/01/neil-leifer-on-wordpress/\">photographers</a>, magazines such as <a href=\"http://life.time.com/\">Life</a>, <a href=\"http://boingboing.net/\">BoingBoing</a>, and the <a href=\"http://observer.com/\">New York Observer</a>, <a href=\"http://www.compliance.gov/\">government websites</a>, a <a href=\"http://josephscott.org/archives/2011/05/pressfs-a-wordpress-filesystem/\">filesystem</a>, <a href=\"http://www.ymcanyc.org/association/pages/y-mvp\"> mobile applications</a>, and even <a href=\"http://www.viper007bond.com/2010/06/12/so-apparently-wordpress-can-guide-missiles/\">seen WordPress guide missiles</a>.</p>\n<p>As the web evolves, WordPress evolves. Factors outside of our control will always influence WordPress&#8217; development: today it&#8217;s mobile devices and retina display, tomorrow it could be Google Glass or technology not yet conceived. A lot can happen in ten years! As technology changes and advances, WordPress has to change with it while remaining true to its core values: making publishing online easy for everyone. How we rise to these challenges will be what defines WordPress over the coming ten years.</p>\n<p><strong>To celebrate ten years of WordPress, we&#8217;re working on a book about our history.</strong> We&#8217;re carrying out interviews with people who have involved with the community from the very beginning, those who are still around, and those who have left. It&#8217;s a huge project, but we wanted to have something to share with you on the 10th anniversary. To learn about the very early days of WordPress, just after Mike and I forked b2 <a href=\"http://wordpress.org/about/history/\">you can download Chapter 3 right here</a>. We&#8217;ll be releasing the rest of the book serially, so watch out as the story of the last ten years emerges.</p>\n<p>In the meantime, <a href=\"http://ma.tt/2013/05/dear-wordpress/\"> I penned my own letter to WordPress</a> and other community members have been sharing their thoughts:</p>\n<ul>\n<li><a href=\"http://zed1.com/journalized/archives/2013/01/25/wordpress-a-10-year-journey/\">Mike Little on our Ten Year Journey</a>.</li>\n<li>Core contributor Helen Hou-Sandi <a href=\"http://helen.wordpress.com/2013/05/27/happy-10th-wordpress-and-thanks-from-my-little-family/\">wishes WordPress happy birthday</a>.</li>\n<li>Peter Westwood on <a href=\"http://blog.ftwr.co.uk/archives/2013/05/27/a-decade-gone-more-to-come/\">a decade gone</a>.</li>\n<li>Support rep Mika Epstein <a href=\"http://ipstenu.org/2013/you-me-and-wp/\">on her WordPress journey</a>.</li>\n<li>Dougal Campbell <a href=\"http://dougal.gunters.org/blog/2013/05/27/instagram-my-wife-suzecampbell-and-i-celebrating-the-wordpress-10th-anniversary-with-bbq-in-our-wordpress-shirts-wp10/\">celebrating with his wife, Suze</a>.</li>\n<li>Otto on <a href=\"http://ottodestruct.com/blog/2013/how-wp-affected-me/\">how WordPress affected him</a>.</li>\n</ul>\n<p>You can see how WordPress&#8217; 10th Anniversary was celebrated all over the world <a href=\"http://wp10.wordpress.net/\">by visiting the wp10 website</a>, according to Meetup we had 4,999 celebrators.</p>\n<p>To finish, I just want to say thank you to everyone: to the developers who write the code, to the designers who make WordPress sing, to the worldwide community translating WordPress into so many languages, to volunteers who answer support questions, to those who make WordPress accessible, to the systems team and the plugin and theme reviewers, to documentation writers, event organisers, evangelists, detractors, supporters and friends. Thanks to the jazzers whose music inspired us and whose names are at the heart of WordPress. Thanks to everyone who uses WordPress to power their blog or website, and to everyone who will in the future. Thanks to WordPress and its community that I&#8217;m proud to be part of.</p>\n<p>Thank you. I can&#8217;t wait to see what the next ten years bring.</p>\n<p><em>Final thanks to <a href=\"http://siobhanmckeown.com/\">Siobhan McKeown</a> for help with this post.</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"http://wordpress.org/news/2013/05/ten-good-years/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:42:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"The Next 10 Starts Now\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"http://wordpress.org/news/2013/05/the-next-10-starts-now/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"http://wordpress.org/news/2013/05/the-next-10-starts-now/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 27 May 2013 20:47:05 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Community\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2594\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:365:\"All around the globe today, people are celebrating the 10th anniversary of the first WordPress release, affectionately known as #wp10. Watching the feed of photos, tweets, and posts from Auckland to Zambia is incredible; from first-time bloggers to successful WordPress-based business owners, people are coming out in droves to raise a glass and share the [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Jen Mylo\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:3901:\"<p>All around the globe today, people are celebrating the 10th anniversary of the first WordPress release, affectionately known as #wp10. <a href=\"http://wp10.wordpress.net\">Watching the feed</a> of photos, tweets, and posts from Auckland to Zambia is incredible; from first-time bloggers to successful WordPress-based business owners, people are coming out in droves to raise a glass and share the &#8220;holiday&#8221; with their local communities. With hundreds of parties going on today, it&#8217;s more visible than ever just how popular WordPress has become.</p>\n<p><strong>Thank you to everyone who has ever contributed to this project: your labors of love made this day possible.</strong></p>\n<p>But today isn&#8217;t just about reflecting on how we got this far (though I thought <a href=\"http://ma.tt/2013/05/dear-wordpress/\">Matt&#8217;s reflection on the first ten years</a> was lovely). We are constantly moving forward. As each release cycle begins and ends (3.6 will be here soon, promise!), we always see an ebb and flow in the contributor pool. Part of ensuring the longevity of WordPress means mentoring new contributors, continually bringing new talent and fresh points of view to our family table.</p>\n<p>I am beyond pleased to announce that this summer we will be mentoring 8 interns, most of them new contributors, through <a href=\"http://www.google-melange.com/gsoc/homepage/google/gsoc2013\">Google Summer of Code</a> and the <a href=\"https://live.gnome.org/OutreachProgramForWomen/2013/JuneSeptember\">Gnome Outreach Program for Women</a>. Current contributors, who already volunteer their time working on WordPress, will provide the guidance and oversight for a variety of exciting projects  this summer. Here are the people/projects involved in the summer internships:</p>\n<ul>\n<li><strong><strong>Ryan McCue</strong>, </strong>from Australia, working on a JSON-based REST API. Mentors will be Bryan Petty and Eric Mann, with a reviewer assist from Andrew Norcross.</li>\n<li><strong>Kat Hagan</strong>, from the United States, working on a Post by Email plugin to replace the core function. Mentors will be Justin Shreve and George Stephanis, with an assist from Peter Westwood.</li>\n<li><strong>Siobhan Bamber</strong>, from Wales, working on a support (forums, training, documentation) internship. Mentors will be Mika Epstein and Hanni Ross.</li>\n<li><strong>Frederick Ding</strong>, from the United States, working on improving portability. Mentors will be Andrew Nacin and Mike Schroder.</li>\n<li><strong>Sayak Sakar</strong>, from India, working on porting WordPress for WebOS to Firefox OS. Mentor will be Eric Johnson.</li>\n<li><strong>Alex Höreth</strong>, from Germany, working on  adding WordPress native revisions to the theme and plugin code editors. Mentors will be Dominik Schilling and Aaron Campbell, with a reviewer assist from Daniel Bachhuber.</li>\n<li><strong>Mert Yazicioglu</strong>, from Turkey, working on ways to improve our community profiles at profiles.wordpress.org. Mentors will be Scott Reilly and Boone Gorges.</li>\n<li><strong>Daniele Maio</strong>, from Italy, working on a native WordPress app for Blackberry 10. Mentor will be Danilo Ercoli.</li>\n</ul>\n<p>Did you notice that our summer cohort is as international as the #wp10 parties going on today? I can only think that this is a good sign.</p>\n<p>It&#8217;s always a difficult process to decide which projects to mentor through these programs. There are always more applicants with interesting ideas with whom we&#8217;d like to work than there are opportunities. Luckily, WordPress is a free/libre open source software project, and anyone can begin contributing at any time. Is this the year for you? We&#8217;d love for you to join us as we work toward #wp20. <img src=\'http://wordpress.org/news/wp-includes/images/smilies/icon_wink.gif\' alt=\';)\' class=\'wp-smiley\' /> </p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"http://wordpress.org/news/2013/05/the-next-10-starts-now/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:42:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 3.6 Beta 3\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2013/05/wordpress-3-6-beta-3/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"http://wordpress.org/news/2013/05/wordpress-3-6-beta-3/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 11 May 2013 03:44:41 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2584\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:374:\"WordPress 3.6 Beta 3 is now available! This is software still in development and we really don’t recommend that you run it on a production site — set up a test site just to play with the new version. To test WordPress 3.6, try the WordPress Beta Tester plugin (you’ll want “bleeding edge nightlies”). Or you can download the beta here (zip). Beta [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Mark Jaquith\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2452:\"<p>WordPress 3.6 Beta 3 is now available!</p>\n<p>This is software still in development and <strong>we <em>really</em> don’t recommend that you run it on a production site</strong> — set up a test site just to play with the new version. To test WordPress 3.6, try the <a href=\"http://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"http://wordpress.org/wordpress-3.6-beta3.zip\">download the beta here</a> (zip).</p>\n<p>Beta 3 contains about a hundred changes, including improvements to the image Post Format flow (yay, drag-and-drop image upload!), a more polished revision comparison screen, and a more quote-like quote format for Twenty Thirteen.</p>\n<p>As a bonus, we now have oEmbed support for the popular music-streaming services <a href=\"http://www.rdio.com/\">Rdio</a> and <a href=\"http://www.spotify.com/\">Spotify</a> (the latter of which kindly created an oEmbed endpoint a mere 24 hours after we lamented their lack of one). Here&#8217;s an album that&#8217;s been getting a lot of play as I&#8217;ve been working on WordPress 3.6:</p>\n<p><iframe width=\"500\" height=\"250\" src=\"https://rd.io/i/Qj5r8SE//?source=oembed\" frameborder=\"0\"></iframe></p>\n<p><iframe src=\"https://embed.spotify.com/?uri=spotify:album:6dJZDZMNdBPZrJcNv57bEq\" width=\"300\" height=\"380\" frameborder=\"0\" allowtransparency=\"true\"></iframe></p>\n<p>Plugin developers, theme developers, and WordPress hosts should be testing beta 3 extensively. The more you test the beta, the more stable our release candidates and our final release will be.</p>\n<p>As always, if you think you’ve found a bug, you can post to the <a href=\"http://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a> in the support forums. Or, if you’re comfortable writing a reproducible bug report, <a href=\"http://core.trac.wordpress.org/\">file one on the WordPress Trac</a>. There, you can also find <a href=\"http://core.trac.wordpress.org/report/5\">a list of known bugs</a> and <a href=\"http://core.trac.wordpress.org/query?status=closed&amp;group=component&amp;milestone=3.6\">everything we&#8217;ve fixed</a> so far.</p>\n<p>We&#8217;re looking forward to your feedback. If you find a bug, please report it, and if you’re a developer, try to help us fix it. We&#8217;ve already had more than 150 contributors to version 3.6 — it&#8217;s not too late to join in!</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"http://wordpress.org/news/2013/05/wordpress-3-6-beta-3/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:42:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 3.6 Beta 2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2013/04/wordpress-3-6-beta-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"http://wordpress.org/news/2013/04/wordpress-3-6-beta-2/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 29 Apr 2013 22:48:55 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2579\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:373:\"WordPress 3.6 Beta 2 is now available! This is software still in development and we really don’t recommend that you run it on a production site — set up a test site just to play with the new version. To test WordPress 3.6, try the WordPress Beta Tester plugin (you’ll want “bleeding edge nightlies”). Or you can download the beta here (zip). The [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Mark Jaquith\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2057:\"<p>WordPress 3.6 Beta 2 is now available!</p>\n<p>This is software still in development and <strong>we <em>really</em> don’t recommend that you run it on a production site</strong> — set up a test site just to play with the new version. To test WordPress 3.6, try the <a href=\"http://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"http://wordpress.org/wordpress-3.6-beta2.zip\">download the beta here</a> (zip).</p>\n<p>The longer-than-usual delay between beta 1 and beta 2 was due to poor user testing results with the Post Formats UI. Beta 2 contains a modified approach for format choosing and switching, which has done well in user testing. We&#8217;ve also made the Post Formats UI hide-able via Screen Options, and set a reasonable default based on what your theme supports.</p>\n<p>There were a lot of bug fixes and polishing tweaks done for beta 2 as well, so definitely check it out if you had an issues with beta 1.</p>\n<p>Plugin developers, theme developers, and WordPress hosts should be testing beta 2 extensively. The more you test the beta, the more stable our release candidates and our final release will be.</p>\n<p>As always, if you think you’ve found a bug, you can post to the <a href=\"http://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a> in the support forums. Or, if you’re comfortable writing a reproducible bug report, <a href=\"http://core.trac.wordpress.org/\">file one on the WordPress Trac</a>. There, you can also find <a href=\"http://core.trac.wordpress.org/report/5\">a list of known bugs</a> and <a href=\"http://core.trac.wordpress.org/query?status=closed&amp;group=component&amp;milestone=3.6\">everything we&#8217;ve fixed</a> so far.</p>\n<p>We&#8217;re looking forward to your feedback. If you find a bug, please report it, and if you’re a developer, try to help us fix it. We&#8217;ve already had more than 150 contributors to version 3.6 — it&#8217;s not too late to join in!</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"http://wordpress.org/news/2013/04/wordpress-3-6-beta-2/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:42:\"Summer Mentorship Programs: GSoC and Gnome\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:76:\"http://wordpress.org/news/2013/04/summer-mentorship-programs-gsoc-and-gnome/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:85:\"http://wordpress.org/news/2013/04/summer-mentorship-programs-gsoc-and-gnome/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 25 Apr 2013 03:18:41 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:9:\"Community\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2573\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:358:\"As an open source, free software project, WordPress depends on the contributions of hundreds of people from around the globe &#8212; contributions in areas like core code, documentation, answering questions in the support forums, translation, and all the other things it takes to make WordPress the best publishing platform it can be, with the most [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Jen Mylo\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:5071:\"<p>As an open source, free software project, WordPress depends on the contributions of hundreds of people from around the globe &#8212; contributions in areas like core code, documentation, answering questions in the support forums, translation, and all the other things it takes to make WordPress the best publishing platform it can be, with the most supportive community. This year, we&#8217;re happy to be participating as a mentoring organization with two respected summer internship programs: <a href=\"http://www.google-melange.com/gsoc/homepage/google/gsoc2013\">Google Summer of Code (GSoC)</a> and the Gnome Outreach Program for Women.</p>\n<h3>Google Summer of Code</h3>\n<p>GSoC is a summer internship program funded by Google specifically for college/university student developers to work on open source coding projects. We have participated in the Google Summer of Code program in the past, and have enjoyed the opportunity to work with students in this way. Some of our best core developers were GSoC students once upon a time!</p>\n<p><a href=\"http://codex.wordpress.org/GSoC2013#Mentors\">Our mentors</a>, almost 30 talented developers with experience developing WordPress, will provide students with guidance and feedback over the course of the summer, culminating in the release of finished projects at the end of the program if all goes well.</p>\n<p>Students who successfully complete the program earn $5,000 for their summer efforts. Interested, or know a college student (newly accepted to college counts, too) who should be? All the information you need about our participation in the program, projects, mentors, and the application process is available on the <a href=\"http://codex.wordpress.org/GSoC2013\">GSoC 2013 page in the Codex</a>.</p>\n<h3>Gnome Outreach Program for Women</h3>\n<p>It&#8217;s not news that women form a low percentage of contributors in most open source projects, and WordPress is no different. We have great women in the contributor community, including some in fairly visible roles, but we still have a lot of work to do to get a representative gender balance on par with our user base.</p>\n<p>The Gnome Outreach Program for Women aims to provide opportunities for women to participate in open source projects, and offers a similar stipend, but there are three key differences between GSoC and Gnome aside from the gender requirement for Gnome.</p>\n<ol>\n<li><span style=\"font-size: 13px;line-height: 19px\">The Gnome program allows intern projects in many areas of contribution, not just code. In other words, interns can propose projects like documentation, community management, design, translation, or pretty much any area in which we have people contributing (including code).</span></li>\n<li><span style=\"font-size: 13px;line-height: 19px\">The Gnome Outreach Program for Women doesn&#8217;t require interns to be college students, though students are definitely welcome to participate. This means that women in all stages of life and career can take the opportunity to try working with open source communities for the summer.</span></li>\n<li><span style=\"font-size: 13px;line-height: 19px\">We have to help raise the money to pay the interns. Google funds GSoC on its own, and we only have to provide our mentors&#8217; time. Gnome doesn&#8217;t have the same funding, so we need to pitch in to raise the money to cover our interns. If your company is interested in helping with this, please check out the program&#8217;s </span><a style=\"font-size: 13px;line-height: 19px\" href=\"https://live.gnome.org/OutreachProgramForWomen#For_Organizations_and_Companies\">sponsorship information</a><span style=\"font-size: 13px;line-height: 19px\"> and follow the contact instructions to get involved. You can earmark donations to support WordPress interns, or to support the program in general. (Pick us, pick us! <img src=\'http://wordpress.org/news/wp-includes/images/smilies/icon_smile.gif\' alt=\':)\' class=\'wp-smiley\' />  )</span></li>\n</ol>\n<p>The summer installment of the Gnome Outreach Program for Women follows the same schedule and general application format as GSoC, though there are more potential projects since it covers more areas of contribution. Women college students interested in doing a coding project are encouraged to apply for both programs to increase the odds of acceptance. All the information you need about our participation in the program, projects, mentors, and the application process is available on the <a href=\"http://codex.wordpress.org/Gnome_Summer_Program_for_Women\">Gnome Outreach Program for Women page in the Codex</a>.</p>\n<p>The application period just started, and it lasts another week (May 1 for Gnome, May 3 for GSoC), so if you think you qualify and are interested in getting involved, check out the information pages, get in touch, and apply… Good luck!</p>\n<p><a href=\"http://codex.wordpress.org/GSoC2013\">Google Summer of Code 2013 Information</a><br />\n<a href=\"http://codex.wordpress.org/Gnome_Summer_Program_for_Women\">Gnome Summer Outreach Program for Women 2013 Information</a></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:81:\"http://wordpress.org/news/2013/04/summer-mentorship-programs-gsoc-and-gnome/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:31:\"http://wordpress.org/news/feed/\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:44:\"http://purl.org/rss/1.0/modules/syndication/\";a:2:{s:12:\"updatePeriod\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"hourly\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:15:\"updateFrequency\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:8:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Sat, 07 Sep 2013 17:45:55 GMT\";s:12:\"content-type\";s:23:\"text/xml; charset=UTF-8\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:10:\"x-pingback\";s:36:\"http://wordpress.org/news/xmlrpc.php\";s:13:\"last-modified\";s:29:\"Thu, 01 Aug 2013 21:49:34 GMT\";s:4:\"x-nc\";s:11:\"HIT lax 249\";}s:5:\"build\";s:14:\"20130902175941\";}", "no");
INSERT INTO `wp_options` VALUES("334", "_transient_timeout_feed_mod_f7bd8ef9f0b32599824d5a7fa4084588", "1378619155", "no");
INSERT INTO `wp_options` VALUES("335", "_transient_feed_mod_f7bd8ef9f0b32599824d5a7fa4084588", "1378575955", "no");
INSERT INTO `wp_options` VALUES("336", "_transient_timeout_dash_20494a3d90a6669585674ed0eb8dcd8f", "1378619155", "no");
INSERT INTO `wp_options` VALUES("337", "_transient_dash_20494a3d90a6669585674ed0eb8dcd8f", "<p>This dashboard widget queries <a href=\"http://blogsearch.google.com/\">Google Blog Search</a> so that when another blog links to your site it will show up here. It has found no incoming links&hellip; yet. It&#8217;s okay &#8212; there is no rush.</p>\n", "no");
INSERT INTO `wp_options` VALUES("332", "_transient_timeout_feed_f7bd8ef9f0b32599824d5a7fa4084588", "1378619155", "no");
INSERT INTO `wp_options` VALUES("184", "_transient_timeout_feed_a5420c83891a9c88ad2a4f04584a5efc", "1378187973", "no");
INSERT INTO `wp_options` VALUES("185", "_transient_feed_a5420c83891a9c88ad2a4f04584a5efc", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n	\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:72:\"\n		\n		\n		\n		\n		\n		\n				\n\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"WordPress Plugins » View: Most Popular\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"http://wordpress.org/plugins/browse/popular/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"WordPress Plugins » View: Most Popular\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 02 Sep 2013 17:50:31 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"http://bbpress.org/?v=1.1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:15:{i:0;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"All in One SEO Pack\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"http://wordpress.org/plugins/all-in-one-seo-pack/#post-753\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 30 Mar 2007 20:08:18 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"753@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:86:\"WordPress SEO plugin to automatically optimize your Wordpress blog for Search Engines.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"uberdose\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"Akismet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"http://wordpress.org/plugins/akismet/#post-15\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 09 Mar 2007 22:11:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"15@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:98:\"Akismet checks your comments against the Akismet web service to see if they look like spam or not.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Contact Form 7\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"http://wordpress.org/plugins/contact-form-7/#post-2141\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 02 Aug 2007 12:45:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"2141@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"Just another contact form plugin. Simple but flexible.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Takayuki Miyoshi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:24:\"Jetpack by WordPress.com\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"http://wordpress.org/plugins/jetpack/#post-23862\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 20 Jan 2011 02:21:38 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"23862@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:104:\"Supercharge your WordPress site with powerful features previously only available to WordPress.com users.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:24:\"Michael Adams (mdawaffe)\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"WordPress SEO by Yoast\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"http://wordpress.org/plugins/wordpress-seo/#post-8321\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 01 Jan 2009 20:34:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"8321@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:131:\"Improve your WordPress SEO: Write better content and have a fully optimized WordPress site using the WordPress SEO plugin by Yoast.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Joost de Valk\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"NextGEN Gallery\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/plugins/nextgen-gallery/#post-1169\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 23 Apr 2007 20:08:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"1169@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:122:\"The most popular WordPress gallery plugin and one of the most popular plugins of all time with over 7.5 million downloads.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Alex Rabe\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"WordPress Importer\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/plugins/wordpress-importer/#post-18101\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 20 May 2010 17:42:45 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"18101@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:101:\"Import posts, pages, comments, custom fields, categories, tags and more from a WordPress export file.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Brian Colinger\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Better WP Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/plugins/better-wp-security/#post-21738\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 22 Oct 2010 22:06:05 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"21738@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:107:\"The easiest, most effective way to secure WordPress. Improve the security of any WordPress site in seconds.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"ChrisWiegman\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Wordfence Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wordpress.org/plugins/wordfence/#post-29832\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 04 Sep 2011 03:13:51 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"29832@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:148:\"Wordfence Security is a free enterprise class security plugin that includes a firewall, virus scanning, real-time traffic with geolocation and more.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"mmaunder\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"W3 Total Cache\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/plugins/w3-total-cache/#post-12073\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 29 Jul 2009 18:46:31 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"12073@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:132:\"Easy Web Performance Optimization (WPO) using caching: browser, page, object, database, minify and content delivery network support.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Frederick Townes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"Captcha\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"http://wordpress.org/plugins/captcha/#post-26129\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 27 Apr 2011 05:53:50 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"26129@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"This plugin allows you to implement super security captcha form into web forms.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"bestwebsoft\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"Really Simple CAPTCHA\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:61:\"http://wordpress.org/plugins/really-simple-captcha/#post-9542\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 09 Mar 2009 02:17:35 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"9542@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:138:\"Really Simple CAPTCHA is a CAPTCHA module intended to be called from other plugins. It is originally created for my Contact Form 7 plugin.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Takayuki Miyoshi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Redirection\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"http://wordpress.org/plugins/redirection/#post-2286\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 10 Sep 2007 04:45:08 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"2286@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:144:\"Redirection is a WordPress plugin to manage 301 redirections and keep track of 404 errors without requiring knowledge of Apache .htaccess files.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"John Godley\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"Google XML Sitemaps\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"http://wordpress.org/plugins/google-sitemap-generator/#post-132\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 09 Mar 2007 22:31:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"132@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:105:\"This plugin will generate a special XML sitemap which will help search engines to better index your blog.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"Arnee\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"WPtouch Mobile Plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"http://wordpress.org/plugins/wptouch/#post-5468\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 01 May 2008 04:58:09 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"5468@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"Create a beautiful mobile WordPress website with just a few clicks.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"BraveNewCode Inc.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:45:\"http://wordpress.org/plugins/rss/view/popular\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:7:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Mon, 02 Sep 2013 17:59:33 GMT\";s:12:\"content-type\";s:23:\"text/xml; charset=UTF-8\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:13:\"last-modified\";s:29:\"Fri, 30 Mar 2007 20:08:18 GMT\";s:4:\"x-nc\";s:11:\"HIT lax 249\";}s:5:\"build\";s:14:\"20090627192103\";}", "no");
INSERT INTO `wp_options` VALUES("186", "_transient_timeout_feed_mod_a5420c83891a9c88ad2a4f04584a5efc", "1378187973", "no");
INSERT INTO `wp_options` VALUES("187", "_transient_feed_mod_a5420c83891a9c88ad2a4f04584a5efc", "1378144773", "no");
INSERT INTO `wp_options` VALUES("188", "_transient_timeout_feed_57bc725ad6568758915363af670fd8bc", "1378187973", "no");
INSERT INTO `wp_options` VALUES("189", "_transient_feed_57bc725ad6568758915363af670fd8bc", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n	\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:72:\"\n		\n		\n		\n		\n		\n		\n				\n\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"WordPress Plugins » View: Newest\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"http://wordpress.org/plugins/browse/new/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"WordPress Plugins » View: Newest\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 02 Sep 2013 17:43:28 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"http://bbpress.org/?v=1.1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:15:{i:0;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"WooCommerce Checkout Password Strength Meter\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:85:\"http://wordpress.org/plugins/woocommerce-checkout-password-strength-meter/#post-57914\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 02 Sep 2013 12:49:28 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"57914@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"Add a password strength meter to the WooCommerce checkout process!\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Remi Corson\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Ework Slider\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"http://wordpress.org/plugins/ework-flexslider/#post-57572\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 24 Aug 2013 18:36:45 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"57572@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:95:\"Flexslider simple and easy to use with fade and slide effect, these can be arranged from admin.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"Ework\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"BP List Newest Members widget\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"http://wordpress.org/plugins/bp-list-newest-members/#post-57795\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 29 Aug 2013 14:08:39 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"57795@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"Show the list of  newest members in the widget area max 5\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"naijaping\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"WP Keyword Suggest\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/plugins/wp-keyword-suggest/#post-57542\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 23 Aug 2013 17:49:27 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"57542@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:103:\"This SEO plugin offers keyword suggestions, taken from autocomplete google, yahoo, bing, amazon, blekko\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"nicolasmarin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"iDEAL Mollie betalen doneren\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"http://wordpress.org/plugins/ideal-mollie-betalen-doneren/#post-57703\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 27 Aug 2013 10:23:31 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"57703@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:85:\"Een plugin waarmee u klanten makkelijk donaties kunt laten doen met iDEAL via Mollie.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Fikira\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"Chrome App Promoter Widget by Anthony Delgado\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/plugins/chrome-app-promote/#post-57258\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 16 Aug 2013 18:25:23 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"57258@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:150:\"Promote your Chrome App on your Wordpress Blog. Do you have an App in the Chrome Web Store? Do you want a quick and easy way to Promote it through-out\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"mrfresh86\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"Simple Crumbs Redux\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"http://wordpress.org/plugins/simple-crumbs-redux/#post-57550\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 24 Aug 2013 02:33:34 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"57550@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"Summary: Generates navigation bread crumbs in WordPress. Requires permalinks.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"Scriptrunner (Doug Sparling)\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:26:\"Restore Admin Menu (ru_RU)\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/plugins/restore-admin-menu/#post-54419\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 11 Jun 2013 13:25:01 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"54419@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:113:\"Restores the admin menu when updating from 3.1.x or an older install to the latest release from ru.wordpress.org.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Sergey Biryukov\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"Tindeck\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"http://wordpress.org/plugins/tindeck/#post-57718\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 27 Aug 2013 18:05:22 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"57718@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"Create Tindeck players anywhere useing shortcode [tindeck id=&#34;&#34;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"danieliser\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:23:\"Simple Fast Highlighter\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"http://wordpress.org/plugins/simple-fast-highlighter/#post-57371\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 19 Aug 2013 14:54:48 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"57371@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:46:\"Fast syntax highlighter written in Javascript.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"michielve\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Esse-Captcha\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"http://wordpress.org/plugins/esse-captcha/#post-57567\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 24 Aug 2013 14:44:49 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"57567@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:114:\"This plugin is just a simple captcha that appears when an unregistered user try to register or to leave a comment.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"stefanoj3\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"Auto Post After Image Upload\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"http://wordpress.org/plugins/auto-post-after-image-upload/#post-57642\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 26 Aug 2013 10:35:43 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"57642@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:127:\"This plugin will provide you the facility to create post after uploading each media from wordpress media gallery automatically.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Shaharia Azam\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"Social Deals Engine -\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"http://wordpress.org/plugins/deals-engine/#post-57804\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 29 Aug 2013 21:07:29 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"57804@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:121:\"Turn your WordPress blog in to a Social Deals site and sell any kind of Deals with this complete Deals management plugin.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"wpsocial\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"Contact Form 7 Charts\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"http://wordpress.org/plugins/contact-form-7-charts/#post-57805\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 29 Aug 2013 21:37:58 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"57805@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:131:\"A plugin for automatically generating color dashboard pie and trend charts from Contact Forms DB and Contact Form 7 forms activity.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"ghagen\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Simple Drop-ins\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"http://wordpress.org/plugins/simple-drop-ins/#post-57686\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 27 Aug 2013 02:34:42 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"57686@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"description\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"rosdyana.kusuma\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:41:\"http://wordpress.org/plugins/rss/view/new\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:10:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Mon, 02 Sep 2013 17:59:33 GMT\";s:12:\"content-type\";s:23:\"text/xml; charset=UTF-8\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:7:\"expires\";s:29:\"Mon, 02 Sep 2013 18:18:28 GMT\";s:13:\"cache-control\";s:0:\"\";s:6:\"pragma\";s:0:\"\";s:13:\"last-modified\";s:31:\"Mon, 02 Sep 2013 17:43:28 +0000\";s:4:\"x-nc\";s:11:\"HIT lax 249\";}s:5:\"build\";s:14:\"20090627192103\";}", "no");
INSERT INTO `wp_options` VALUES("190", "_transient_timeout_feed_mod_57bc725ad6568758915363af670fd8bc", "1378187973", "no");
INSERT INTO `wp_options` VALUES("191", "_transient_feed_mod_57bc725ad6568758915363af670fd8bc", "1378144773", "no");
INSERT INTO `wp_options` VALUES("193", "_transient_timeout_feed_1a5f760f2e2b48827d4974a60857e7c2", "1378187973", "no");
INSERT INTO `wp_options` VALUES("194", "_transient_feed_1a5f760f2e2b48827d4974a60857e7c2", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n	\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:72:\"\n		\n		\n		\n		\n		\n		\n				\n\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:43:\"WordPress Plugins » View: Recently Updated\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"http://wordpress.org/plugins/browse/updated/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:43:\"WordPress Plugins » View: Recently Updated\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 02 Sep 2013 17:25:01 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"http://bbpress.org/?v=1.1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:15:{i:0;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:24:\"DJ Rotator For WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:65:\"http://wordpress.org/plugins/dj-rotator-for-wordpress/#post-32499\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 28 Nov 2011 20:18:48 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"32499@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"Easily create a DJ Rotator to display on-air personalities.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Greg Rickaby\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"YITH Footer Banner\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/plugins/yith-footer-banner/#post-56081\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 18 Jul 2013 09:04:23 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"56081@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:81:\"YITH Footer Banner gives you the ability to have a floating banner in your theme.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"yithemes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Ework Slider\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"http://wordpress.org/plugins/ework-flexslider/#post-57572\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 24 Aug 2013 18:36:45 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"57572@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:95:\"Flexslider simple and easy to use with fade and slide effect, these can be arranged from admin.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"Ework\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Varnish HTTP Purge\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/plugins/varnish-http-purge/#post-28412\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 15 Jul 2011 08:53:13 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"28412@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"Purge Varnish Cache when pages are modified.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"techpriester\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"WooCommerce Checkout Password Strength Meter\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:85:\"http://wordpress.org/plugins/woocommerce-checkout-password-strength-meter/#post-57914\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 02 Sep 2013 12:49:28 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"57914@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"Add a password strength meter to the WooCommerce checkout process!\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Remi Corson\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Microblog Poster\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"http://wordpress.org/plugins/microblog-poster/#post-33140\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 20 Dec 2011 12:48:58 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"33140@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:133:\"Automatically publishes your new blog content to Social Networks. Auto-updates Twitter, Facebook, Linkedin, Plurk, Diigo, Delicious..\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"Efficient Scripts\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Zedity\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"http://wordpress.org/plugins/zedity/#post-56952\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 07 Aug 2013 11:28:08 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"56952@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:139:\"Take your site or blog to the next level by adding multimedia content with unprecedented possibilities and flexibility, in just few clicks!\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"zuyoy\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"xili-language\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"http://wordpress.org/plugins/xili-language/#post-8746\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 23 Jan 2009 15:26:21 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"8746@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:150:\"xili-language lets you create and manage multilingual WP site in several languages with yours or most famous localizable themes. Ready for CMS design.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"Michel - xiligroup dev\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"Book Review Library\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"http://wordpress.org/plugins/book-review-library/#post-57551\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 24 Aug 2013 05:30:36 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"57551@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:86:\"A book cataloguing and review system designed with bookophiles and librarians in mind.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Chris Reynolds\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"WP-Appbox\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wordpress.org/plugins/wp-appbox/#post-47158\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 18 Dec 2012 23:09:56 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"47158@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:118:\"Via Shortcode schnell und einfach App-Details von Apps aus einer Reihe an App Stores in Artikeln oder Seiten anzeigen.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Marcelismus\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"YieldKit Affiliate Marketing\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"http://wordpress.org/plugins/yieldkit/#post-33222\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 23 Dec 2011 13:03:41 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"33222@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:136:\"YieldKit generates affiliate links out of already existing product links and product names, brands or merchants – fully automatically.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"okrohne\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Portfolio Mgmt.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/plugins/portfolio-mgmt/#post-43630\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 26 Sep 2012 20:27:43 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"43630@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:92:\"Add the power of portfolio content management to your WordPress website with Portfolio Mgmt.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Erik Ford\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Links shortcode\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"http://wordpress.org/plugins/links-shortcode/#post-22315\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 16 Nov 2010 04:59:33 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"22315@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:149:\"The plugin provides the shortcode &#039;links&#039;. This shortcode shows all links having specified characteristics, following a specified template.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Maarten Swemmer\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:37:\"Gravity Forms Constant Contact Add-on\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"http://wordpress.org/plugins/gravity-forms-constant-contact/#post-20525\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 31 Aug 2010 22:20:41 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"20525@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:89:\"Add contacts to your Constant Contact mailing list when they submit a Gravity Forms form.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Zack Katz\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"WPBook\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:46:\"http://wordpress.org/plugins/wpbook/#post-2501\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 13 Oct 2007 02:55:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"2501@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:136:\"Plugin to embed WordPress Blog into Facebook Platform. Requires PHP 5. \n\nRequires ability to access your WordPress blog via HTTPS (SSL).\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"davelester\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:45:\"http://wordpress.org/plugins/rss/view/updated\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:10:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Mon, 02 Sep 2013 17:59:33 GMT\";s:12:\"content-type\";s:23:\"text/xml; charset=UTF-8\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:7:\"expires\";s:29:\"Mon, 02 Sep 2013 18:00:01 GMT\";s:13:\"cache-control\";s:0:\"\";s:6:\"pragma\";s:0:\"\";s:13:\"last-modified\";s:31:\"Mon, 02 Sep 2013 17:25:01 +0000\";s:4:\"x-nc\";s:11:\"HIT lax 249\";}s:5:\"build\";s:14:\"20090627192103\";}", "no");
INSERT INTO `wp_options` VALUES("195", "_transient_timeout_feed_mod_1a5f760f2e2b48827d4974a60857e7c2", "1378187973", "no");
INSERT INTO `wp_options` VALUES("196", "_transient_feed_mod_1a5f760f2e2b48827d4974a60857e7c2", "1378144773", "no");
INSERT INTO `wp_options` VALUES("358", "_transient_timeout_plugin_slugs", "1378662356", "no");
INSERT INTO `wp_options` VALUES("359", "_transient_plugin_slugs", "a:4:{i:0;s:19:\"akismet/akismet.php\";i:1;s:25:\"duplicator/duplicator.php\";i:2;s:9:\"hello.php\";i:3;s:35:\"wp-image-finder/wp-image-finder.php\";}", "no");
INSERT INTO `wp_options` VALUES("203", "db_upgraded", "", "yes");
INSERT INTO `wp_options` VALUES("204", "_site_transient_update_core", "O:8:\"stdClass\":3:{s:7:\"updates\";a:1:{i:0;O:8:\"stdClass\":9:{s:8:\"response\";s:6:\"latest\";s:8:\"download\";s:38:\"http://wordpress.org/wordpress-3.6.zip\";s:6:\"locale\";s:5:\"en_US\";s:8:\"packages\";O:8:\"stdClass\":4:{s:4:\"full\";s:38:\"http://wordpress.org/wordpress-3.6.zip\";s:10:\"no_content\";s:49:\"http://wordpress.org/wordpress-3.6-no-content.zip\";s:11:\"new_bundled\";s:50:\"http://wordpress.org/wordpress-3.6-new-bundled.zip\";s:7:\"partial\";b:0;}s:7:\"current\";s:3:\"3.6\";s:11:\"php_version\";s:5:\"5.2.4\";s:13:\"mysql_version\";s:3:\"5.0\";s:11:\"new_bundled\";s:3:\"3.6\";s:15:\"partial_version\";s:0:\"\";}}s:12:\"last_checked\";i:1378556551;s:15:\"version_checked\";s:3:\"3.6\";}", "yes");
INSERT INTO `wp_options` VALUES("205", "can_compress_scripts", "1", "yes");
INSERT INTO `wp_options` VALUES("366", "_site_transient_update_themes", "O:8:\"stdClass\":3:{s:12:\"last_checked\";i:1378576195;s:7:\"checked\";a:6:{s:16:\"custom-community\";s:6:\"1.17.2\";s:9:\"pet-world\";s:3:\"1.0\";s:12:\"twentyeleven\";s:3:\"1.6\";s:9:\"twentyten\";s:3:\"1.6\";s:14:\"twentythirteen\";s:3:\"1.0\";s:12:\"twentytwelve\";s:3:\"1.2\";}s:8:\"response\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("211", "theme_mods_twentyeleven", "a:1:{s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1378145096;s:4:\"data\";a:6:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:9:\"sidebar-2\";a:0:{}s:9:\"sidebar-3\";a:0:{}s:9:\"sidebar-4\";a:0:{}s:9:\"sidebar-5\";a:0:{}}}}", "yes");
INSERT INTO `wp_options` VALUES("367", "theme_mods_pet-world", "a:1:{i:0;b:0;}", "yes");
INSERT INTO `wp_options` VALUES("212", "theme_mods_custom-community", "a:5:{i:0;b:0;s:12:\"header_image\";s:13:\"remove-header\";s:16:\"header_textcolor\";s:6:\"041fed\";s:18:\"nav_menu_locations\";a:2:{s:8:\"menu_top\";i:6;s:7:\"primary\";i:0;}s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1378576195;s:4:\"data\";a:23:{s:19:\"wp_inactive_widgets\";a:0:{}s:7:\"sidebar\";a:5:{i:0;s:8:\"search-2\";i:1;s:6:\"text-2\";i:2;s:14:\"recent-posts-2\";i:3;s:12:\"categories-2\";i:4;s:6:\"text-3\";}s:11:\"leftsidebar\";a:0:{}s:15:\"headerfullwidth\";a:0:{}s:10:\"headerleft\";a:0:{}s:12:\"headercenter\";a:0:{}s:11:\"headerright\";a:0:{}s:15:\"footerfullwidth\";a:0:{}s:10:\"footerleft\";a:0:{}s:12:\"footercenter\";a:0:{}s:11:\"footerright\";a:0:{}s:12:\"memberheader\";a:0:{}s:16:\"memberheaderleft\";a:0:{}s:18:\"memberheadercenter\";a:0:{}s:17:\"memberheaderright\";a:0:{}s:17:\"membersidebarleft\";a:0:{}s:18:\"membersidebarright\";a:0:{}s:11:\"groupheader\";a:0:{}s:15:\"groupheaderleft\";a:0:{}s:17:\"groupheadercenter\";a:0:{}s:16:\"groupheaderright\";a:0:{}s:16:\"groupsidebarleft\";a:0:{}s:17:\"groupsidebarright\";a:0:{}}}}", "yes");
INSERT INTO `wp_options` VALUES("213", "theme_switched", "", "yes");
INSERT INTO `wp_options` VALUES("214", "cc_version", "1.9", "yes");
INSERT INTO `wp_options` VALUES("215", "custom_community_theme_options", "a:156:{s:13:\"cap_style_css\";s:4:\"grey\";s:17:\"cap_website_width\";s:4:\"1000\";s:22:\"cap_website_width_unit\";s:2:\"px\";s:25:\"cap_add_custom_background\";s:7:\"Enabled\";s:17:\"cap_bg_body_color\";s:0:\"\";s:15:\"cap_bg_body_img\";s:0:\"\";s:21:\"cap_bg_body_img_fixed\";s:7:\"Enabled\";s:19:\"cap_bg_body_img_pos\";s:6:\"center\";s:22:\"cap_bg_body_img_repeat\";s:9:\"no repeat\";s:24:\"cap_cc_responsive_enable\";s:7:\"Enabled\";s:22:\"cap_bg_container_color\";s:0:\"\";s:24:\"cap_bg_container_nolines\";s:4:\"show\";s:16:\"cap_v_line_color\";s:0:\"\";s:20:\"cap_bg_container_img\";s:0:\"\";s:27:\"cap_bg_container_img_repeat\";s:9:\"no repeat\";s:27:\"cap_container_corner_radius\";s:7:\"rounded\";s:20:\"cap_sidebar_position\";s:5:\"right\";s:20:\"cap_title_font_style\";s:17:\"Arial, sans-serif\";s:14:\"cap_title_size\";s:0:\"\";s:16:\"cap_title_weight\";s:4:\"bold\";s:15:\"cap_title_color\";s:0:\"\";s:23:\"cap_subtitle_font_style\";s:17:\"Arial, sans-serif\";s:19:\"cap_subtitle_weight\";s:4:\"bold\";s:18:\"cap_subtitle_color\";s:0:\"\";s:14:\"cap_excerpt_on\";s:7:\"content\";s:18:\"cap_excerpt_length\";s:0:\"\";s:14:\"cap_font_style\";s:17:\"Arial, sans-serif\";s:13:\"cap_font_size\";s:0:\"\";s:14:\"cap_font_color\";s:0:\"\";s:14:\"cap_link_color\";s:0:\"\";s:20:\"cap_link_color_hover\";s:0:\"\";s:27:\"cap_link_color_subnav_adapt\";s:20:\"just the link colour\";s:18:\"cap_link_underline\";s:5:\"never\";s:17:\"cap_link_bg_color\";s:0:\"\";s:23:\"cap_link_bg_color_hover\";s:0:\"\";s:28:\"cap_link_styling_title_adapt\";s:21:\"just the hover effect\";s:11:\"cap_favicon\";s:0:\"\";s:32:\"cap_default_homepage_hide_avatar\";s:4:\"show\";s:26:\"cap_posts_lists_style_home\";s:4:\"blog\";s:23:\"cap_magazine_style_home\";s:14:\"img-mouse-over\";s:31:\"cap_default_homepage_last_posts\";s:4:\"show\";s:26:\"cap_default_homepage_style\";s:7:\"bubbles\";s:30:\"cap_default_homepage_hide_date\";s:4:\"show\";s:30:\"cap_posts_lists_style_taxonomy\";s:4:\"blog\";s:20:\"cap_archive_template\";s:5:\"right\";s:27:\"cap_magazine_style_taxonomy\";s:14:\"img-mouse-over\";s:27:\"cap_posts_lists_style_dates\";s:4:\"blog\";s:24:\"cap_magazine_style_dates\";s:14:\"img-mouse-over\";s:28:\"cap_posts_lists_style_author\";s:4:\"blog\";s:25:\"cap_magazine_style_author\";s:14:\"img-mouse-over\";s:27:\"cap_posts_lists_hide_avatar\";s:4:\"show\";s:28:\"cap_posts_lists_style</span>\";s:7:\"bubbles\";s:25:\"cap_posts_lists_hide_date\";s:4:\"show\";s:20:\"cap_bg_loginpage_img\";s:0:\"\";s:21:\"cap_login_logo_height\";s:0:\"\";s:27:\"cap_bg_loginpage_body_color\";s:0:\"\";s:34:\"cap_bg_loginpage_backtoblog_fade_1\";s:0:\"\";s:34:\"cap_bg_loginpage_backtoblog_fade_2\";s:0:\"\";s:15:\"cap_add_to_head\";s:0:\"\";s:17:\"cap_add_to_footer\";s:0:\"\";s:27:\"cap_add_custom_image_header\";s:7:\"Enabled\";s:15:\"cap_header_text\";s:2:\"on\";s:21:\"cap_header_text_color\";s:0:\"\";s:8:\"cap_logo\";s:0:\"\";s:17:\"cap_header_height\";s:3:\"200\";s:16:\"cap_header_width\";s:7:\"default\";s:14:\"cap_header_img\";s:0:\"\";s:21:\"cap_header_img_repeat\";s:9:\"no repeat\";s:16:\"cap_header_img_x\";s:4:\"left\";s:16:\"cap_header_img_y\";s:0:\"\";s:22:\"cap_menue_disable_home\";s:7:\"Enabled\";s:26:\"cap_menue_enable_community\";s:7:\"Enabled\";s:10:\"cap_menu_x\";s:4:\"left\";s:17:\"cap_bg_menu_style\";s:9:\"tab style\";s:18:\"cap_menu_underline\";s:0:\"\";s:20:\"cap_menue_link_color\";s:0:\"\";s:28:\"cap_menue_link_color_current\";s:0:\"\";s:23:\"cap_bg_menue_link_color\";s:0:\"\";s:15:\"cap_bg_menu_img\";s:0:\"\";s:22:\"cap_bg_menu_img_repeat\";s:9:\"no repeat\";s:31:\"cap_bg_menue_link_color_current\";s:0:\"\";s:23:\"cap_bg_menu_img_current\";s:0:\"\";s:30:\"cap_bg_menu_img_current_repeat\";s:9:\"no repeat\";s:29:\"cap_bg_menue_link_color_hover\";s:0:\"\";s:32:\"cap_bg_menue_link_color_dd_hover\";s:0:\"\";s:22:\"cap_menu_corner_radius\";s:11:\"all rounded\";s:21:\"cap_leftsidebar_width\";s:3:\"225\";s:24:\"cap_bg_leftsidebar_color\";s:0:\"\";s:22:\"cap_bg_leftsidebar_img\";s:0:\"\";s:29:\"cap_bg_leftsidebar_img_repeat\";s:9:\"no repeat\";s:30:\"cap_bg_leftsidebar_default_nav\";s:3:\"yes\";s:22:\"cap_rightsidebar_width\";s:3:\"225\";s:25:\"cap_bg_rightsidebar_color\";s:0:\"\";s:23:\"cap_bg_rightsidebar_img\";s:0:\"\";s:30:\"cap_bg_rightsidebar_img_repeat\";s:9:\"no repeat\";s:24:\"cap_bg_widgettitle_style\";s:6:\"angled\";s:26:\"cap_widgettitle_font_style\";s:17:\"Arial, sans-serif\";s:25:\"cap_widgettitle_font_size\";s:0:\"\";s:26:\"cap_widgettitle_font_color\";s:0:\"\";s:24:\"cap_bg_widgettitle_color\";s:0:\"\";s:22:\"cap_bg_widgettitle_img\";s:0:\"\";s:29:\"cap_bg_widgettitle_img_repeat\";s:9:\"no repeat\";s:25:\"cap_capitalize_widgets_li\";s:2:\"no\";s:27:\"cap_capitalize_widgettitles\";s:2:\"no\";s:16:\"cap_footer_width\";s:7:\"default\";s:20:\"cap_footerall_height\";s:0:\"\";s:22:\"cap_bg_footerall_color\";s:0:\"\";s:20:\"cap_bg_footerall_img\";s:0:\"\";s:27:\"cap_bg_footerall_img_repeat\";s:9:\"no repeat\";s:17:\"cap_footer_height\";s:0:\"\";s:19:\"cap_bg_footer_color\";s:0:\"\";s:17:\"cap_bg_footer_img\";s:0:\"\";s:24:\"cap_bg_footer_img_repeat\";s:9:\"no repeat\";s:13:\"cap_bp_avatar\";s:0:\"\";s:20:\"cap_bp_login_bar_top\";s:2:\"on\";s:25:\"cap_bp_default_navigation\";s:7:\"Enabled\";s:24:\"cap_bg_content_nav_color\";s:0:\"\";s:23:\"cap_menue_enable_search\";s:7:\"Enabled\";s:19:\"cap_buddydev_search\";s:7:\"Enabled\";s:15:\"cap_searchbar_x\";s:5:\"right\";s:15:\"cap_searchbar_y\";s:0:\"\";s:17:\"cap_login_sidebar\";s:2:\"on\";s:25:\"cap_bp_login_sidebar_text\";s:0:\"\";s:21:\"cap_bp_profile_header\";s:2:\"on\";s:23:\"cap_bp_profile_sidebars\";s:7:\"default\";s:27:\"cap_bp_profiles_avatar_size\";s:0:\"\";s:25:\"cap_bp_profiles_nav_order\";s:0:\"\";s:20:\"cap_bp_groups_header\";s:2:\"on\";s:22:\"cap_bp_groups_sidebars\";s:7:\"default\";s:25:\"cap_bp_groups_avatar_size\";s:0:\"\";s:23:\"cap_bp_groups_nav_order\";s:0:\"\";s:25:\"cap_enable_slideshow_home\";s:4:\"home\";s:17:\"cap_slideshow_img\";s:0:\"\";s:23:\"cap_slideshow_small_img\";s:0:\"\";s:17:\"cap_slideshow_cat\";s:6:\"a:0:{}\";s:20:\"cap_slideshow_amount\";s:0:\"\";s:23:\"cap_slideshow_post_type\";s:0:\"\";s:23:\"cap_slideshow_show_page\";s:0:\"\";s:18:\"cap_slideshow_time\";s:0:\"\";s:21:\"cap_slideshow_orderby\";s:0:\"\";s:19:\"cap_slideshow_style\";s:7:\"default\";s:21:\"cap_slideshow_caption\";s:2:\"on\";s:20:\"cap_slideshow_shadow\";s:14:\"sharper shadow\";s:26:\"cap_slideshow_direct_links\";s:2:\"no\";s:17:\"cap_overwrite_css\";s:0:\"\";s:20:\"cap_general_min_role\";s:13:\"switch_themes\";s:19:\"cap_header_min_role\";s:13:\"switch_themes\";s:17:\"cap_menu_min_role\";s:13:\"switch_themes\";s:21:\"cap_sidebars_min_role\";s:13:\"switch_themes\";s:19:\"cap_footer_min_role\";s:13:\"switch_themes\";s:23:\"cap_buddypress_min_role\";s:13:\"switch_themes\";s:20:\"cap_profile_min_role\";s:13:\"switch_themes\";s:19:\"cap_groups_min_role\";s:13:\"switch_themes\";s:22:\"cap_slideshow_min_role\";s:13:\"switch_themes\";s:22:\"cap_overwrite_min_role\";s:13:\"switch_themes\";s:35:\"cap_roles_and_capabilities_min_role\";s:13:\"switch_themes\";}", "yes");
INSERT INTO `wp_options` VALUES("216", "_site_transient_timeout_poptags_40cd750bba9870f18aada2478b24840a", "1378156306", "yes");
INSERT INTO `wp_options` VALUES("217", "_site_transient_poptags_40cd750bba9870f18aada2478b24840a", "a:40:{s:6:\"widget\";a:3:{s:4:\"name\";s:6:\"widget\";s:4:\"slug\";s:6:\"widget\";s:5:\"count\";s:4:\"3898\";}s:4:\"post\";a:3:{s:4:\"name\";s:4:\"Post\";s:4:\"slug\";s:4:\"post\";s:5:\"count\";s:4:\"2456\";}s:6:\"plugin\";a:3:{s:4:\"name\";s:6:\"plugin\";s:4:\"slug\";s:6:\"plugin\";s:5:\"count\";s:4:\"2344\";}s:5:\"admin\";a:3:{s:4:\"name\";s:5:\"admin\";s:4:\"slug\";s:5:\"admin\";s:5:\"count\";s:4:\"1930\";}s:5:\"posts\";a:3:{s:4:\"name\";s:5:\"posts\";s:4:\"slug\";s:5:\"posts\";s:5:\"count\";s:4:\"1856\";}s:7:\"sidebar\";a:3:{s:4:\"name\";s:7:\"sidebar\";s:4:\"slug\";s:7:\"sidebar\";s:5:\"count\";s:4:\"1583\";}s:7:\"twitter\";a:3:{s:4:\"name\";s:7:\"twitter\";s:4:\"slug\";s:7:\"twitter\";s:5:\"count\";s:4:\"1329\";}s:6:\"google\";a:3:{s:4:\"name\";s:6:\"google\";s:4:\"slug\";s:6:\"google\";s:5:\"count\";s:4:\"1325\";}s:8:\"comments\";a:3:{s:4:\"name\";s:8:\"comments\";s:4:\"slug\";s:8:\"comments\";s:5:\"count\";s:4:\"1310\";}s:6:\"images\";a:3:{s:4:\"name\";s:6:\"images\";s:4:\"slug\";s:6:\"images\";s:5:\"count\";s:4:\"1260\";}s:4:\"page\";a:3:{s:4:\"name\";s:4:\"page\";s:4:\"slug\";s:4:\"page\";s:5:\"count\";s:4:\"1225\";}s:5:\"image\";a:3:{s:4:\"name\";s:5:\"image\";s:4:\"slug\";s:5:\"image\";s:5:\"count\";s:4:\"1121\";}s:9:\"shortcode\";a:3:{s:4:\"name\";s:9:\"shortcode\";s:4:\"slug\";s:9:\"shortcode\";s:5:\"count\";s:4:\"1000\";}s:8:\"facebook\";a:3:{s:4:\"name\";s:8:\"Facebook\";s:4:\"slug\";s:8:\"facebook\";s:5:\"count\";s:3:\"982\";}s:5:\"links\";a:3:{s:4:\"name\";s:5:\"links\";s:4:\"slug\";s:5:\"links\";s:5:\"count\";s:3:\"974\";}s:3:\"seo\";a:3:{s:4:\"name\";s:3:\"seo\";s:4:\"slug\";s:3:\"seo\";s:5:\"count\";s:3:\"950\";}s:9:\"wordpress\";a:3:{s:4:\"name\";s:9:\"wordpress\";s:4:\"slug\";s:9:\"wordpress\";s:5:\"count\";s:3:\"844\";}s:7:\"gallery\";a:3:{s:4:\"name\";s:7:\"gallery\";s:4:\"slug\";s:7:\"gallery\";s:5:\"count\";s:3:\"821\";}s:6:\"social\";a:3:{s:4:\"name\";s:6:\"social\";s:4:\"slug\";s:6:\"social\";s:5:\"count\";s:3:\"780\";}s:3:\"rss\";a:3:{s:4:\"name\";s:3:\"rss\";s:4:\"slug\";s:3:\"rss\";s:5:\"count\";s:3:\"722\";}s:7:\"widgets\";a:3:{s:4:\"name\";s:7:\"widgets\";s:4:\"slug\";s:7:\"widgets\";s:5:\"count\";s:3:\"686\";}s:6:\"jquery\";a:3:{s:4:\"name\";s:6:\"jquery\";s:4:\"slug\";s:6:\"jquery\";s:5:\"count\";s:3:\"681\";}s:5:\"pages\";a:3:{s:4:\"name\";s:5:\"pages\";s:4:\"slug\";s:5:\"pages\";s:5:\"count\";s:3:\"678\";}s:5:\"email\";a:3:{s:4:\"name\";s:5:\"email\";s:4:\"slug\";s:5:\"email\";s:5:\"count\";s:3:\"623\";}s:4:\"ajax\";a:3:{s:4:\"name\";s:4:\"AJAX\";s:4:\"slug\";s:4:\"ajax\";s:5:\"count\";s:3:\"615\";}s:5:\"media\";a:3:{s:4:\"name\";s:5:\"media\";s:4:\"slug\";s:5:\"media\";s:5:\"count\";s:3:\"595\";}s:10:\"javascript\";a:3:{s:4:\"name\";s:10:\"javascript\";s:4:\"slug\";s:10:\"javascript\";s:5:\"count\";s:3:\"572\";}s:5:\"video\";a:3:{s:4:\"name\";s:5:\"video\";s:4:\"slug\";s:5:\"video\";s:5:\"count\";s:3:\"570\";}s:10:\"buddypress\";a:3:{s:4:\"name\";s:10:\"buddypress\";s:4:\"slug\";s:10:\"buddypress\";s:5:\"count\";s:3:\"541\";}s:4:\"feed\";a:3:{s:4:\"name\";s:4:\"feed\";s:4:\"slug\";s:4:\"feed\";s:5:\"count\";s:3:\"539\";}s:7:\"content\";a:3:{s:4:\"name\";s:7:\"content\";s:4:\"slug\";s:7:\"content\";s:5:\"count\";s:3:\"530\";}s:5:\"photo\";a:3:{s:4:\"name\";s:5:\"photo\";s:4:\"slug\";s:5:\"photo\";s:5:\"count\";s:3:\"522\";}s:4:\"link\";a:3:{s:4:\"name\";s:4:\"link\";s:4:\"slug\";s:4:\"link\";s:5:\"count\";s:3:\"506\";}s:6:\"photos\";a:3:{s:4:\"name\";s:6:\"photos\";s:4:\"slug\";s:6:\"photos\";s:5:\"count\";s:3:\"505\";}s:5:\"login\";a:3:{s:4:\"name\";s:5:\"login\";s:4:\"slug\";s:5:\"login\";s:5:\"count\";s:3:\"471\";}s:4:\"spam\";a:3:{s:4:\"name\";s:4:\"spam\";s:4:\"slug\";s:4:\"spam\";s:5:\"count\";s:3:\"458\";}s:5:\"stats\";a:3:{s:4:\"name\";s:5:\"stats\";s:4:\"slug\";s:5:\"stats\";s:5:\"count\";s:3:\"453\";}s:8:\"category\";a:3:{s:4:\"name\";s:8:\"category\";s:4:\"slug\";s:8:\"category\";s:5:\"count\";s:3:\"452\";}s:7:\"youtube\";a:3:{s:4:\"name\";s:7:\"youtube\";s:4:\"slug\";s:7:\"youtube\";s:5:\"count\";s:3:\"436\";}s:7:\"comment\";a:3:{s:4:\"name\";s:7:\"comment\";s:4:\"slug\";s:7:\"comment\";s:5:\"count\";s:3:\"432\";}}", "yes");
INSERT INTO `wp_options` VALUES("226", "_site_transient_update_plugins", "O:8:\"stdClass\":2:{s:12:\"last_checked\";i:1378576191;s:8:\"response\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("219", "duplicator_settings", "a:4:{s:7:\"version\";s:5:\"0.4.6\";s:18:\"uninstall_settings\";b:1;s:15:\"uninstall_files\";b:1;s:16:\"uninstall_tables\";b:1;}", "yes");
INSERT INTO `wp_options` VALUES("220", "duplicator_version_plugin", "0.4.6", "yes");
INSERT INTO `wp_options` VALUES("221", "duplicator_options", "s:217:\"a:9:{s:6:\"dbhost\";s:9:\"localhost\";s:6:\"dbname\";s:0:\"\";s:6:\"dbuser\";s:0:\"\";s:7:\"url_new\";s:0:\"\";s:8:\"email-me\";s:1:\"0\";s:12:\"email_others\";s:0:\"\";s:10:\"dir_bypass\";s:0:\"\";s:9:\"log_level\";s:1:\"0\";s:8:\"skip_ext\";s:0:\"\";}\";", "yes");
INSERT INTO `wp_options` VALUES("222", "duplicator_pack_passcount", "0", "yes");
INSERT INTO `wp_options` VALUES("223", "duplicator_add1_passcount", "0", "yes");
INSERT INTO `wp_options` VALUES("224", "duplicator_add1_clicked", "0", "yes");
INSERT INTO `wp_options` VALUES("225", "recently_activated", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("227", "cc_hide_activation_message", "yes", "yes");
INSERT INTO `wp_options` VALUES("319", "category_children", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("353", "_transient_feed_mod_b9388c83948825c1edaef0d856b7b109", "1378575956", "no");
INSERT INTO `wp_options` VALUES("354", "_transient_timeout_feed_77fa140e07ce53fe8c87136636f83d72", "1378619156", "no");
INSERT INTO `wp_options` VALUES("355", "_transient_feed_77fa140e07ce53fe8c87136636f83d72", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n	\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:72:\"\n		\n		\n		\n		\n		\n		\n				\n\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"WordPress Plugins » View: Newest\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"http://wordpress.org/plugins/browse/new/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"WordPress Plugins » View: Newest\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 07 Sep 2013 17:27:04 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"http://bbpress.org/?v=1.1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:15:{i:0;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:26:\"Custom Post Type Auto Menu\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"http://wordpress.org/plugins/custom-post-type-auto-menu/#post-57765\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 28 Aug 2013 21:55:15 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"57765@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:100:\"Automatically create menu items for your custom post types in your chosen menu and parent menu item.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"badfun\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:24:\"Disable JPEG Compression\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:65:\"http://wordpress.org/plugins/disable-jpeg-compression/#post-57860\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 31 Aug 2013 16:26:48 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"57860@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:104:\"Here is a short description of the plugin.  This should be no more than 150 characters.  No markup here.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Scolpy\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"Text Advertisements\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"http://wordpress.org/plugins/text-advertisements/#post-57882\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 01 Sep 2013 23:02:29 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"57882@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"Easily put your advertisement link in every where of wordpress theme\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Arash Heidari\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"Simple Picture Menu\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"http://wordpress.org/plugins/simple-picture-menu/#post-57757\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 28 Aug 2013 16:12:12 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"57757@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:122:\"A menu bar placed on any side of the screen to create a picture based bar, for users to navigate through out your website.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Loganw\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"Provide Support Live Chat\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"http://wordpress.org/plugins/provide-support-live-chat/#post-57906\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 02 Sep 2013 05:53:50 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"57906@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:147:\"This plugin will help you to add your Provide Support Live Chat button to your WordPress website. Make one more step to excellent customer service.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"Provide Support, LLC\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:41:\"Force First and Last Name as Display Name\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"http://wordpress.org/plugins/force-first-last/#post-57964\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 04 Sep 2013 01:13:08 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"57964@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:513:\"<p>The display name dropdown is hidden from users. Instead, it is always set to their first and last name, or username if those fields are empty.</p>\n<p>Display names are updated at registration or when a user profile is updated. To update existing users, visit Settings --&#62; Force First Last and click on the link to run an initial update on your users.</p>\n<p>On GitHub: <a href=\"https://github.com/strangerstudios/force-first-last\" rel=\"nofollow\">https://github.com/strangerstudios/force-first-last</a>\n</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"strangerstudios\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sample Slider\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"http://wordpress.org/plugins/sample-slider/#post-57558\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 24 Aug 2013 10:45:27 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"57558@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"Very basic shortcode based plugin.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"mitali.cyrus\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"WooCommerce HSS Extension for Streaming Video\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:86:\"http://wordpress.org/plugins/woocommerce-hss-extension-for-streaming-video/#post-57931\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 03 Sep 2013 02:21:49 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"57931@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:132:\"Sell access to streaming videos through WordPress by integrating the HostStreamSell video platform with the great WooCommerce plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"hoststreamsell\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Really Simple Guest Post Plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:65:\"http://wordpress.org/plugins/really-simple-guest-post/#post-57909\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 02 Sep 2013 08:45:40 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"57909@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:109:\"Really Simple Guest Post Plugin will help you to generate a guest posting form in the simple and easiest way.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Ataul Ghani\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:26:\"Attachment Page Redirect X\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"http://wordpress.org/plugins/attachment-page-redirect-x/#post-56574\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 29 Jul 2013 07:36:22 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"56574@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:107:\"Redirect attachment pages to their parent page (301), when possible, otherwise to the blog home page (302).\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Beej\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Inn Style Widget\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"http://wordpress.org/plugins/inn-style-widget/#post-57907\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 02 Sep 2013 06:53:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"57907@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:26:\"Inn Style WordPress Widget\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Ian Tearle\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"WP e-Customers Beta\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/plugins/wp-e-customers/#post-57577\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 25 Aug 2013 00:45:33 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"57577@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"WP e-Customers Beta by WebTechGlobal\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"WebTechGlobal\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"Facebook Auto Publish\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"http://wordpress.org/plugins/facebook-auto-publish/#post-57910\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 02 Sep 2013 09:43:26 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"57910@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"Publish posts automatically to Facebook page or profile.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"f1logic\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Rift Slider\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"http://wordpress.org/plugins/rift-slider/#post-57878\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 01 Sep 2013 17:39:58 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"57878@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"Rift Slider is an awesome response slider which splits and rotates your slides.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"syntaxart\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"BackupToAzure\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"http://wordpress.org/plugins/backuptoazure/#post-57313\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 18 Aug 2013 05:49:13 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"57313@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:95:\"A wordpress plugin that takes backup of your wordpress site to Microsoft Windows Azure Storage.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"backuptoazure\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:41:\"http://wordpress.org/plugins/rss/view/new\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:10:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Sat, 07 Sep 2013 17:45:56 GMT\";s:12:\"content-type\";s:23:\"text/xml; charset=UTF-8\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:7:\"expires\";s:29:\"Sat, 07 Sep 2013 18:02:04 GMT\";s:13:\"cache-control\";s:0:\"\";s:6:\"pragma\";s:0:\"\";s:13:\"last-modified\";s:31:\"Sat, 07 Sep 2013 17:27:04 +0000\";s:4:\"x-nc\";s:11:\"HIT lax 249\";}s:5:\"build\";s:14:\"20130902175941\";}", "no");
INSERT INTO `wp_options` VALUES("344", "_transient_timeout_feed_867bd5c64f85878d03a060509cd2f92c", "1378619156", "no");
INSERT INTO `wp_options` VALUES("345", "_transient_feed_867bd5c64f85878d03a060509cd2f92c", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:61:\"\n	\n	\n	\n	\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"WordPress Planet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://planet.wordpress.org/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:2:\"en\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"WordPress Planet - http://planet.wordpress.org/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:50:{i:0;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:61:\"WordPress.tv: John James Jacoby: Wonderful WordPress Workflow\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=21690\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"http://wordpress.tv/2013/09/07/john-james-jacoby-wonderful-wordpress-workflow/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:689:\"<div id=\"v-gJv1BHf5-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/21690/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/21690/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=21690&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/09/07/john-james-jacoby-wonderful-wordpress-workflow/\"><img alt=\"John James Jacoby: Wonderful WordPress Workflowkflow\" src=\"http://videos.videopress.com/gJv1BHf5/wonderful-wordpress-workflow_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 07 Sep 2013 11:03:52 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:82:\"WordPress.tv: Brennen Byrne: Employing Best Security Practices for WordPress Sites\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=21716\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:99:\"http://wordpress.tv/2013/09/07/brennen-byrne-employing-best-security-practices-for-wordpress-sites/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:731:\"<div id=\"v-lQSifts6-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/21716/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/21716/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=21716&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/09/07/brennen-byrne-employing-best-security-practices-for-wordpress-sites/\"><img alt=\"Brennen Byrne: Employing Best Security Practices for WordPress Sites\" src=\"http://videos.videopress.com/lQSifts6/employing-best-security-practices_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 07 Sep 2013 10:49:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"WPTavern: Password Free Login With Clef Hits All The High Notes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=8766\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:115:\"http://feedproxy.google.com/~r/WordpressTavern/~3/n04-e-RlBu8/password-free-login-with-clef-hits-all-the-high-notes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4953:\"<p>Recently I have been reviewing a number of wp-admin login alternatives that allow for login via phone. The first among the plugins tested was <a title=\"LaunchKey WordPress Plugin\" href=\"http://wordpress.org/plugins/launchkey/\" target=\"_blank\">LaunchKey</a>, which I spoke about in this <a title=\"LaunchKey Review\" href=\"http://www.wptavern.com/the-daily-plugin-launchkey-user-languages-buy-him-a-beer\" target=\"_blank\">LaunchKey Review</a> post. Though the functionality of LaunchKey was promising, it seemed to explode on the launching pad when it came to initial setup. Even with the valiant efforts in an hour-long back-and-forth exchange with their support team on Twitter to get me going, it seemed that the setup challenges were the biggest obstacles. It was so frustrating that I opted to delete LaunchKey altogether and forever give up on the idea of secure, remote smartphone-enabled logins. <span id=\"more-8766\"></span></p>\n<p>Sensing my frustration and desire to get this technology implemented in my installations, the team over at <a title=\"Clef Home Page\" href=\"http://getclef.com\" target=\"_blank\">GetClef.com</a> decided to get to work. They created something for me that not only had every piece of functionality that I was looking for, but they did it with an installation process that took no more than 60 seconds to install the app on my iPhone, install the plugin and have them both talking to each other. OK, so they didn&#8217;t create it for me specifically, but from how beautifully this integrates, it sure feels like they completely read my mind in regards to the functionality and ease of use that I was looking for!</p>\n<p>To begin, you simply navigate to the Clef app page which asks for your mobile number. Once entered, Clef will text you the link to install the app on your phone. Currently both iOS and Android versions are available for integration with the Clef plugin. Once installed, the app will have you set up a pin number to protect anyone from using it to login to your sites. So even if you lose your phone, you won&#8217;t have to worry that someone out there can login to all your sites.</p>\n<p><a title=\"Clef\" href=\"http://wordpress.org/plugins/wpclef/\" target=\"_blank\">Clef</a> is touted as the simplest way to login to multiple sites without passwords in a secure, encrypted way that is as easy to use as taking a photo. Here&#8217;s Clef&#8217;s <a title=\"Brenned Byrne on Twitter\" href=\"https://twitter.com/brennenbyrne\" target=\"_blank\">Brennen Byrne</a> giving us a quick walk-through on how the system works and what it does.</p>\n<div class=\"aligncenter\"></div>\n<p>As stated in the video, one scan of the QR code enables complete login of <strong>ALL</strong> your WordPress installations. If you login to one site that is Clef-Enabled, you have access to every other Clef-capable site in your network without having to login again. I can&#8217;t stress enough how much of a time-saving feature this is. Often I work with collaboration teams and outsource workers that often require access to one or several of my WordPress web properties. This tool allows me to easily add and remove credentials for an individual within Clef on a network wide basis, so I can assign a person specific properties to work on. When they are finished with the tasks and milestones assigned, I can simply remove them network wide and not have to be burdened to login to each individual site to remove the user credentials or their permissions.</p>\n<p>From a designer and developer perspective, this is a really great selling point to include in your design proposals and specs to clients. Larger companies and organizations can easily manage user roles and login capabilities by implementing Clef for their WordPress installs. It&#8217;s just one more tool that gives WordPress the decided advantage over using other CMS platforms.</p>\n<p>Let&#8217;s also talk about the security reinforcement of this app/plugin combo. How many of you out there use the same admin password for all your installations? Come on, I know there are lots of you out there that do this. It&#8217;s a bad practice to get into because once one of your sites is compromised, they all are. Most of us don&#8217;t like to use different passwords, especially if our network is 50-100 installations deep. Clef can make it easier for you to keep your logins in one place without exposing yourself by using duplicate passwords across your network.</p>\n<p>Even if you are just passively intrigued at the concept of remote gadget WordPress logins, Clef is worth investigating. With remarkably quick setup and ease of use, this plugin has earned a permanent spot in my everyday plugin roster. I love the advancements that WordPress is making with device integration and Clef is just another great reinforcement as to why we love using WordPress so much!</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/n04-e-RlBu8\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 06 Sep 2013 23:00:11 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Marcus Couch\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"WPTavern: 7 Surprising Results From The 2013 BuddyPress Codex Survey\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=8885\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:120:\"http://feedproxy.google.com/~r/WordpressTavern/~3/8TOECMZ944s/7-surprising-results-from-the-2013-buddypress-codex-survey\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:7031:\"<p>The results of the BuddyPress codex survey are in! 178 BuddyPress developers participated in the survey and the information they provided will help the team to prioritize short-term and long-term tasks for improving the BP Codex. Community developers <a href=\"http://buddypress.org/community/members/hnla/\" target=\"_blank\">@hnla</a> and <a href=\"http://buddypress.org/community/members/mercime/\" target=\"_blank\">@mercime</a> are spearheading the effort to improve the BuddyPress codex for the BP 1.9 release.</p>\n<p>While this survey is packed full of fascinating <a href=\"http://buddypress.org/2013/09/2013-buddypress-codex-survey-results/\" target=\"_blank\">results</a>, I&#8217;d like to highlight just a few of them here:<span id=\"more-8885\"></span></p>\n<h2>Nearly 50% of BuddyPress sites are in languages other than English.</h2>\n<p>Respondents hailed from 36 different countries and results show that 56% of BuddyPress sites are built using English as the language and the other half is comprised of various languages from around the world. The top 10 include:  1) English (56%), 2) Spanish, 3) Italian, 4) French, 5) German, 6) Dutch, 7) Swedish, 8) Portugese, 9) Chinese, and 10) Greek.</p>\n<p><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/09/international.jpg\" rel=\"thumbnail\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/09/international.jpg?resize=560%2C307\" alt=\"international\" class=\"aligncenter size-full wp-image-8920\" /></a></p>\n<p>It&#8217;s clear to see that BuddyPress is an international community. We&#8217;re spread out all over the globe! If you&#8217;re a BuddyPress plugin developer, you need to <a href=\"http://buddypress.org/support/topic/localize-your-buddypress-plugins/\" target=\"_blank\">localize your plugins</a>. Hopefully we can include some more detailed references on localization when it comes time to revamp the codex.</p>\n<h2>Only 15% of BuddyPress sites surveyed make use of the Friends component.</h2>\n<p>When you think about social networks, oftentimes the friends component is what you might assume would be the most important. This survey reveals otherwise:</p>\n<p><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/09/components.jpg\" rel=\"thumbnail\"><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/09/components.jpg?resize=493%2C291\" alt=\"components\" class=\"aligncenter size-full wp-image-8925\" /></a></p>\n<p>I was surprised that the Groups component wasn&#8217;t activated on more sites, as it is probably the most flexible and has the most extensions. These numbers might indicate that many people are using BuddyPress for its more robust profile and account management capabilities, rather than for its social features. Not one of the social components reached more than 20%.</p>\n<h2>90% of BuddyPress developers surveyed are male.</h2>\n<p><a href=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/09/gender.jpg\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/09/gender.jpg?resize=560%2C118\" alt=\"gender\" class=\"aligncenter size-full wp-image-8930\" /></a></p>\n<p>Do these numbers surprise you? I would have imagined there would be a few more female developers who responded, but perhaps the survey did not reach them. However, these numbers really should not deter female developers from getting involved. From my experience attending BuddyCamp Vancouver, the BuddyPress community is made up of some of the nicest people you will ever meet. Even in the support forums you will find that people are generally very welcoming and helpful to new developers. BuddyPress is still a relatively small community and it&#8217;s easy to start getting involved and making a difference.</p>\n<h2>People prefer to learn BuddyPress through written tutorials.</h2>\n<p><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/09/tutorials.jpg\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/09/tutorials.jpg?resize=560%2C301\" alt=\"tutorials\" class=\"aligncenter size-full wp-image-8939\" /></a></p>\n<p>This has been my suspicion for awhile and now it is confirmed. Developers are not looking for fancy video tutorials and they are only marginally interested in books and in-person training when it comes to learning about BuddydPress. They want written tutorials, references and guides that they can quickly scan and come back to when needed.</p>\n<h2>39% of BuddyPress sites are installed within a WordPress multisite network.</h2>\n<p><a href=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/09/bp-site-root.jpg\" rel=\"thumbnail\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/09/bp-site-root.jpg?resize=560%2C408\" alt=\"bp-site-root\" class=\"aligncenter size-full wp-image-8933\" /></a></p>\n<p>Perhaps this one isn&#8217;t much of a surprise, given that in the beginning you could only use BuddyPress with WordPress multisite. After BuddyPress was made to be compatible with single site WordPress installations, one would have thought that they would become the vast majority, since it&#8217;s the easiest way to set up WordPress. But it appears that usage on multisite vs. single site is almost 50/50. What this tells me is that blogs are still a very important aspect of BuddyPress social networks. </p>\n<p>What does this mean for the codex? We absolutely need more documentation on using BuddyPress within a multisite environment. </p>\n<h2>The biggest complaint about the codex is that the documentation is incomplete and difficult to navigate.</h2>\n<p><a href=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/09/codex-issues.jpg\" rel=\"thumbnail\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/09/codex-issues.jpg?resize=560%2C306\" alt=\"codex-issues\" class=\"aligncenter size-full wp-image-8937\" /></a></p>\n<p>It looks like the largest task at hand will be to fill in any bald spots in the codex and improve the navigation. It&#8217;s not so much that the content is unclear or outdated but rather it&#8217;s just not there at all. Creating new sections and adding to existing ones will probably be the main focus in improving the codex.</p>\n<h2>35% of BuddyPress developers surveyed are willing to contribute to the codex.</h2>\n<p>Wow, that&#8217;s an amazing response from the BuddyPress community developers who are ready and willing to help make the codex a more useful resource. Many thanks to <a href=\"http://buddypress.org/community/members/hnla/\" target=\"_blank\">@hnla</a> and <a href=\"http://buddypress.org/community/members/mercime/\" target=\"_blank\">@mercime</a> for all their hard work in analyzing the responses from the survey and providing these handy graphs for these results. By far, one of the biggest complaints about BuddyPress is the lack of documentation. With all the capable volunteers stepping forward, things are about to change for the better.</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/8TOECMZ944s\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 06 Sep 2013 22:24:48 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"WPTavern: Coming Soon: Inline Documentation For All WordPress Hooks\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=8832\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:118:\"http://feedproxy.google.com/~r/WordpressTavern/~3/Zf81S3bXaFY/coming-soon-inline-documentation-for-all-wordpress-hooks\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3412:\"<p><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/09/all-the-hooks.png\" rel=\"thumbnail\"><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/09/all-the-hooks.png?resize=299%2C298\" alt=\"all-the-hooks\" class=\"alignright size-full wp-image-8851\" /></a>Something exciting is happening in the world of WordPress documentation. Very soon all of the hooks used throughout the core are going to be documented. An initiative is now underway to bring inline docs for hooks into the upcoming WordPress 3.7 release. I can see some of you jumping up and down and celebrating wildly right now. But there are probably more than a few of you who are wondering <strong>&#8220;What in the world is a hook?&#8221;</strong><span id=\"more-8832\"></span></p>\n<p>You will see the terms &#8220;actions/filters&#8221; and &#8220;hooks&#8221; throughout the codex and it can get a little confusing. Hooks are split into <a href=\"http://codex.wordpress.org/Plugin_API/Action_Reference\" title=\"WordPress Action Reference\" target=\"_blank\">actions</a> and <a href=\"http://codex.wordpress.org/Plugin_API/Filter_Reference\" title=\"WordPress Filter Reference\" target=\"_blank\">filters</a>. Essentially, hooks are events that allow you to &#8220;hook&#8221; into WordPress and make it do stuff. The codex <a href=\"http://codex.wordpress.org/Plugin_API/Action_Reference\" title=\"Codex Action Reference\" target=\"_blank\">Plugin API/Action Reference</a> page lists all existing hooks, some of which have been documented.</p>\n<p>Inline documentation of hooks will make it much easier for developers to extend WordPress. Each hook gets a quick explanation and the @since version added as a comment. For example, check out the notes for <em>do_action( &#8216;welcome_panel&#8217; );</em></p>\n<p><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/09/welcome-panel.jpg\" rel=\"thumbnail\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/09/welcome-panel.jpg?resize=560%2C329\" alt=\"welcome-panel\" class=\"aligncenter size-full wp-image-8882\" /></a></p>\n<p>If you wanted to add some content to the WordPress welcome panel but didn&#8217;t know how, this inline documentation will help to point you in the right direction.</p>\n<p>A handful of contributors are currently tackling a massive list of hooks in 195 files. If you can help, leave a comment on the <a href=\"http://make.wordpress.org/core/2013/09/05/add-inline-docs-for-hooks/\" target=\"_blank\">make.wordpress.org</a> post to claim the files you&#8217;ll be working on and then add separate patches for each to the <a href=\"http://core.trac.wordpress.org/ticket/25229\" target=\"_blank\">Add Inline Docs for Hooks</a> trac ticket. Make sure to review the <a href=\"http://make.wordpress.org/core/handbook/inline-documentation-standards/php-documentation-standards/#4-hooks-actions-and-filters\" target=\"_blank\">hook documentation standards</a> before submitting a patch.</p>\n<p>Developers always say that if you want to learn WordPress, the best way to start is by going through the core to find out how it all works. Inline documentation for hooks will make this easier than ever. Although it&#8217;s a monumental task to coordinate, the end result is that WordPress will be much more approachable for developers who are new to the platform.</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/Zf81S3bXaFY\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 06 Sep 2013 14:00:55 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:119:\"WordPress.tv: T. Michael Tracy: What’s the WebGL Thing? An Introduction to Using Interactive 3D Graphics in WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=21726\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:131:\"http://wordpress.tv/2013/09/06/t-michael-tracy-whats-the-webgl-thing-an-introduction-to-using-interactive-3d-graphics-in-wordpress/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:803:\"<div id=\"v-bOhqwEtF-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/21726/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/21726/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=21726&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/09/06/t-michael-tracy-whats-the-webgl-thing-an-introduction-to-using-interactive-3d-graphics-in-wordpress/\"><img alt=\"T. Michael Tracy: What’s the WebGL Thing? An Introduction to Using Interactive 3D Graphics in WordPress\" src=\"http://videos.videopress.com/bOhqwEtF/web-gl-interactive-3d-graphics-in-wp_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 06 Sep 2013 10:44:45 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"WordPress.tv: Dave Ross: Optimize Image Files Like a Pro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=21728\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"http://wordpress.tv/2013/09/06/dave-ross-optimize-image-files-like-a-pro/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:672:\"<div id=\"v-TqDCJmoq-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/21728/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/21728/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=21728&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/09/06/dave-ross-optimize-image-files-like-a-pro/\"><img alt=\"Dave Ross: Optimize Image Files Like a Pro\" src=\"http://videos.videopress.com/TqDCJmoq/optimize-image-files_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 06 Sep 2013 10:43:21 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"BuddyPress: 2013 BuddyPress Codex Survey Results\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://buddypress.org/?p=170911\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"http://buddypress.org/2013/09/2013-buddypress-codex-survey-results/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:32403:\"<p>This report presents the results from the 2013 BuddyPress Codex Survey held from August 16 &#8211; 26, 2013. One hundred seventy-eight developers from thirty-six countries responded to provide valuable information about BP usage and documentation requirements. Thank you all.</p>\n<h3>A. Background</h3>\n<p>At the beginning of the development cycle for BP version 1.9, <a href=\"http://buddypress.org/community/members/hnla/\" rel=\"nofollow\">@hnla</a> and <a href=\"http://buddypress.org/community/members/mercime/\" rel=\"nofollow\">@mercime</a> were put in charge of improving the current BP Codex. Feedback was scarce on the proposed codex outline and the timeline posted by <a href=\"http://buddypress.org/community/members/hnla/\" rel=\"nofollow\">@hnla</a> at <a href=\"http://bpdevel.wordpress.com\" title=\"bpdevel.wordpress.com\">bpdevel.wordpress.com</a>. It was at this stage that the decision was made to create and deploy a BP codex survey even when it was not originally included in the timeline.</p>\n<h3>B. Goal of Survey</h3>\n<p>Gather data to determine priority tasks and to identify resources necessary to complete the project to clean up and refresh the BP codex.</p>\n<p>Objectives:</p>\n<ul>\n<li>Improve information architecture of BP Codex</li>\n<li>Learn more about BP usage to assess information requirements of the community</li>\n<li>Determine users’ preferred methods of learning BP to prioritize short-term and long-term tasks</li>\n<li>Identify developers who are willing to author articles in BP Codex</li>\n</ul>\n<p><span id=\"more-170911\"></span></p>\n<h3>C. Survey Design/Method</h3>\n<p>The first-ever BP survey included 21 questions in three sections namely: You and BuddyPress (8), BP codex (10), and about the survey (3). In effect, questions were designed to gather feedback on the usability of current available documentation with regards to the survey’s goal and objectives mentioned above. A wide variety of survey question types were employed to gather the data required: multiple choices, check boxes, matrices, and open‐ended/comments.</p>\n<p>The survey was originally designed using Google Forms and submitted to the BP Project/Lead Developers for comments/approval. Upon approval, the survey was copied over to the Polldaddy.com account for public access. Huge props to Siobhan McKeown (<a href=\"http://buddypress.org/community/members/siobhan/\" rel=\"nofollow\">@siobhan</a>) for the survey consult. Special thanks to Automattic and Polldaddy.com for the upgraded account.</p>\n<p>Polldaddy, the survey tool used, has excellent reporting and filtering functions available in real time with quantitative data and allowed for the export of such data in different file formats. Additional chart types, tag clouds and further analyses of qualitative data collected from the survey were implemented using Microsoft Excel, Google Charts and tagxedo.com.</p>\n<h3>D. Survey Results</h3>\n<p><strong>General Information</strong>: One hundred seventy-eight BP developers/designers from thirty-six countries participated in this survey. The majority of respondents (37%) took the survey in the United States, followed by Germany (6%) then Italy, United Kingdom and Australia at 4% each. Of those respondents from the U.S., 28% took the survey in California, followed by New York (5%), then New Jersey and Massachusetts at 4% each.</p>\n<p><a href=\"http://mercime.files.wordpress.com/2013/09/00-country1.jpg\"><img class=\"aligncenter size-full wp-image-901\" alt=\"00-country\" src=\"http://mercime.files.wordpress.com/2013/09/00-country1.jpg\" width=\"700\" height=\"383\" /></a></p>\n<p><strong>1. Gender: </strong></p>\n<p><a href=\"http://mercime.files.wordpress.com/2013/09/01-gender1.jpg\"><img class=\"aligncenter size-full wp-image-902\" alt=\"01-gender\" src=\"http://mercime.files.wordpress.com/2013/09/01-gender1.jpg\" width=\"700\" height=\"147\" /></a></p>\n<p><strong>2. Where did you first learn about BuddyPress?</strong></p>\n<p>Inclusion in the WP Plugin Repository brought about the largest number of BP users.<br />\nNote: &#8220;Google/Search&#8221; (7.3%) for social networks and &#8220;Cannot Remember&#8221;/not sure (5.1%) were brought out from the &#8220;Other Option&#8221; results to be included in comparison with other choices.</p>\n<p><a href=\"http://mercime.files.wordpress.com/2013/09/02-where-1st-learn1.jpg\"><img class=\"aligncenter size-full wp-image-903\" alt=\"02-where--1st-learn\" src=\"http://mercime.files.wordpress.com/2013/09/02-where-1st-learn1.jpg\" width=\"491\" height=\"294\" /></a></p>\n<p><strong>3. When did you first use BuddyPress in a site? (BP version)</strong></p>\n<p>BuddyPress alpha/beta to BP 1.1+ versions worked in WP Multi-User (WPMU) installations only and required manual transfer of theme folders.  The release of BuddyPress 1.2 expanded the user/developer base when BP could be used for both single WP and WPMU installations and one could install BP in three steps (no longer requiring  manual configuration of folders in server). BuddyPress 1.5 further expanded user/developer base with new features and component classes, enhancements and bug fixes and closed 1001 BP Trac tickets in all. </p>\n<p><a href=\"http://mercime.files.wordpress.com/2013/09/03-when-1stbpversion1.jpg\"><img class=\"aligncenter size-full wp-image-904\" alt=\"03-when-1stBPversion\" src=\"http://mercime.files.wordpress.com/2013/09/03-when-1stbpversion1.jpg\" width=\"700\" height=\"378\" /></a></p>\n<p><strong>4. How are you using BuddyPress?</strong></p>\n<p><a href=\"http://mercime.files.wordpress.com/2013/09/04-user-types1.jpg\"><img class=\"aligncenter size-full wp-image-905\" alt=\"04-user-types\" src=\"http://mercime.files.wordpress.com/2013/09/04-user-types1.jpg\" width=\"700\" height=\"314\" /></a></p>\n<p><strong>5. Where have you installed BuddyPress?</strong></p>\n<p><a href=\"http://mercime.files.wordpress.com/2013/09/05-bpinwp1.jpg\"><img class=\"aligncenter size-full wp-image-921\" alt=\"05-BPinWP\" src=\"http://mercime.files.wordpress.com/2013/09/05-bpinwp1.jpg\" width=\"700\" height=\"509\" /></a></p>\n<p><strong>6. What types of BuddyPress sites have you built?</strong></p>\n<p>This tag cloud incorporates the original types listed in the survey and all the other types added by the respondents in the &#8220;Other option&#8221; form. The top 10 types of BP networks created are: 1) Generic, 2) Academic, 3) Artistic, 4) Sports, 5) Gaming, 6) Religious, 7) Scientific, 8) Business, 9) Niche community, and 10) Non-profit.</p>\n<p><a href=\"http://mercime.files.wordpress.com/2013/09/06-bpsitetypes1.jpg\"><img class=\"aligncenter size-full wp-image-907\" alt=\"06-bpsitetypes\" src=\"http://mercime.files.wordpress.com/2013/09/06-bpsitetypes1.jpg\" width=\"700\" height=\"376\" /></a></p>\n<p><strong>7. In what language is your BuddyPress site?</strong></p>\n<p>This tag cloud incorporates the original languages listed in the survey and all the other languages added by the respondents in the &#8220;Other option&#8221; form. The top 10 languages used in BP installations are: 1) English (56%), 2) Spanish, 3) Italian, 4) French, 5) German, 6) Dutch, 7) Swedish, 8) Portugese, 9) Chinese, and 10) Greek.</p>\n<p><a href=\"http://mercime.files.wordpress.com/2013/09/07-what-lang-bpsite1.jpg\"><img class=\"aligncenter size-full wp-image-908\" alt=\"07-what-lang-BPsite\" src=\"http://mercime.files.wordpress.com/2013/09/07-what-lang-bpsite1.jpg\" width=\"699\" height=\"376\" /></a></p>\n<p><strong>8. What components and features are activated in your sites? (Default Active Components: Extended Profiles and Activity Streams)</strong></p>\n<p><a href=\"http://mercime.files.wordpress.com/2013/09/08-components-activated1.jpg\"><img class=\"aligncenter size-full wp-image-909\" alt=\"08-components-activated\" src=\"http://mercime.files.wordpress.com/2013/09/08-components-activated1.jpg\" width=\"493\" height=\"291\" /></a></p>\n<p><strong>9. What BuddyPress documentation do you currently use?</strong></p>\n<p><a href=\"http://mercime.files.wordpress.com/2013/09/09-documentation-used-curre1.jpg\"><img class=\"aligncenter size-full wp-image-910\" alt=\"09-documentation-used-curre\" src=\"http://mercime.files.wordpress.com/2013/09/09-documentation-used-curre1.jpg\" width=\"700\" height=\"340\" /></a></p>\n<p><strong>10. How would you prefer to learn BuddyPress?</strong></p>\n<p><a href=\"http://mercime.files.wordpress.com/2013/09/10-learning-preference1.jpg\"><img class=\"aligncenter size-full wp-image-911\" alt=\"10-learning-preference\" src=\"http://mercime.files.wordpress.com/2013/09/10-learning-preference1.jpg\" width=\"700\" height=\"955\" /></a></p>\n<p><strong>11. Where do you look first for answers to your BuddyPress questions?</strong></p>\n<p><a href=\"http://mercime.files.wordpress.com/2013/09/11-first-look1.jpg\"><img class=\"aligncenter size-full wp-image-912\" alt=\"11-first-look\" src=\"http://mercime.files.wordpress.com/2013/09/11-first-look1.jpg\" width=\"472\" height=\"295\" /></a></p>\n<p><strong>12. How useful is the current BuddyPress Codex?</strong></p>\n<p><a href=\"http://mercime.files.wordpress.com/2013/09/12-codex-usefulness.jpg\"><img class=\"aligncenter size-full wp-image-913\" alt=\"12-codex-usefulness\" src=\"http://mercime.files.wordpress.com/2013/09/12-codex-usefulness.jpg\" width=\"490\" height=\"301\" /></a></p>\n<p><strong>13. What sections of the current BuddyPress Codex do you find most useful?</strong></p>\n<p><a href=\"http://mercime.files.wordpress.com/2013/09/13-codex-useful-sections1.jpg\"><img class=\"aligncenter size-full wp-image-914\" alt=\"13-codex-useful-sections\" src=\"http://mercime.files.wordpress.com/2013/09/13-codex-useful-sections1.jpg\" width=\"645\" height=\"344\" /></a></p>\n<p><strong>14. What issues do you find in the BuddyPress Codex?</strong></p>\n<p><a href=\"http://mercime.files.wordpress.com/2013/09/14-codex-issues1.jpg\"><img class=\"aligncenter size-full wp-image-915\" alt=\"14-codex-issues\" src=\"http://mercime.files.wordpress.com/2013/09/14-codex-issues1.jpg\" width=\"611\" height=\"334\" /></a></p>\n<p><strong>15. What documentation would you like to see in the BuddyPress Codex?</strong></p>\n<p><a href=\"http://mercime.files.wordpress.com/2013/09/15-documentation-requested1.jpg\"><img class=\"aligncenter size-full wp-image-916\" alt=\"15-documentation-requested\" src=\"http://mercime.files.wordpress.com/2013/09/15-documentation-requested1.jpg\" width=\"700\" height=\"894\" /></a></p>\n<p><strong>16. Have you contributed to the BuddyPress Codex?</strong><br />\nYes: 13%. No: 87%.</p>\n<p><strong>17. Would you like to Contribute to the BuddyPress Codex?</strong><br />\nYes: 35%. No: 65%</p>\n<blockquote><p>Thirty-two developers/designers indicated interest in contributing to the BP codex.<br />\n<a href=\"http://buddypress.org/community/members/boonebgorges/\" rel=\"nofollow\">@boonebgorges</a>, <a href=\"http://buddypress.org/community/members/bowromir/\" rel=\"nofollow\">@bowromir</a>, @charisevl, <a href=\"http://buddypress.org/community/members/chouf1/\" rel=\"nofollow\">@chouf1</a>, <a href=\"http://buddypress.org/community/members/damoncook/\" rel=\"nofollow\">@damoncook</a>, <a href=\"http://buddypress.org/community/members/dcavins/\" rel=\"nofollow\">@dcavins</a>, <a href=\"http://buddypress.org/community/members/dcrabill/\" rel=\"nofollow\">@dcrabill</a>, <a href=\"http://buddypress.org/community/members/ddean/\" rel=\"nofollow\">@ddean</a>, <a href=\"http://buddypress.org/community/members/defries/\" rel=\"nofollow\">@defries</a>, <a href=\"http://buddypress.org/community/members/dianakc/\" rel=\"nofollow\">@dianakc</a>,  <a href=\"http://buddypress.org/community/members/djpaul/\" rel=\"nofollow\">@djpaul</a>, <a href=\"http://buddypress.org/community/members/espellcaste/\" rel=\"nofollow\">@espellcaste</a>, <a href=\"http://buddypress.org/community/members/grimmwerks/\" rel=\"nofollow\">@grimmwerks</a>, <a href=\"http://buddypress.org/community/members/hnla/\" rel=\"nofollow\">@hnla</a>, <a href=\"http://buddypress.org/community/members/imath/\" rel=\"nofollow\">@imath</a>, <a href=\"http://buddypress.org/community/members/jjones7/\" rel=\"nofollow\">@jjones7</a>, <a href=\"http://buddypress.org/community/members/johnjamesjacoby/\" rel=\"nofollow\">@johnjamesjacoby</a>,<a href=\"http://buddypress.org/community/members/karmatosed/\" rel=\"nofollow\">@karmatosed</a>, <a href=\"http://buddypress.org/community/members/mercime/\" rel=\"nofollow\">@mercime</a>, <a href=\"http://buddypress.org/community/members/pollyplummer/\" rel=\"nofollow\">@pollyplummer</a>, <a href=\"http://buddypress.org/community/members/r-a-y/\" rel=\"nofollow\">@r-a-y</a>, <a href=\"http://buddypress.org/community/members/themightymo/\" rel=\"nofollow\">@themightymo</a>, <a href=\"http://buddypress.org/community/members/sbrajesh/\" rel=\"nofollow\">@sbrajesh</a>, <a href=\"http://buddypress.org/community/members/slaffik/\" rel=\"nofollow\">@slaFFik</a>, <a href=\"http://buddypress.org/community/members/svenl77/\" rel=\"nofollow\">@svenl77</a>, <a href=\"http://buddypress.org/community/members/ubernaut/\" rel=\"nofollow\">@ubernaut</a> and #markfincg, #vanseodesign, #simon-noesi, #gladiatorsuits, #AShenkar, #cidadesonho</p></blockquote>\n<blockquote><p>\nFor those who said no, some reasons given were:<br />\n~ &#8220;Not sure how I could contribute other than offering my experience so far. I&#8217;m not a programmer so can&#8217;t write plugins, etc (yet).&#8221;- &#8220;Like I said before BuddyPress is not like WordPress code -wise. If you have a solid understanding of HTML + CSS you can work your way around in almost any &#8216;regular&#8217; WordPress theme because most PHP code is in between the HTML elements. In BuddyPress there is almost none PHP and just a single line ( Action ) that calls a lot of HTML to be included. Thats what makes it so difficult to do whatever you want with BuddyPress.&#8221;<br />\n~ &#8220;I wouldn&#8217;t be able to contribute to the Codex since I&#8217;m not a programmer nor do I have extensive time. That&#8217;s why I depend on devs and people who are way more knowledgeable than I am.&#8221;<br />\n~ &#8220;I&#8217;ll let you know when i&#8217;m ready. <img src=\"http://buddypress.org/wp-includes/images/smilies/icon_smile.gif\" alt=\":)\" class=\"wp-smiley\" />  &#8220;</p></blockquote>\n<p><strong>18. How did you learn about this survey?</strong><br />\nHuge props to Sarah Gooding (<a href=\"http://buddypress.org/community/members/pollyplummer/\" rel=\"nofollow\">@pollyplummer</a>) for bringing in 34% of total respondents via her timely blog post about this survey at wpmu.org. We raised wpmu.org from among the sources listed in the &#8220;Other option&#8221; form as seen below.</p>\n<p><a href=\"http://mercime.files.wordpress.com/2013/09/18-survey-learn-where1.jpg\"><img class=\"aligncenter size-full wp-image-917\" alt=\"18-survey-learn-where\" src=\"http://mercime.files.wordpress.com/2013/09/18-survey-learn-where1.jpg\" width=\"586\" height=\"324\" /></a></p>\n<p><strong>19. This BuddyPress survey is:</strong><br />\nJust right: 90%<br />\nToo long: 8%<br />\nToo short: 2%</p>\n<p><strong>20. Will you be willing to take another BuddyPress survey 6 months from now?</strong><br />\nYes: 81%.<br />\nMaybe: 19%<br />\nNo: 1%</p>\n<p><strong>21. Any last thoughts on improving the BuddyPress Codex: </strong></p>\n<p>Following are some suggestions collected at random. Enjoy.</p>\n<blockquote><p>What would be nice on the Codex is to identify all foreign BP translators (the active one at least) or the foreign BP usage oriented sites. I remember back to 2009 the german, italian, spanish BP sites. Where are they actually?</p></blockquote>\n<blockquote><p>Improve the search on buddypress.org. It&#8217;s practically impossible to find relevant info in the codex, forum posts and blogs. Need lots more tutorials. See cakephp docs,as a good example.</p></blockquote>\n<blockquote><p>If tutorials =&gt; level of complexity<br />\nFuture: a home for translated codex (fr,&#8230;)<br />\ni&#8217;m not sure about video training/tuto<br />\nI like the quick starting guide idea<br />\nI love the phpdoc one</p></blockquote>\n<blockquote><p>I think having examples; i.e., rather than just code examples in a class, perhaps a write up of a certain function or real life application with pointers to the appropriate docs</p></blockquote>\n<blockquote><p>Codex is essential for leveraging the power of BP. Currently the entry barrier is too high.</p></blockquote>\n<blockquote><p>\nNeed much more information about what BuddyPress is, what features it offers (see http://bbpress.org/about/features/ for an example from bbPress), and other things that help people figure out what its useful for and how to use it. Also provide some more entry level articles. The learning curve is pretty steep, even for a pretty experienced multiple WordPress and phpBB site owner like me.</p></blockquote>\n<blockquote><p>I&#8217;m just glad that you want to improve the Codex.</p></blockquote>\n<blockquote><p>1. Improve navigation &#8211; sidebar links should not be the only way to find and access content (if they&#8217;re not, then there&#8217;s another issue).<br />\n2. Make updating it a priority &#8211; it is very disheartening to read something like &#8220;We&#8217;ve made major changes since x.x version&#8221; and then see the docs haven&#8217;t been updated for 1000 days. I&#8217;m 100% positive that BP would have a much larger (and more knowledgeable) developer base if documentation was correct and current &#8211; growth in user base would undoubtedly follow.</p></blockquote>\n<blockquote><p>Thanks for all the wonderful work &#8211; BuddyPress and its documentation already do contribute to make a difference in this world <img src=\"http://buddypress.org/wp-includes/images/smilies/icon_smile.gif\" alt=\":)\" class=\"wp-smiley\" /> </p></blockquote>\n<blockquote><p>\nNot just think about developers or assume themes are developers &#8211; I&#8217;m very worried this is happening. We also need to not overwhelm fist time users, developers and designers. We all need to remember what the first time using BuddyPress and then pushing its use was like.</p></blockquote>\n<blockquote><p>Be more clear, give chance to people to participate in it. Bring more new features. More customization.</p></blockquote>\n<blockquote><p>Complete code examples with multiple usage scenarios.<br />\nComplete &#8220;How to&#8221; creating themes the PROPER way with 1.7+<br />\nMore &#8220;How To&#8221;s.<br />\nDetailed &#8220;How To&#8221;s.</p></blockquote>\n<blockquote><p>Make everything easier to navigate and more inline with WordPress Codex. Make information on developing themes and plugins clearer maybe by establishing a best practices section.</p></blockquote>\n<blockquote><p>Look forward to seeing where it&#8217;s going. And Thank you.</p></blockquote>\n<blockquote><p>More content would be great but first and foremost it just needs to be accurate for the version it is on. So much outdated material. I shouldn&#8217;t have to search around the internet for basic documentation that should be on the BuddyPress site.</p></blockquote>\n<blockquote><p>Working examples of plugin development using checkboxes, radio buttons, dropdown menu&#8217;s etc. So one can have a look to see how to begin a plugin.</p></blockquote>\n<blockquote><p>I&#8217;ve been a very intermittent dev with BP, and just got back into it. I was in the codex today and was like 0-for-10 on finding anything at all. I found somebodies hooks reference on Github and that was closest I got to help.  I think it is great that you&#8217;re making it a priority to improve the codex and would love to try to help.</p></blockquote>\n<blockquote><p>As on WP Codex, I look for usage of hooks/loops but not found (or not easily) on BP Codex. Would love to see hook/loop and expected output.</p></blockquote>\n<blockquote><p>It will be awesome to have some written guidelines on how to edit codex properly. It is not very clear at the moment. Also, think about increasing the visibility of documentation. I love what I have seen on the new document structure proposed [in bpdevel]. I really hope that it becomes reality.</p></blockquote>\n<blockquote><p>I&#8217;m all for a new Codex and I say thinking plenty before heading into the writing phase is best. Please make something scalable that won&#8217;t be obsolete by the time 1.9 comes out!</p></blockquote>\n<blockquote><p>Go developer.buddypress.org while you&#8217;re at it.</p></blockquote>\n<blockquote><p>Go BP Codex Team!</p></blockquote>\n<h3>E. Moving Forward</h3>\n<p>We asked. You answered quite clearly! Now we&#8217;re going back to our planning board and work in the details necessary to push this project onwards and upwards.</p>\n<p>In the next BP Codex update at <a href=\"http://bpdevel.wordpress.com\" title=\"bpdevel.wordpress.com\">bpdevel.wordpress.com</a>  <a href=\"http://buddypress.org/community/members/hnla/\" rel=\"nofollow\">@hnla</a> will be posting the updated Table of Contents where you can indicate which section/topic you&#8217;d like to create/update at <a href=\"http://codex.buddypress.org/\" target=\"_blank\">codex.buddypress.org</a> &#8211; though please feel free to post your area of interest in comments below. Among others, we&#8217;ll also be providing some guidelines for contributions to the codex along with recommendations arising from this survey.</p>\n<p>Thank you again for participating in our first BuddyPress Codex Survey <img src=\"http://buddypress.org/wp-includes/images/smilies/icon_wink.gif\" alt=\";-)\" class=\"wp-smiley\" /> </p>\n<p>P.S. To #markfincg, #vanseodesign, #simon-noesi, #gladiatorsuits, #AShenkar, and #cidadesonho: Apologies, couldn&#8217;t find your WP/BP usernames. Please post in comment below if you are still interested in contributing to the BP Codex. Thanks.</p>\n<h2>Discussion</h2>\n\n<div id=\"bbpress-forums\">\n\n	\n	\n		\n		\n			\n\n<div class=\"bbp-pagination\">\n	<div class=\"bbp-pagination-count\">\n\n		Viewing 6 posts - 1 through 6 (of 6 total)\n	</div>\n\n	<div class=\"bbp-pagination-links\">\n\n		\n	</div>\n</div>\n\n\n			\n<ul id=\"topic-170926-replies\" class=\"forums bbp-replies\">\n\n	<li class=\"bbp-body\">\n\n		\n			\n<div id=\"post-170926\" class=\"post-170926 topic type-topic status-publish hentry odd bbp-parent-forum-2074 bbp-parent-topic-170926 bbp-reply-position-1 user-id-187497 topic-author\">\n\n	<div class=\"bbp-reply-author\">\n\n		\n		<a href=\"http://buddypress.org/community/members/mercime/\" title=\"View @mercime\'s profile\" class=\"bbp-author-avatar\" rel=\"nofollow\"><img src=\"http://gravatar.com/avatar/fae451be6708241627983570a1a1817a?d=http://buddypress.org/wp-content/plugins/buddypress/bp-core/images/mystery-man.jpg&s=100&r=G\" class=\"avatar user-187497-avatar avatar-100 photo\" width=\"100\" height=\"100\" alt=\"Avatar of @mercime\" /></a><br /><a href=\"http://buddypress.org/community/members/mercime/\" title=\"View @mercime\'s profile\" class=\"bbp-author-name\" rel=\"nofollow\">@mercime</a><br /><div class=\"bbp-author-role\">Keymaster</div>\n		<p class=\"bbp-user-nicename\">@mercime</p>\n		<p class=\"bbp-reply-post-date\"><a href=\"http://buddypress.org/support/topic/2013-buddypress-codex-survey-results/#post-170926\" title=\"#170926\" class=\"bbp-reply-permalink\">1 day, 10 hours ago</a></p>\n\n		\n		\n	</div><!-- .bbp-reply-author -->\n\n	<div class=\"bbp-reply-content\">\n\n		\n		<p>The 2013 BP Codex Survey report is now available. Read more about it at <a href=\"http://buddypress.org/2013/09/2013-buddypress-codex-survey-results/\" rel=\"nofollow\">http://buddypress.org/2013/09/2013-buddypress-codex-survey-results/</a></p>\n\n		\n	</div><!-- .bbp-reply-content -->\n\n	<span class=\"bbp-admin-links\"></span>\n</div><!-- #post-170926 -->\n\n		\n			\n<div id=\"post-170929\" class=\"post-170929 reply type-reply status-publish hentry even bbp-parent-forum-2074 bbp-parent-topic-170926 bbp-reply-position-2 user-id-11701205\">\n\n	<div class=\"bbp-reply-author\">\n\n		\n		<a href=\"http://buddypress.org/community/members/bphelp/\" title=\"View bp-help\'s profile\" class=\"bbp-author-avatar\" rel=\"nofollow\"><img src=\"http://gravatar.com/avatar/a24df1f1f1c7cbd63096036d6c84cec6?d=http://buddypress.org/wp-content/plugins/buddypress/bp-core/images/mystery-man.jpg&s=100&r=G\" class=\"avatar user-11701205-avatar avatar-100 photo\" width=\"100\" height=\"100\" alt=\"Avatar of bp-help\" /></a><br /><a href=\"http://buddypress.org/community/members/bphelp/\" title=\"View bp-help\'s profile\" class=\"bbp-author-name\" rel=\"nofollow\">bp-help</a><br /><div class=\"bbp-author-role\">Participant</div>\n		<p class=\"bbp-user-nicename\">@bphelp</p>\n		<p class=\"bbp-reply-post-date\"><a href=\"http://buddypress.org/support/topic/2013-buddypress-codex-survey-results/#post-170929\" title=\"#170929\" class=\"bbp-reply-permalink\">1 day, 10 hours ago</a></p>\n\n		\n		\n	</div><!-- .bbp-reply-author -->\n\n	<div class=\"bbp-reply-content\">\n\n		\n		<p><a href=\"http://buddypress.org/community/members/mercime/\" rel=\"nofollow\">@mercime</a><br />\nGreat data from the survey! Congrats to all!</p>\n\n		\n	</div><!-- .bbp-reply-content -->\n\n	<span class=\"bbp-admin-links\"></span>\n</div><!-- #post-170929 -->\n\n		\n			\n<div id=\"post-170932\" class=\"post-170932 reply type-reply status-publish hentry odd bbp-parent-forum-2074 bbp-parent-topic-170926 bbp-reply-position-3 user-id-9022563\">\n\n	<div class=\"bbp-reply-author\">\n\n		\n		<a href=\"http://buddypress.org/community/members/danbp/\" title=\"View chouf1\'s profile\" class=\"bbp-author-avatar\" rel=\"nofollow\"><img src=\"http://gravatar.com/avatar/0deae2e7003027fbf153500cd3fa5501?d=http://buddypress.org/wp-content/plugins/buddypress/bp-core/images/mystery-man.jpg&s=100&r=G\" class=\"avatar user-9022563-avatar avatar-100 photo\" width=\"100\" height=\"100\" alt=\"Avatar of danbp\" /></a><br /><a href=\"http://buddypress.org/community/members/danbp/\" title=\"View chouf1\'s profile\" class=\"bbp-author-name\" rel=\"nofollow\">chouf1</a><br /><div class=\"bbp-author-role\">Participant</div>\n		<p class=\"bbp-user-nicename\">@danbp</p>\n		<p class=\"bbp-reply-post-date\"><a href=\"http://buddypress.org/support/topic/2013-buddypress-codex-survey-results/#post-170932\" title=\"#170932\" class=\"bbp-reply-permalink\">1 day, 8 hours ago</a></p>\n\n		\n		\n	</div><!-- .bbp-reply-author -->\n\n	<div class=\"bbp-reply-content\">\n\n		\n		<p>Thank you <a href=\"http://buddypress.org/community/members/mercime/\" rel=\"nofollow\">@mercime</a> and <a href=\"http://buddypress.org/community/members/hnla/\" rel=\"nofollow\">@hnla</a> for this long, serious and detailed work ! Very interesting datas.<br />\nHope that the next survey will come out of a holiday period !:D</p>\n<p>Salut !</p>\n\n		\n	</div><!-- .bbp-reply-content -->\n\n	<span class=\"bbp-admin-links\"></span>\n</div><!-- #post-170932 -->\n\n		\n			\n<div id=\"post-170936\" class=\"post-170936 reply type-reply status-publish hentry even bbp-parent-forum-2074 bbp-parent-topic-170926 bbp-reply-position-4 user-id-7564761\">\n\n	<div class=\"bbp-reply-author\">\n\n		\n		<a href=\"http://buddypress.org/community/members/sooskriszta/\" title=\"View OC2PS\'s profile\" class=\"bbp-author-avatar\" rel=\"nofollow\"><img src=\"http://gravatar.com/avatar/6ae41315a1c52ed387a0d80db0491435?d=http://buddypress.org/wp-content/plugins/buddypress/bp-core/images/mystery-man.jpg&s=100&r=G\" class=\"avatar user-7564761-avatar avatar-100 photo\" width=\"100\" height=\"100\" alt=\"Avatar of OC2PS\" /></a><br /><a href=\"http://buddypress.org/community/members/sooskriszta/\" title=\"View OC2PS\'s profile\" class=\"bbp-author-name\" rel=\"nofollow\">OC2PS</a><br /><div class=\"bbp-author-role\">Participant</div>\n		<p class=\"bbp-user-nicename\">@sooskriszta</p>\n		<p class=\"bbp-reply-post-date\"><a href=\"http://buddypress.org/support/topic/2013-buddypress-codex-survey-results/#post-170936\" title=\"#170936\" class=\"bbp-reply-permalink\">1 day, 8 hours ago</a></p>\n\n		\n		\n	</div><!-- .bbp-reply-author -->\n\n	<div class=\"bbp-reply-content\">\n\n		\n		<p>I would be happy to contribute to codex as well. But to a user codex as opposed to a developer codex. Even though BuddyPress is now easier than it used to be, there are plenty of things new users (site admins) ask again and again &#8211; these are recurring themes on the forums. If you look at the WordPress &#8220;documentation&#8221;, it explains concepts in a clear and simple manner accessible by even novice users.I would be happy to contribute to codex as well. But to a user codex as opposed to a developer codex. Even though BuddyPress is now easier than it used to be, there are plenty of things new users (site admins) ask again and again &#8211; these are recurring themes on the forums. If you look at the WordPress &#8220;documentation&#8221;, it explains concepts in a clear and simple manner accessible by even novice users.</p>\n\n		\n	</div><!-- .bbp-reply-content -->\n\n	<span class=\"bbp-admin-links\"></span>\n</div><!-- #post-170936 -->\n\n		\n			\n<div id=\"post-170939\" class=\"post-170939 reply type-reply status-publish hentry odd bbp-parent-forum-2074 bbp-parent-topic-170926 bbp-reply-position-4 user-id-5462165\">\n\n	<div class=\"bbp-reply-author\">\n\n		\n		<a href=\"http://buddypress.org/community/members/hnla/\" title=\"View Hugo\'s profile\" class=\"bbp-author-avatar\" rel=\"nofollow\"><img src=\"http://gravatar.com/avatar/3860c955aa3f79f13b92826ae47d07fe?d=http://buddypress.org/wp-content/plugins/buddypress/bp-core/images/mystery-man.jpg&s=100&r=G\" class=\"avatar user-5462165-avatar avatar-100 photo\" width=\"100\" height=\"100\" alt=\"Avatar of Hugo\" /></a><br /><a href=\"http://buddypress.org/community/members/hnla/\" title=\"View Hugo\'s profile\" class=\"bbp-author-name\" rel=\"nofollow\">Hugo</a><br /><div class=\"bbp-author-role\">Moderator</div>\n		<p class=\"bbp-user-nicename\">@hnla</p>\n		<p class=\"bbp-reply-post-date\"><a href=\"http://buddypress.org/support/topic/2013-buddypress-codex-survey-results/#post-170939\" title=\"#170939\" class=\"bbp-reply-permalink\">1 day, 7 hours ago</a></p>\n\n		\n		\n	</div><!-- .bbp-reply-author -->\n\n	<div class=\"bbp-reply-content\">\n\n		\n		<p><a href=\"http://buddypress.org/community/members/sooskriszta/\" rel=\"nofollow\">@sooskriszta</a> yes it&#8217;s intended that the user setup / configuration, basic principles etc type pages be expanded and your offer of help appreciated, we&#8217;ll call out to everyone who offered to help  and those that want to when we get the next TOC outline up with a clearer idea of structure and new pages required.</p>\n<p>I want to add a big thanks to Mercime on the survey as it was mainly her work in pulling this together and producing the results which make for interesting reading and will help us to plan out the revised TOC &amp; new pages.</p>\n\n		\n	</div><!-- .bbp-reply-content -->\n\n	<span class=\"bbp-admin-links\"></span>\n</div><!-- #post-170939 -->\n\n		\n			\n<div id=\"post-170961\" class=\"post-170961 reply type-reply status-publish hentry even bbp-parent-forum-2074 bbp-parent-topic-170926 bbp-reply-position-6 user-id-7349734\">\n\n	<div class=\"bbp-reply-author\">\n\n		\n		<a href=\"http://buddypress.org/community/members/ubernaut/\" title=\"View @ubernaut\'s profile\" class=\"bbp-author-avatar\" rel=\"nofollow\"><img src=\"http://gravatar.com/avatar/e715c0ee9082add252b5246f7af712ac?d=http://buddypress.org/wp-content/plugins/buddypress/bp-core/images/mystery-man.jpg&s=100&r=G\" class=\"avatar user-7349734-avatar avatar-100 photo\" width=\"100\" height=\"100\" alt=\"Avatar of @ubernaut\" /></a><br /><a href=\"http://buddypress.org/community/members/ubernaut/\" title=\"View @ubernaut\'s profile\" class=\"bbp-author-name\" rel=\"nofollow\">@ubernaut</a><br /><div class=\"bbp-author-role\">Participant</div>\n		<p class=\"bbp-user-nicename\">@ubernaut</p>\n		<p class=\"bbp-reply-post-date\"><a href=\"http://buddypress.org/support/topic/2013-buddypress-codex-survey-results/#post-170961\" title=\"#170961\" class=\"bbp-reply-permalink\">1 day ago</a></p>\n\n		\n		\n	</div><!-- .bbp-reply-author -->\n\n	<div class=\"bbp-reply-content\">\n\n		\n		<p>Nice work very interesting the word cloud and the multisite usage break down i found especially interesting. Question on #8 though surely there must be some overlap in component usage not sure the pie chart tells me very much, maybe i&#8217;m being slow again.<br />\n <img src=\"http://buddypress.org/wp-includes/images/smilies/icon_razz.gif\" alt=\":P\" class=\"wp-smiley\" /> </p>\n\n		\n	</div><!-- .bbp-reply-content -->\n\n	<span class=\"bbp-admin-links\"></span>\n</div><!-- #post-170961 -->\n\n		\n	</li><!-- .bbp-body -->\n\n</ul><!-- #topic-170926-replies -->\n\n\n			\n\n<div class=\"bbp-pagination\">\n	<div class=\"bbp-pagination-count\">\n\n		Viewing 6 posts - 1 through 6 (of 6 total)\n	</div>\n\n	<div class=\"bbp-pagination-links\">\n\n		\n	</div>\n</div>\n\n\n		\n		\n\n\n	<div id=\"no-reply-170926\" class=\"bbp-no-reply\">\n		<div class=\"bbp-template-notice\">\n			<p>You must be logged in to reply to this topic.</p>\n		</div>\n	</div>\n\n\n\n	\n	\n</div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 06 Sep 2013 05:31:26 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"@mercime\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"WordPress.tv: Jesse Friedman: Real-Time Site Personalization\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=21698\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"http://wordpress.tv/2013/09/05/jesse-friedman-real-time-site-personalization/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:684:\"<div id=\"v-WNfjxQ4w-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/21698/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/21698/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=21698&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/09/05/jesse-friedman-real-time-site-personalization/\"><img alt=\"Jesse Friedman: Real-Time Site Personalization\" src=\"http://videos.videopress.com/WNfjxQ4w/real-time-site-personalization_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 06 Sep 2013 01:59:02 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"WordPress.tv: K Adam White: Evolving Your JavaScript with Backbone.js\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=21684\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:86:\"http://wordpress.tv/2013/09/05/k-adam-white-evolving-your-javascript-with-backbone-js/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:710:\"<div id=\"v-UwReWU0w-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/21684/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/21684/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=21684&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/09/05/k-adam-white-evolving-your-javascript-with-backbone-js/\"><img alt=\"K Adam White: Evolving Your JavaScript with Backbone.js\" src=\"http://videos.videopress.com/UwReWU0w/evolving-your-javascript-with-backbone_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 06 Sep 2013 01:58:05 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"Matt: Mission to Democratize Publishing\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=42969\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://ma.tt/2013/09/mission-to-democratize-publishing/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:250:\"<p>I spoke to Robin Hough at the Guardian about <a href=\"http://www.theguardian.com/media-network/media-network-blog/2013/sep/03/democratise-publishing-matt-mullenwegg-cloud\">WordPress and Automattic&#8217;s mission to democratize publishing</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 05 Sep 2013 21:01:38 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"WPTavern: Pressgram Launches WordPress-Powered Photo-Sharing App\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=8801\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:116:\"http://feedproxy.google.com/~r/WordpressTavern/~3/RWB28xAPVyI/pressgram-launches-wordpress-powered-photo-sharing-app\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:10970:\"<p>Everyone has been waiting on the edge of their seats for the <a href=\"http://pressgr.am/\" target=\"_blank\">Pressgram app</a> to be accepted in the app store and today it finally happened. Billed as &#8220;An Image Sharing App Built for an Independent Web&#8221;, Pressgram has received some major <a href=\"http://www.forbes.com/sites/toyota/2013/08/19/entrepreneur-develops-new-way-to-share-images-online/\" title=\"Pressgram on Forbes\" target=\"_blank\">national attention</a>, given its direct confrontation of the very unpopular policies of Facebook and Instagram. The project was fully funded on <a href=\"http://www.kickstarter.com/projects/tentblogger/pressgram-an-image-sharing-app-built-for-an-indepe\" target=\"_blank\">Kickstarter</a> within 30 days, due to the support of a community that is passionate about owning their own data with full creative control.<br />\n<span id=\"more-8801\"></span></p>\n<h3>What is Pressgram?</h3>\n<p><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/09/11-user-profile-2.png\" rel=\"thumbnail\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/09/11-user-profile-2.png?resize=281%2C500\" alt=\"11-user-profile-2\" class=\"alignright size-large wp-image-8813\" /></a>In case you haven&#8217;t been following, Pressgram is a photo-sharing app for iOS, created by Atlanta-based developer John Saddington. It is similar to Instagram but with a few serious distinctions: </p>\n<ul>\n<li> Powered by WordPress + iOS with Filtered Photos added in</li>\n<li> Users will own their own data &#8211; your content is always yours</li>\n<li> The target users are publishers</li>\n<li> Currently makes use of open source photo filters</li>\n</ul>\n<p>When you use the Pressgram app in combination with the Pressgram WordPress plugin, the images are published to your blog through the typical post publishing process and are stored in the WordPress media folder. They are also stored in Amazon&#8217;s cloud storage and delivered to the Pressgram social network from there in order to create a consistent experience for the user within the application.</p>\n<p>For now the <a href=\"http://wordpress.org/plugins/pressgram/\" title=\"WordPress Pressgram plugin\" target=\"_blank\">Pressgram plugin for WordPress</a> simply de-clutters the homepage so that Pressgram posts don&#8217;t get mixed in with your longer-form content. In the future, Saddington plans to add more features based on user feedback and suggestions from the community.</p>\n<h3>An Interview with John Saddington on Community and the Future of Pressgram</h3>\n<p><div id=\"attachment_8817\" class=\"wp-caption alignleft\"><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/09/john-saddington.jpg\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/09/john-saddington.jpg?resize=300%2C300\" alt=\"John Saddington, creator of Pressgram\" class=\"size-medium wp-image-8817\" /></a><p class=\"wp-caption-text\">John Saddington, creator of Pressgram</p></div>I spoke with John Saddington on the eve of Pressgram&#8217;s launch into the app store. He was intent on building Pressgram, whether anyone was interested in it or not. He felt so strongly about owning his own data that he long ago cancelled his Facebook and Instagram accounts. </p>\n<p>His Kickstarter initiative outlines the many compelling reasons for owning your own data by refusing to &#8220;line the pockets of another&#8217;s purse&#8221;, as he put it. The clear success of the fundraising efforts show that he is not alone in his thinking:</p>\n<blockquote><p>&#8220;I was pleasantly surprised by how many other online publishers really &#8220;got&#8221; my intention and where I was headed with the application. They could see the value of posting images directly to their WordPress blogs and also the philosophical intent. Naturally I&#8217;m happy that it reached its funding goal but I would have still built the application out if I didn&#8217;t and that&#8217;s because I had originally intended on provisioning it on my own device for myself alone.&#8221; </p></blockquote>\n<p>Pressgram also shares the community aspect that you&#8217;ve seen with Instagram and Saddington has already hand-picked a select few who will be offering their time and resources to help moderate, manage and grow the community that is springing up around this app. &#8220;This is so much bigger than just an &#8216;app&#8217;,&#8221; he said. &#8220;It&#8217;s a movement of creatives and artists and digital publishers who are rebelling against the unashamed commercial interests.&#8221;</p>\n<h3>Why isn&#8217;t there an Android app?</h3>\n<p>Given Instagram&#8217;s massive success after launching in the Android market, I was curious as to why Saddington didn&#8217;t start there first. I asked him how soon he&#8217;d be releasing an Android app. He said:</p>\n<blockquote><p>The answer is quite simple &#8211; I know Objective-C programming as I&#8217;ve built a few apps in that environment but I&#8217;ve never built an Android app. And besides, I&#8217;ve only owned iOS-devices so the intent was to first scratch my own itch and then scratch other people&#8217;s if the interest was warranted and big enough. Apparently it&#8217;s quite large as there are a number of Kickstarter backers who are Android users and who are waiting for it to be released! I will have to build out a team though if I&#8217;m going to get to Android and that takes time and money.</p></blockquote>\n<p>Since I am an Android user, I won&#8217;t be able to try it and will be depending on our readers for some initial reviews. </p>\n<h4>Using Pressgram Without WordPress</h4>\n<p><div id=\"attachment_8821\" class=\"wp-caption alignright\"><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/09/17-edit-image.png\" rel=\"thumbnail\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/09/17-edit-image.png?resize=281%2C500\" alt=\"Photo filters on the Pressgram app\" class=\"size-large wp-image-8821\" /></a><p class=\"wp-caption-text\">Photo filters on the Pressgram app are available even without using WordPress</p></div>Not everyone hosts their own blog. In fact, if Pressgram ever hopes to gain mass appeal, there must be an option for using it by itself. This is why Saddington made sure to account for non-WordPress users in his app:</p>\n<blockquote><p>You can use Pressgram without ever connecting it directly to a WordPress blog &#8211; I believe many users will do this as the philosophical nature of not being part of the Facebook network where they monetize every single thing (<a href=\"http://blog.pressgr.am/soul/\" target=\"_blank\">and if they could have your soul they would</a>) that you are and do. Some users will just want to be part of a better social network as well as having the capabilities of filtering photos and sharing them.</p></blockquote>\n<p>Saddington left Facebook and Instagram due to the licensing and policies that he did not agree with, but he still wanted to take pictures and add filters to them and wanted others to have the freedoms afforded to self-publishers who are not dependent on social networks. The <a href=\"http://blog.pressgr.am/\">Pressgram blog</a> has been diligently pumping out posts on why any user, whether connected to WordPress or not, should carefully consider forsaking the data-hungry social networks and find a new way to share online. They&#8217;ve been driving a strong campaign for the open web and only time and downloads will tell how successful the app will be.</p>\n<h3>Initial Proprietary License: Possible Open Source Licensing in the Future</h3>\n<p>The Pressgram app is currently free to download and Saddington has confirmed that it will be so forever. So the philosophy behind Pressgram is all about freedom &#8211; for the user and the publisher. But what about the software itself?</p>\n<p>During the final days of the project&#8217;s fundraising campaign, the largest backer of the project withdrew when he learned that it would not be open source:</p>\n<blockquote class=\"twitter-tweet\"><p>I canceled my pledge for <a href=\"https://twitter.com/Pressgram\">@Pressgram</a> (10k) because project will be proprietary, not OS like I expected. Sorry for misunderstanding.</p>\n<p>&mdash; Matt Mullenweg (@photomatt) <a href=\"https://twitter.com/photomatt/statuses/321729470346186752\">April 9, 2013</a></p></blockquote>\n<p></p>\n<p>When I asked John if the project will ever move to an open source license he said that he is willing to consider it. Given his heavy involvement in working with OS in the past, I was curious as to what aspect of the project necessitates a proprietary license. For him it boils down to a matter of workflow and speed in getting the software out the door:</p>\n<blockquote><p>&#8220;It was simply a personal decision that I made that would allow me to move faster in the way that I develop, engineer, and ship products. But again, this was a deeply personal project that had no intentions of being a publicly-used application at first. No one knew that I was working on it for 6 months (starting in September of 2012)! It was a &#8220;night and weekend&#8221; passion project that has grown into a little monster! In regards to making it OS in the future &#8211; I&#8217;m not sure yet. I can see the validity from both sides being experienced and a big part of open source for a very long time.</p></blockquote>\n<p>This brings us to a very interesting question &#8211; should the developer&#8217;s workflow be a factor in the licensing of his project? I guess this is a very personal decision.  My hope is that John will opt for an open source license in the future and receive all the benefits of having contributors. You never know how many developers would be happy to submit bug fixes and new features to a worthy OS project, putting it much further down the road than one developer could ever go by himself.</p>\n<p>Saddington hopes to reclaim lost freedoms for users in offering them a way to publish their photos to their own sites with full ownership. It&#8217;s a very special thing that he chose to use the WordPress platform to help people regain these freedoms. </p>\n<p>However, WordPress wouldn&#8217;t be the fantastic application-building framework that it is today without its open source license. There&#8217;s no getting around that fact. Pressgram is entirely dependent on WordPress in order to deliver photos to the user&#8217;s home on the web. Is there any reason why Pressgram couldn&#8217;t benefit from those same open source principles that have made WordPress a resounding success?</p>\n<p>These are interesting questions to consider. Congrats to Saddington and his team on launching the app today. Pressgram is an amazing example of how WordPress can be used to power a creative application with mass appeal. We&#8217;re likely to see many such apps in the future.</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/RWB28xAPVyI\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 05 Sep 2013 14:09:24 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"WPTavern: This Week On WPWeekly – Swiftype\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=8829\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:92:\"http://feedproxy.google.com/~r/WordpressTavern/~3/I50ByMaYXa4/this-week-on-wpweekly-swiftype\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1056:\"<p>On this weeks edition of WordPress Weekly, <a href=\"https://swiftype.com/\" title=\"https://swiftype.com/\">Swiftype</a> will be our special guest. I <a href=\"http://www.wptavern.com/review-swiftype-search-plugin\" title=\"http://www.wptavern.com/review-swiftype-search-plugin\">reviewed their plugin/service</a> back in May. We plan on talking about why the search in WordPress is not as good as it should be, what makes search hard, the performance impacts of search and of course, the benefits of using search as a service versus the sites database. We&#8217;ll also cover the headlines of the week. If you have any questions about WordPress search, search, or Swiftype in particular, please place them in the comments. The show will air live this <strong>Friday at 9P.M. Eastern time</strong> and you can follow along via the <a href=\"http://www.wptavern.com/wordpress-weekly\" title=\"http://www.wptavern.com/wordpress-weekly\">WPWeekly Podcast page</a>.  </p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/I50ByMaYXa4\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 04 Sep 2013 23:16:33 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"WPTavern: Why WordCamp Detroit 2013 Was Cancelled\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=8799\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:101:\"http://feedproxy.google.com/~r/WordpressTavern/~3/JsYnol29nSM/why-wordcamp-detroit-2013-was-cancelled\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6761:\"<p>It looks like the plug has been pulled on <a title=\"http://2013.detroit.wordcamp.org/wordcamp-detroit-2013-cancelled/\" href=\"http://2013.detroit.wordcamp.org/wordcamp-detroit-2013-cancelled/\">WordCamp Detroit 2013.</a> In a blog post published on September 3rd, 2013 TJList one of the organizers has announced that they have canceled this year&#8217;s WordCamp. The primary reason given was that they were not ready to put on a high-quality event. Those who have already purchased tickets will be refunded in full, including sponsors.</p>\n<p>It&#8217;s not often I hear news of a WordCamp event being cancelled. In fact, I asked Andrea Middleton of WordCamp Central if this was the first WordCamp to be cancelled this year and she said yes. I got in touch with TJList to see if he could provide more insight into the cancellation and what lessons if any he learned throughout this whole ordeal so that other WordCamp organizers could avoid the same fate. <span id=\"more-8799\"></span></p>\n<p><strong>I know you outlined that this years event would not be able to meet high expectations that WordCamp attendees are accustomed to. Is there anyway you could share some more information with me that I could share with others that lead to this decision? Was it poor planning, lack of focus, or just not enough time to get things hammered out? Was the foundation helpful at all or were they one of the reasons for not being able to meet expectations? Any lessons learned that you can give other WordCamp organizers to avoid the same fate?</strong></p>\n<p>In previous years, the lead organizer for WordCamp Detroit had experience organizing events. He is working on other things this year. Most of this year&#8217;s team had worked on previous events, but nobody had managed the big picture.The people at the WordPress Foundation responded quickly and were helpful, when we asked. We didn&#8217;t do that enough. </p>\n<div id=\"attachment_4720\" class=\"wp-caption aligncenter\"><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2010/10/20101012-050426.jpg\" rel=\"thumbnail\"><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2010/10/20101012-050426.jpg?resize=225%2C300\" alt=\"WordCamp Detroit 2010 Day 2\" class=\"size-medium wp-image-4720\" /></a><p class=\"wp-caption-text\">WordCamp Detroit 2010 Day 2</p></div>\n<p>When I took on the role of lead organizer, I greatly underestimated the amount of work required and the number of details to be considered. The team was also busy with life and work. The designer who did last year&#8217;s logo and theme was busy with some major projects in his business. I was wrapping up a year-long leadership development program that took a lot of my time. </p>\n<p>We did not have anyone assigned to creating content and updating news. Publicity was limited to a few tweets and a couple of Facebook posts. Speaker applications were left with no response. No work was being done to contact sponsors. If it weren&#8217;t for multi-event sponsors we would not have had any event at all. Despite all that, we had a great initial response when the site went live. We sold nearly 20 tickets and had 18 applications to speak.</p>\n<p>When my course ended and I started breathing again at the end of August, the ladies on the team said, &#8220;<em>We need to talk about this. Can we really pull this off?</em>&#8221; The answer, sadly enough, was &#8220;<em>No. Not without killing ourselves. Not with the level of quality we want to provide.</em>&#8221;</p>\n<p><strong>My top 5 lessons learned:</strong><br />\n<strong>1. Do your homework! </strong><br />\nRead the helpful hints and suggestions that other WordCamp organizers have so generously left behind. There are a lot of killer resources out there. Use them.</p>\n<p><strong>2. Start early. </strong><br />\nSix months might be enough. Ask us that next summer and see if the answer changes.</p>\n<p><strong>3. Ask for help. </strong><br />\nThen do it again. And again.</p>\n<p><strong>4. Create a detailed project plan. </strong><br />\nEstablish key milestones at the beginning of the process. Date, venue, theme for the conference, theme, website live date, cut-off dates for speaker submissions, etc. will all impact the quality of the event.</p>\n<p><strong>5. Ask, don&#8217;t assume. </strong><br />\nGet commitments from the key organizers and volunteers. What can they realistically deliver? We&#8217;re talking about doing this again in 2014. I&#8217;m starting fresh with number 1 from my list.</p>\n<h2>The Importance Of Strong Leadership</h2>\n<p>Ask anyone who has organized a WordCamp or any large event for that matter and they won&#8217;t tell you it was easy. Putting on these types of events requires strong leadership skills. Being a leader means you get things done, keep tabs on all of the work your organizers are accomplishing, provide a clear direction of tasks needing to be completed, and being an effective communicator. One of the last things TJ mentioned to me that he stressed I share with everyone else was the following:</p>\n<blockquote><p>In all fairness to the other organizers, I was the source of the breakdown for the planning failure. I was unwilling and/or unable to communicate effectively, and I was not open with the rest of the team about my limited availability. Put bluntly, my early failure to lead and provide direction caused the planning to fall so far behind that we could not recover the event.</p></blockquote>\n<p>Despite the event falling apart, I thank TJ for being open and honest about the situation. I hope other WordCamp organizers read this post and get a grasp as to how important being a leader is to facilitate a successful event. With the lessons learned, I can&#8217;t see how WordCamp Detroit 2014 would be anything but a success. </p>\n<p>Back in 2010 during the first ever WordCamp Detroit, I interviewed lead organizer Anthony Montalbano where we briefly chatted about organizing the event. </p>\n<div class=\"aligncenter\"><div id=\"v-DlTshvAZ-1\" class=\"video-player\"><div><img alt=\"Interview With Anthony Montalbano\" src=\"http://i2.wp.com/videos.videopress.com/DlTshvAZ/wcdetanthonyinterview_dvd.original.jpg?resize=560%2C420\" /></div><p class=\"robots-nocontent\">You do not have sufficient <a rel=\"nofollow\" href=\"http://www.gnu.org/philosophy/free-sw.html\">freedom levels</a> to view this video. Support free software and upgrade.</p></div></div>\n<p>You can also read my <a href=\"http://www.wptavern.com/wordcamp-detroit-was-a-good-time\" title=\"http://www.wptavern.com/wordcamp-detroit-was-a-good-time\">review of WordCamp Detroit 2010</a> to get a sense of how well the event was run during its first year. </p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/JsYnol29nSM\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 04 Sep 2013 19:13:54 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"WordPress.tv: Panel Discussion: Big Business in the Smallest State\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=21724\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:83:\"http://wordpress.tv/2013/09/04/panel-discussion-big-business-in-the-smallest-state/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:700:\"<div id=\"v-tHWxgS8G-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/21724/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/21724/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=21724&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/09/04/panel-discussion-big-business-in-the-smallest-state/\"><img alt=\"Panel Discussion: Big Business in the Smallest State\" src=\"http://videos.videopress.com/tHWxgS8G/big-business-in-the-smallest-state_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 04 Sep 2013 10:35:25 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:15;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"WordPress.tv: Reiko Beach: Digital Branding: You and Your Business\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=21686\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:82:\"http://wordpress.tv/2013/09/04/reiko-beach-digital-branding-you-and-your-business/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:703:\"<div id=\"v-dRUo8z9j-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/21686/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/21686/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=21686&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/09/04/reiko-beach-digital-branding-you-and-your-business/\"><img alt=\"Reiko Beach: Digital Branding: You and Your Business\" src=\"http://videos.videopress.com/dRUo8z9j/digital-branding-you-and-your-business_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 04 Sep 2013 10:33:41 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:16;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:80:\"WPTavern: WPWeekly Episode 119 – The Triple A Of WordPress Support, WPSitecare\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=8762\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:127:\"http://feedproxy.google.com/~r/WordpressTavern/~3/Uu8fsL5RdbI/wpweekly-episode-119-the-triple-a-of-wordpress-support-wpsitecare\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2650:\"<p><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/08/WordPressWeekly_albumart2.jpg\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/08/WordPressWeekly_albumart2.jpg?resize=150%2C150\" alt=\"WordPress Weekly Cover Art\" class=\"alignright size-thumbnail wp-image-8715\" /></a> In this episode of WordPress Weekly we covered the headlines of the week and then spent the second half the show talking with Rami Abraham and Ryan Sullivan of <a href=\"http://www.wpsitecare.com/\" title=\"http://www.wpsitecare.com/\">WPSitecare.com</a>. As a company that specializes in supporting WordPress users in all sorts of situations, I thought it would be great to talk to them about what they are finding in terms of what is causing the most support queries. Themes, plugins, or WordPress. We discussed a number of topics such as webhosting, support, pricing, and general issues we have all faced with WordPress. <span id=\"more-8762\"></span></p>\n<h2>Stories Discussed:</h2>\n<p><a href=\"http://www.wptavern.com/automatic-updates-possible-in-wordpress-3-7\" title=\"http://www.wptavern.com/automatic-updates-possible-in-wordpress-3-7\">Automatic Updates For WordPress 3.7</a><br />\n<a href=\"http://www.wptavern.com/ben-sibley-on-the-state-of-wordpress-themes-2013\" title=\"http://www.wptavern.com/ben-sibley-on-the-state-of-wordpress-themes-2013\">State Of WordPress Themes</a><br />\n<a href=\"http://www.wptavern.com/mollom-security-breach\" title=\"http://www.wptavern.com/mollom-security-breach\">Mollom Security Breach</a></p>\n<h2>WPWeekly Meta:</h2>\n<p><strong>Next Episode:</strong> Friday, September 6th 9P.M. Eastern &#8211; Interview With Swiftype</p>\n<p><strong>Subscribe To WPWeekly Via Itunes: </strong><a href=\"https://itunes.apple.com/us/podcast/wordpress-weekly/id694849738\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via RSS: </strong><a href=\"http://www.wptavern.com/feed/podcast\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via Stitcher Radio: </strong><a href=\"http://www.stitcher.com/podcast/wordpress-weekly-podcast?refid=stpr\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Length Of Episode:</strong> 1 Hour 13 Minutes</p>\n<p><strong>Download The Show:</strong> <a href=\"http://www.wptavern.com/wp-content/uploads/2013/09/EPISODE-119-The-Triple-A-Of-WordPress-Support-WPSitecare.mp3\" target=\"_blank\">EPISODE 119 &#8211; The Triple A Of WordPress Support.mp3</a></p>\n<p><strong>Listen To Episode #119:</strong><br />\n</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/Uu8fsL5RdbI\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 03 Sep 2013 23:36:54 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:17;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Matt: Fear of Risk\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=42967\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"http://ma.tt/2013/09/fear-of-risk/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:410:\"<p>Bruce Schneier has a remarkably clear essay on <a href=\"http://www.schneier.com/blog/archives/2013/09/our_newfound_fe.html\">Our Newfound Fear of Risk</a> which could as easily be about corporations, finance, or relationships as it is about its chosen topic. It reminded me a lot of one of the better books I read this year, <a href=\"http://www.amazon.com/dp/B0083DJWGO/\">Antifragile by Nassim Taleb</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 03 Sep 2013 21:49:58 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:18;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"Alex King: WordPress 3.6 Contributor T-shirts\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://alexking.org/?p=18209\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"http://alexking.org/blog/2013/09/03/wordpress-3-6-contributor-t-shirts\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:574:\"<p><a href=\"http://alexking.org/blog/2013/09/03/wordpress-3-6-contributor-t-shirts\"><img width=\"510\" height=\"382\" src=\"http://alexking.org/wp-content/uploads/2013/09/001-20130831-IMG_3789-510x382.jpg\" class=\"attachment-medium-img wp-post-image\" alt=\"WP 3.6 Contributor\" /></a></p>\n<p>I distributed t-shirts to the members of <a href=\"http://crowdfavorite.com\">my team</a> that got patches in for WordPress 3.6 in our monthly team meeting today. We do this for each major release to encourage involvement in the community and to help continually build a better WordPress.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 03 Sep 2013 18:54:51 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Alex\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:19;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"WPTavern: EXCLUSIVE: Sarah Gooding Moves To The WordPress Tavern\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=8774\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:115:\"http://feedproxy.google.com/~r/WordpressTavern/~3/MltI6jQxBr4/exclusive-sarah-gooding-moves-to-the-wordpress-tavern\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1884:\"<p><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/09/wptavern.jpg?resize=300%2C300\" alt=\"wptavern\" class=\"alignright size-medium wp-image-8775\" />Hello WordPress Tavern readers! Some of you may know me as a word wrangling WordPress writer from WPMU.org, where I spent the last four years writing about everything from WordPress and BuddyPress news to theme and product reviews, tutorials, and everything in between. Today, however, I&#8217;m excited to announce that I have officially moved to the Tavern.<span id=\"more-8774\"></span></p>\n<p>I&#8217;ve been using WordPress since 2008. For the past several years I have spent my time scouring the web for all the latest WordPress news and innovations. Plain and simple, I love staying on the front lines of WordPress. So when Matt Mullenweg invited me to join Jeffro and the team at the Tavern to report on WordPress news, I couldn&#8217;t say no. I am thrilled at the chance to chronicle WordPress history as it&#8217;s unfolding right now around the web.  </p>\n<p>It&#8217;s also a great privilege to work with Jeffro, the Tavern Keeper, since he&#8217;s been doing this faithfully for ages. We&#8217;re teaming up to bring you the the best and most interesting WordPress news out there. So if you&#8217;ve been a fan of my articles in the past, please make sure to <a href=\"http://feeds2.feedburner.com/WordpressTavern\" title=\"WPTavern Feed\" target=\"_blank\">subscribe here</a>, where you will be able to follow my new adventures at the Tavern. With WordPress powering roughly 20% of the web, there&#8217;s something awesome happening in this community every day and we&#8217;re going to make sure that you know about it. Grab a pint, pull up a chair and let&#8217;s start up some conversations about WordPress.</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/MltI6jQxBr4\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 03 Sep 2013 18:52:08 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:20;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:37:\"WPTavern: Edit Flow, Jetpack, And MP6\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=8769\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:87:\"http://feedproxy.google.com/~r/WordpressTavern/~3/pOEZyGzfIso/edit-flow-jetpack-and-mp6\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3344:\"<p>The following plugins have either been recently updated or have an update pending. I use all three and know a bunch of other people who use them as well. Jetpack 2.4 in combination with Photon is causing problems on certain websites where images are showing at their full size instead of their specified dimensions. Meanwhile, Edit Flow has been acting up for me since upgrading to WordPress 3.6. I just wanted to share my findings on each plugin thus far. <span id=\"more-8769\"></span></p>\n<p><strong>Edit Flow</strong> &#8211; After upgrading to WordPress 3.6, I discovered that I could not preview posts using the custom post status of Pitch. This took me forever to diagnose and figure out but it has something to do with the plugin not generating a revision which is shown as the post preview when the preview button is selected. I have demonstrated this bug to the developers at Automattic who are in control of this plugin and they are currently developing a fix. If you experience this problem with Edit Flow, I suggest you set your <em>Default</em> post status to Draft since the Draft post status works as expected. </p>\n<p><strong>Jetpack 2.4</strong> &#8211; While 2.4 introduced the awesome <a href=\"http://www.wptavern.com/jetpack-2-4-adds-widget-visibility-module\" title=\"http://www.wptavern.com/jetpack-2-4-adds-widget-visibility-module\">Widget Visibility module</a>, it unfortunately caused images on websites to be displayed at their full size which has been determined to be an issue with Photo as outlined in <a href=\"http://wordpress.org/support/topic/jetpack-update-messes-up-photos?replies=17\" title=\"http://wordpress.org/support/topic/jetpack-update-messes-up-photos?replies=17\">this support thread</a>. If you&#8217;re experiencing the same issue after upgrading Jetpack to 2.4, you&#8217;re encouraged to disable Photon until an update is pushed out. </p>\n<p><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/09/GearIcon.jpg\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/09/GearIcon.jpg?resize=145%2C150\" alt=\"Gear Icons\" class=\"alignright size-thumbnail wp-image-8770\" /></a><strong>MP6 2.0</strong> MP6 2.0 was recently released and I&#8217;ve noticed a number of icons disappear from my menu which have been replaced with default Gear icons. I initially reported this as a bug on the <a href=\"http://wordpress.org/support/topic/mp6-20-replaced-menu-icons-with-gear-icon?replies=1\" title=\"http://wordpress.org/support/topic/mp6-20-replaced-menu-icons-with-gear-icon?replies=1\">support forums</a> but after reading the <a href=\"http://make.wordpress.org/ui/2013/08/31/mp6-2-0/\" title=\"http://make.wordpress.org/ui/2013/08/31/mp6-2-0/\">announcement post</a>, I see this is expected behaviour. Theme and plugin developers are encouraged to generate new menu icons that are compatible with MP6. Utilizing <a href=\"http://halfelf.org/2013/mp6uccess-tips-and-tricks/\" title=\"http://halfelf.org/2013/mp6uccess-tips-and-tricks/\">Mika Epstein&#8217;s post</a> as well as the <a href=\"https://github.com/tillkruess/MP6-Icon-Examples\" title=\"https://github.com/tillkruess/MP6-Icon-Examples\">MP6 icon examples</a> within the Git repository should provide a head start. </p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/pOEZyGzfIso\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 03 Sep 2013 14:03:55 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:21;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:84:\"WordPress.tv: Lindsay Branscombe: Navigating the Forest of E-commerce: A Guided Tour\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=21720\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:100:\"http://wordpress.tv/2013/09/03/lindsay-branscombe-navigating-the-forest-of-e-commerce-a-guided-tour/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:733:\"<div id=\"v-erZZhSL0-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/21720/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/21720/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=21720&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/09/03/lindsay-branscombe-navigating-the-forest-of-e-commerce-a-guided-tour/\"><img alt=\"Lindsay Branscombe: Navigating the Forest of E-commerce: A Guided Tour\" src=\"http://videos.videopress.com/erZZhSL0/e-commerce-navigating-the-forest_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 03 Sep 2013 10:47:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:22;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:76:\"WordPress.tv: Sam Hotchkiss: WordPress Security: Preventing a Lot of Attacks\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=21722\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:91:\"http://wordpress.tv/2013/09/03/sam-hotchkiss-wordpress-security-preventing-alot-of-attacks/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:723:\"<div id=\"v-KFu6q2DD-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/21722/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/21722/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=21722&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/09/03/sam-hotchkiss-wordpress-security-preventing-alot-of-attacks/\"><img alt=\"Sam Hotchkiss: WordPress Security: Preventing a Lot of Attacks\" src=\"http://videos.videopress.com/KFu6q2DD/wp-security-preventing-a-lot-of-attacks_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 03 Sep 2013 10:45:53 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:23;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"Joseph: Mike Adams on Three Security Issues You Thought You’d Fixed\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"https://josephscott.org/?p=8826\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:100:\"https://josephscott.org/archives/2013/09/mike-adams-on-three-security-issues-you-thought-youd-fixed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:625:\"<p>Mike Adams spoke about <a href=\"http://wordpress.tv/2013/08/09/mike-adams-three-security-issues-you-thought-youd-fixed/\">Three Security Issues You Thought You&#8217;d Fixed</a> at <a href=\"http://2013.sf.wordcamp.org/\">WordCamp San Francisco 2013</a>.  Although this was at a WordPress event, the security issues he talks about apply more broadly to PHP and web sites in general.</p>\n<p></p>\n<p>I work with Mike at Automattic and we are <a href=\"http://automattic.com/work-with-us/\">hiring</a>.  If you enjoy bunny puns you should check out our list of <a href=\"http://automattic.com/work-with-us/\">open positions</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 02 Sep 2013 17:44:37 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Joseph Scott\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:24;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"WordPress.tv: Steph Yiu: VIP Tools for Writers and Editors\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=21714\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:75:\"http://wordpress.tv/2013/09/02/steph-yiu-vip-tools-for-writers-and-editors/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:673:\"<div id=\"v-9O8YRv5j-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/21714/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/21714/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=21714&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/09/02/steph-yiu-vip-tools-for-writers-and-editors/\"><img alt=\"Steph Yiu: VIP Tools for Writers and Editors\" src=\"http://videos.videopress.com/9O8YRv5j/borrowing-from-the-vips_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 02 Sep 2013 10:50:41 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:25;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:76:\"WordPress.tv: Jonathan Desrosiers: Plugin Development – Stirred not Shaken\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=21718\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"http://wordpress.tv/2013/09/02/jonathan-desrosiers-plugin-development/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:676:\"<div id=\"v-wDymnUvQ-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/21718/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/21718/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=21718&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/09/02/jonathan-desrosiers-plugin-development/\"><img alt=\"Jon Desrosiers: Plugin Development – Stirred not Shaken\" src=\"http://videos.videopress.com/wDymnUvQ/plugin-development_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 02 Sep 2013 10:48:42 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:26;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"WordPress.tv: Jared Novack: How We Built 17,170,200 Websites in 6 Months\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=21947\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:89:\"http://wordpress.tv/2013/09/01/jared-novack-how-we-built-17170200-websites-in-6-months-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:650:\"<div id=\"v-if2QpA7c-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/21947/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/21947/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=21947&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/09/01/jared-novack-how-we-built-17170200-websites-in-6-months-2/\"><img alt=\"jarednovak.mp4\" src=\"http://videos.videopress.com/if2QpA7c/video-36d6b8ba58_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 01 Sep 2013 13:57:31 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:27;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:97:\"WordPress.tv: Matthew Boynes: Rewrite Recipes: Exploring Advanced Permalink Structures by Example\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=21704\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:113:\"http://wordpress.tv/2013/09/01/matthew-boynes-rewrite-recipes-exploring-advanced-permalink-structures-by-example/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:767:\"<div id=\"v-mg6WDwhx-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/21704/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/21704/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=21704&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/09/01/matthew-boynes-rewrite-recipes-exploring-advanced-permalink-structures-by-example/\"><img alt=\"Matthew Boynes: Rewrite Recipes: Exploring Advanced Permalink Structures by Example\" src=\"http://videos.videopress.com/mg6WDwhx/rewrite-recipes-exploring-adv-structures_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 01 Sep 2013 10:57:43 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:28;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"WordPress.tv: Christopher Cochran: Designing Responsively\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=21710\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:74:\"http://wordpress.tv/2013/08/31/christopher-cochran-designing-responsively/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:670:\"<div id=\"v-ulrtukcz-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/21710/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/21710/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=21710&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/08/31/christopher-cochran-designing-responsively/\"><img alt=\"Christopher Cochran: Designing Responsively\" src=\"http://videos.videopress.com/ulrtukcz/designing-responsively_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 31 Aug 2013 11:43:10 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:29;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:84:\"WordPress.tv: Richard Dinh: Leveraging the JSON API Plugin for WordPress Maintenance\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=21696\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:101:\"http://wordpress.tv/2013/08/31/richard-dinh-leveraging-the-json-api-plugin-for-wordpress-maintenance/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:752:\"<div id=\"v-0au50u2y-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/21696/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/21696/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=21696&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/08/31/richard-dinh-leveraging-the-json-api-plugin-for-wordpress-maintenance/\"><img alt=\"Richard Dinh: Leveraging the JSON API Plugin for WordPress Maintenance\" src=\"http://videos.videopress.com/0au50u2y/leveraging-the-json-api-pluging-for-wp-maintenance_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 31 Aug 2013 11:00:54 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:30;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"WPTavern: Jetpack 2.4 Adds Widget Visibility Module\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=8754\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:103:\"http://feedproxy.google.com/~r/WordpressTavern/~3/YEL7zT0yzf0/jetpack-2-4-adds-widget-visibility-module\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3888:\"<p>If you use the <a href=\"http://wordpress.org/plugins/jetpack/\" title=\"http://wordpress.org/plugins/jetpack/\">Jetpack plugin by Automattic</a>, you&#8217;ll notice there is an update to version 2.4 available. The <a href=\"http://wordpress.org/plugins/jetpack/changelog/\" title=\"http://wordpress.org/plugins/jetpack/changelog/\">changelog</a> for Jetpack is usually a mile long but in this case, I was happy to see that the Widget Visibility module was added to Jetpack. Widget Visibility was made available to WordPress.com <a href=\"http://www.wptavern.com/widget-visibility-when-do-we-get-that\" title=\"http://www.wptavern.com/widget-visibility-when-do-we-get-that\">earlier this year</a>. <span id=\"more-8754\"></span></p>\n<div id=\"attachment_7009\" class=\"wp-caption aligncenter\"><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/05/WidgetVisibility.jpg\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/05/WidgetVisibility.jpg?resize=399%2C189\" alt=\"Widget Visibility\" class=\"size-full wp-image-7009\" /></a><p class=\"wp-caption-text\">Now Available In Jetpack</p></div>\n<p>As I mentioned in my initial post discussing the feature, the interface is surprisingly simple to use. In 2011, <a href=\"http://www.wptavern.com/feedback-needed-for-new-widget-context-user-interface\" title=\"http://www.wptavern.com/feedback-needed-for-new-widget-context-user-interface\">I shared my thoughts</a> on what I think would work for a widget control interface.</p>\n<blockquote><p>\nI’m thinking of a plugin that’s a cross between Widget Logic and Widget Context. This plugin should work on the premise that anytime a widget is added to a sidebar, it’s viewable across the entire site where that sidebar loads. UI is added to the widget screen so that I can easily search or choose from the various template files that make up my theme to decide where the widget will be displayed. By specifically configuring where the widget will be displayed, I’ve also configured where it will not be displayed. I’m not quite sure which user interface would work best for selecting more than one area where the widgets will be displayed, perhaps the check box method that already exists in Widget Context. This is about all I’d need to satisfy my needs. It’s simple, not many options and I think covers the basis for a lot of uses. Now, if Kaspars or users suggested that they wanted rules, or more complex ways of telling their widgets where to show up or hide, I would not complain about having an Advanced tab that showed additional options. But I definitely don’t want that clutter in view as part of the default configuration UI.</p></blockquote>\n<p>What I requested in 2011 is not far from what Widget Visibility offers. Instead of choosing template files within a theme, I can choose between <strong>category, author, tag, date, page</strong> which are theme agnostic and cover the gamut of options I&#8217;d need to hide or show a widget. I&#8217;m glad they didn&#8217;t listen to me when I described the interface. I only wish something this simple would have been added to WordPress a long time ago. What something like Widget Visibility offers is an easy way to make one sidebar serve multiple purposes without needing to create separate sidebars with specific widgets. This opens up a lot more versatility for displaying widgets. While I&#8217;m still excited to see this piece of functionality accessible to a large audience through Jetpack, I can&#8217;t help but think about how much more exciting it would have been to see this as an added feature back in the WordPress 3.0 days. </p>\n<p>Now I can retire the Widget Logic plugin which required me to know WordPress conditional tags in order to control when and where widgets displayed.</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/YEL7zT0yzf0\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 30 Aug 2013 17:47:34 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:31;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"WordPress.tv: Frederick Townes: Business Optimization\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=21611\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"http://wordpress.tv/2013/08/30/frederick-townes-business-optimization/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:674:\"<div id=\"v-EICJD1L0-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/21611/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/21611/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=21611&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/08/30/frederick-townes-business-optimization/\"><img alt=\"Frederick Townes: Business Optimizationation\" src=\"http://videos.videopress.com/EICJD1L0/keynote-business-optimization_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 30 Aug 2013 11:07:35 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:32;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:86:\"WordPress.tv: Mel Choyce: What’s Your Problem, Man? Building a Successful UX Process\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=21702\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:98:\"http://wordpress.tv/2013/08/30/mel-choyce-whats-your-problem-man-building-a-successful-ux-process/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:733:\"<div id=\"v-0fZ1CjJ1-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/21702/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/21702/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=21702&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/08/30/mel-choyce-whats-your-problem-man-building-a-successful-ux-process/\"><img alt=\"Mel Choyce: What’s Your Problem, Man? Building a Successful UX Process\" src=\"http://videos.videopress.com/0fZ1CjJ1/building-a-successful-ux-process_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 30 Aug 2013 10:58:57 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:33;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"WPTavern: Automatic Updates Possible In WordPress 3.7\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=8748\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:105:\"http://feedproxy.google.com/~r/WordpressTavern/~3/oqbc1vm7NYc/automatic-updates-possible-in-wordpress-3-7\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4243:\"<p><a href=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2009/02/wordpresslogo.png\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2009/02/wordpresslogo.png?resize=150%2C150\" alt=\"wordpresslogo\" class=\"alignright size-thumbnail wp-image-422\" /></a>As was stated by Matt Mullenweg in his <a href=\"http://wordpress.tv/2013/07/29/matt-mullenweg-state-of-the-word-2013/\" title=\"http://wordpress.tv/2013/07/29/matt-mullenweg-state-of-the-word-2013/\">State Of The Word 2013 at WordCamp San Francisco</a>, one of the goals for WordPress was to perform automatic updates similar to the Chrome browser. That is, perform automatic updates without breaking anything to the point where you don&#8217;t even know the software has updated. On the Make WordPress Core blog, <a href=\"http://make.wordpress.org/core/2013/08/28/core-updates-in-3-7/\" title=\"http://make.wordpress.org/core/2013/08/28/core-updates-in-3-7/\">we find out</a> how this will possibly become a reality with WordPress 3.7. A plugin created by Pento called <a href=\"http://wordpress.org/plugins/automatic-updater/\" title=\"http://wordpress.org/plugins/automatic-updater/\">Automatic Updater</a> will be used as the framework to provide this functionality. The first step is for the automation of minor releases. For example 3.7 to 3.7.1 would happen automatically. Andrew Nacin outlines a number of tickets that need to be addressed surrounding this functionality. <span id=\"more-8748\"></span></p>\n<p>One of the first comments on that blog post is from Joshua Strebel, CEO of <a href=\"http://page.ly\" title=\"http://page.ly\">Page.ly</a> which is a large managed WordPress hosting service.</p>\n<blockquote><p>Please consider an opt-out constant/mechanism simply for those of us that run multi-tenancy and manage the entire core package from the top down.</p></blockquote>\n<p>Andrew followed up by noting there will be a mechanism to opt out which will not be accessible from the user interface. Instead, it will most likely be a filter or a constant to not only opt-out of upgrades, but also to enable upgrading to major releases as well in case you wanted full-blown automation. However, they are looking for more feedback from hosting companies and are encouraging them to follow the development of this feature. </p>\n<p>Back around September of 2011, I asked whether <a href=\"http://www.wptavern.com/should-automatic-upgrades-be-opt-in\" title=\"http://www.wptavern.com/should-automatic-upgrades-be-opt-in\">Automatic upgrades for WordPress should be opt-in</a>? Out of 210 votes, 67% or 141 said yes while 69 voted no. At the time, I felt like WordPress wanted to hold my hand too much when it came to managing my install. However, I am completely fine with automatic upgrades to minor releases leaving me to upgrade to major versions when I feel comfortable doing so. The <a href=\"http://www.wptavern.com/should-automatic-upgrades-be-opt-in#comments\" title=\"http://www.wptavern.com/should-automatic-upgrades-be-opt-in#comments\">conversation in the comments</a> following the poll are worth a read, even if the conversation was two years ago. It would be interesting to hear from those who participated in that conversation to see if their views have changed, especially since we now know that the default upgrade functionality will be for minor releases. </p>\n<blockquote><p>I’m just thinking you might want to consider more than the most obvious point of view about upgrades. When was the last time you upgraded Chrome? Did you know it upgraded itself, about twice a week? Did you notice? Did you care? That’s the kind of thing I think we should shoot for. You shouldn’t notice upgrades, they should just happen. And not fail, of course. &#8211; <a href=\"http://www.wptavern.com/should-automatic-upgrades-be-opt-in#comment-12763\" title=\"http://www.wptavern.com/should-automatic-upgrades-be-opt-in#comment-12763\">Otto</a></p></blockquote>\n<p>Hmm, Otto mentioned the way Chrome upgrades in 2011, Matt talks about it as the model for WordPress in 2013 and that&#8217;s the way we&#8217;re headed. Perhaps Otto has a future telling crystal skull?</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/oqbc1vm7NYc\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 30 Aug 2013 05:58:42 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:34;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"WPTavern: WordPress Weekly iTunes Subscription Information\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=8741\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:110:\"http://feedproxy.google.com/~r/WordpressTavern/~3/WUn7j6tszac/wordpress-weekly-itunes-subscription-information\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2024:\"<p>Since the creation of WordPress Weekly back in 2008, I&#8217;ve used <a href=\"http://www.talkshoe.com/tc/34224\" title=\"http://www.talkshoe.com/tc/34224\">Talkshoe.com</a> to record the show in front of a live audience. Over the years, a number of people have subscribed to the iTunes feed provided by Talkshoe. Starting this week, I will no longer be using the Talkshoe iTunes feed but rather, my own. I encourage you to subscribe to the new <a href=\"https://itunes.apple.com/us/podcast/wordpress-weekly/id694849738\" title=\"https://itunes.apple.com/us/podcast/wordpress-weekly/id694849738\">WordPress Weekly iTunes subscription link</a> as all new episodes will be published through it. This frees me from having to be attached to a service to use an iTunes link and as long as iTunes doesn&#8217;t shut down, this should be the last time you&#8217;ll have to change subscription links.</p>\n<p>Alternatively, if you want to subscribe to the show via RSS feed, you can do so through the following URL <a href=\"http://www.wptavern.com/feed/podcast\" title=\"http://www.wptavern.com/feed/podcast\">http://www.wptavern.com/feed/podcast </a></p>\n<p>As a bonus, check out the brand new piece of Podcast cover art for the show created by Becky Crockett of <a href=\"http://www.podcastdesigns.com\" title=\"http://www.podcastdesigns.com\">PodcastDesigns.com</a>. Be warned, the full size image is 1400 X 1400. Becky was a treat to work with and was recommended to me via <a href=\"http://www.wptavern.com/author/mcouch\" title=\"http://www.wptavern.com/author/mcouch\">Marcus Couch</a>. </p>\n<p><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/08/WordPressWeekly_albumart2.jpg\" rel=\"thumbnail\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/08/WordPressWeekly_albumart2.jpg?resize=500%2C500\" alt=\"WordPress Weekly Cover Art\" class=\"aligncenter size-large wp-image-8715\" /></a></p>\n<p>What do you think?</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/WUn7j6tszac\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 29 Aug 2013 18:57:15 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:35;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"Joseph: WordPress UI Ideas From Shaun Andrews\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"https://josephscott.org/?p=9014\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"https://josephscott.org/archives/2013/08/wordpress-ui-ideas-from-shaun-andrews/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:712:\"<p><a href=\"http://www.shaunandrews.com/\">Shaun Andrews</a> has been working on user interface ideas for WordPress.  One of my favorites so far has been about <a href=\"http://www.shaunandrews.com/wordpress/browsing-themes-in-wordpress/\">browsing themes</a>.</p>\n<p><a href=\"http://www.shaunandrews.com/wordpress/browsing-themes-in-wordpress/\"><img src=\"https://sharedat.net/f/KE/KEwS/browsing-themes.png\" width=\"983\" height=\"1024\" class=\"aligncenter\" /></a></p>\n<p>Reminds me of the Netflix and Amazon Prime interfaces on my old Roku box.</p>\n<p>Go follow <a href=\"http://www.shaunandrews.com/\">www.shaunandrews.com</a> to see what he has been up to.  Hopefully some of these will make it into WordPress 3.8.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 29 Aug 2013 15:15:40 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Joseph Scott\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:36;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"WordPress.tv: Taylor Lovett: What You Missed in Computer Science\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=21688\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:81:\"http://wordpress.tv/2013/08/29/taylor-lovett-what-you-missed-in-computer-science/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:697:\"<div id=\"v-ONO5AwK4-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/21688/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/21688/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=21688&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/08/29/taylor-lovett-what-you-missed-in-computer-science/\"><img alt=\"Taylor Lovett: What You Missed in Computer Science\" src=\"http://videos.videopress.com/ONO5AwK4/what-you-missed-in-computer-science_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 29 Aug 2013 11:05:27 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:37;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:41:\"WPTavern: Plugin Review – Leaky Paywall\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=8496\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:89:\"http://feedproxy.google.com/~r/WordpressTavern/~3/DcgKaMjn1fA/plugin-review-leaky-paywall\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5032:\"<h2>Plugin Author, License, And Pricing:</h2>\n<p>Created by the same folks who created the <a href=\"http://www.wptavern.com/creating-a-digital-publication-in-wordpress-with-the-issuem-plugin\" title=\"http://www.wptavern.com/creating-a-digital-publication-in-wordpress-with-the-issuem-plugin\">IssueM plugin</a>. The plugin is licensed under the GPL and has three different pricing tiers. Single site for $55.00, 2-5 sites for $75.00 and 6-25 sites for $95.00. </p>\n<h2>Description And Review:</h2>\n<p>Leaky Paywall takes a different approach to enticing users to pay for content. Normally, paywalls are hard stops that prevent content from being consumed, or shared for that matter unless you pay up. Some of these paywalls are configured in such a way that not only can humans not consume the content, but neither can search engines. Using leaky paywall, site administrators get to decide which combination of content types can be leaked out. The choices range from <em>pages, posts, articles, and Issues</em>, if you have the <a href=\"http://www.wptavern.com/creating-a-digital-publication-in-wordpress-with-the-issuem-plugin\" title=\"http://www.wptavern.com/creating-a-digital-publication-in-wordpress-with-the-issuem-plugin\">IssueM plugin</a> installed. The biggest difference between this paywall system and others is that content behind the paywall can be crawled by search engines and can also be shared via social media. As long as the number of free posts is 1 or higher, articles being shared across social media will not show the paywall message for new visitors. <span id=\"more-8496\"></span></p>\n<p>Leaky Paywall is cookie based which enables it to work as intended. However, it also means that it&#8217;s as simple as deleting cookies to get around the paywall. When I asked Peter what would site administrators do to protect against people getting behind the paywall by either turning cookies off or deleting them once they&#8217;ve hit the free article limit, this was his response:</p>\n<blockquote><p>Nothing, that&#8217;s the leaky part. It works for the NYTimes because 95% of humans are honest or don&#8217;t want to be bothered with having to &#8220;get around&#8221; the system.</p></blockquote>\n<p>You get to choose how many articles can be viewed for free as well as when the free article cookie expires. </p>\n<div id=\"attachment_8498\" class=\"wp-caption aligncenter\"><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/08/LeakyPaywallOptions.jpg\" rel=\"thumbnail\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/08/LeakyPaywallOptions.jpg?resize=500%2C379\" alt=\"Leaky Pay Wall Options\" class=\"size-large wp-image-8498\" /></a><p class=\"wp-caption-text\">Leaky Pay Wall Options</p></div>\n<p>You can configure the subscribe or login message which is the message that will be viewed to those who have reached their free article limit. The message can either use the default CSS style that comes with the plugin or none at all. By default, it will look like this:</p>\n<div id=\"attachment_8499\" class=\"wp-caption aligncenter\"><a href=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/08/LeakyPaywallSubscribeCSS.jpg\" rel=\"thumbnail\"><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/08/LeakyPaywallSubscribeCSS.jpg?resize=500%2C128\" alt=\"Subscribe Box CSS\" class=\"size-large wp-image-8499\" /></a><p class=\"wp-caption-text\">Default CSS</p></div>\n<p>Out of the box, Leaky Paywall only supports the Stripe Payment gateway for recurring payments but there will be more payment processors in the future. </p>\n<h2>Support:</h2>\n<p>There are a couple of different ways of obtaining support. The first is access to <a href=\"http://issuem.com/forums/\" title=\"http://issuem.com/forums/\">basic support forums</a> where registration is free. The second is by purchasing a 1 Month support package for $39 that provides access to the priority support section of the forum with the promise of getting you a response within 8 business hours. The third is a yearly priority support package for $129 that gives you all of the above for a year. There is also <a href=\"http://issuem.com/category/training/\" title=\"http://issuem.com/category/training/\">free access to training material</a> on their training page. </p>\n<h2>Final Thoughts:</h2>\n<p>While I was originally against the idea of Paywalls, something like what Leaky Paywall provides has changed my mind. It&#8217;s not intrusive, the built-in Stripe Payment gateway makes it easy to pay/subscribe to the site without the need for a password and content can still be shared as well as consumed by the outside world without any problems.</p>\n<div class=\"aligncenter\"></div>\n<h2>Coupon Code</h2>\n<p>Readers of WPTavern.com who are interested in purchasing the plugin can use the coupon code <strong>LeakyTavern2013</strong> to receive 50% off the price. There are only 10 available so it&#8217;s first come, first serve. </p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/DcgKaMjn1fA\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 29 Aug 2013 11:00:08 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:38;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"WordPress.tv: Brad Parbs: Getting SASSy – Fun with CSS Preprocessors\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=21700\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:83:\"http://wordpress.tv/2013/08/29/brad-parbs-getting-sassy-fun-with-css-preprocessors/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:687:\"<div id=\"v-rGnRsjzP-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/21700/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/21700/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=21700&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/08/29/brad-parbs-getting-sassy-fun-with-css-preprocessors/\"><img alt=\"Brad Parbs: Getting SASSy – Fun with CSS Preprocessors\" src=\"http://videos.videopress.com/rGnRsjzP/getting-sassy-fun_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 29 Aug 2013 11:00:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:39;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"WPTavern: WP Site Care On WordPress Weekly This Week\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=8730\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:104:\"http://feedproxy.google.com/~r/WordpressTavern/~3/fLKmSbegUj8/wp-site-care-on-wordpress-weekly-this-week\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1476:\"<p><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/08/wpsitecarelogo.jpg\" rel=\"thumbnail\"><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/08/wpsitecarelogo.jpg?resize=300%2C42\" alt=\"WP Site Care Logo\" class=\"alignright size-medium wp-image-8732\" /></a>Ryan Sullivan and Rami Abraham of <a href=\"http://www.wpsitecare.com/\" title=\"http://www.wpsitecare.com/\">WPSitecare</a> will be my special guests this week on WordPress Weekly. WP Site Care is a WordPress Support &#038; Maintenance Company. The first time I discovered a company like WP Site Care was in 2009 which was around the time <a href=\"http://wpcandy.com/reports/one-more-way-to-get-wordpress-help/\" title=\"http://wpcandy.com/reports/one-more-way-to-get-wordpress-help/\">WP HelpCenter</a> was created. On the show, I plan on asking these guys what its like helping people solve WordPress problems on all sorts of different server environments, their thoughts on webhosting, WordPress in general, and much more. If you have any questions you&#8217;d like me to ask them concerning their service, please publish them in the comments.</p>\n<p>Point your browser to the <a href=\"http://www.wptavern.com/wordpress-weekly\" title=\"http://www.wptavern.com/wordpress-weekly\">Podcast page</a> this Friday evening at 9PM eastern in order to participate in the live recording of the show.</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/fLKmSbegUj8\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 28 Aug 2013 23:06:27 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:40;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"WPTavern: Ben Sibley On The State Of WordPress Themes 2013\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=8720\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:110:\"http://feedproxy.google.com/~r/WordpressTavern/~3/t9_ConfMHyE/ben-sibley-on-the-state-of-wordpress-themes-2013\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1908:\"<p><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/08/supportdashlogo.jpg\" rel=\"thumbnail\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/08/supportdashlogo.jpg?resize=217%2C37\" alt=\"Supportdash Logo\" class=\"alignright size-full wp-image-8721\" /></a><a href=\"http://www.supportdash.com\" title=\"http://www.supportdash.com\">Supportdash</a>, a company specializing in providing customer support for WordPress developers has <a href=\"http://www.supportdash.com/state-wordpress-themes/\" title=\"http://www.supportdash.com/state-wordpress-themes/\">published an infographic</a> that highlights the state of WordPress themes. Their survey pretty much has nothing to do with the design of the themes themselves but of trends, where are they being sold, the marketplace, and their support structures. </p>\n<p>A few things I found surprising based on their data.</p>\n<p><strong>They tallied 1,001 theme shops<br />\n300 of those shops were responsible for 4,044 WordPress themes<br />\n872 of the 1,001 theme shops were selling on ThemeForest<br />\n88% of the 1,001 theme shops in the sample offered lifetime support</strong></p>\n<p>I got in touch with Ben Sibley who agreed to have a recorded conversation with me discussing the data he discovered. The short interview is 15 minutes in length where we discussed how the survey was conducted, the things that surprised him and the info surrounding the support numbers. </p>\n<!--[if lt IE 9]><script>document.createElement(\'audio\');</script><![endif]-->\n<a href=\"http://www.wptavern.com/wp-content/uploads/2013/08/Short-Interview-With-Ben-Sibley.mp3\">http://www.wptavern.com/wp-content/uploads/2013/08/Short-Interview-With-Ben-Sibley.mp3</a>\n<p>After reading the data they compiled and listening to the interview, what do you think?</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/t9_ConfMHyE\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 28 Aug 2013 21:31:24 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:41;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:95:\"WordPress.tv: Al Caldarone: Create Your Own Member Access Templates with Custom Sidebar Widgets\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=21694\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:112:\"http://wordpress.tv/2013/08/28/al-caldarone-create-your-own-member-access-templates-with-custom-sidebar-widgets/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:767:\"<div id=\"v-A8ddRkgy-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/21694/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/21694/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=21694&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/08/28/al-caldarone-create-your-own-member-access-templates-with-custom-sidebar-widgets/\"><img alt=\"Al Caldarone: Create Your Own Member Access Templates with Custom Sidebar Widgets\" src=\"http://videos.videopress.com/A8ddRkgy/create-member-access-templates-with-widgets_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 28 Aug 2013 11:01:56 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:42;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"WordPress.tv: Andrew Nacin: WordPress in Transition\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=21732\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"http://wordpress.tv/2013/08/28/andrew-nacin-wordpress-in-transition/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:675:\"<div id=\"v-5GG16zuu-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/21732/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/21732/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=21732&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/08/28/andrew-nacin-wordpress-in-transition/\"><img alt=\"Andrew Nacin: WordPress in Transition WordPress\" src=\"http://videos.videopress.com/5GG16zuu/anything-everything-wordpress_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 28 Aug 2013 10:37:50 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:43;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"WPTavern: Mollom Security Breach\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=8706\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:84:\"http://feedproxy.google.com/~r/WordpressTavern/~3/SeNQaf5t6Yo/mollom-security-breach\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2792:\"<p><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/08/Screen-Shot-2013-08-06-at-3.50.46-PM.png\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/08/Screen-Shot-2013-08-06-at-3.50.46-PM.png?resize=300%2C85\" alt=\"Mollom Logo\" class=\"alignright size-medium wp-image-8327\" /></a>Over the week-end, I received an email from Mollom notifying me that they had discovered a security breach. According to their <a href=\"http://mollom.com/blog/security-notice-august-2013\" title=\"http://mollom.com/blog/security-notice-august-2013\">official blog post</a> on the matter, the breach was discovered on August 21st. Mollom is a service managed by Acquia, a commercial open source software company providing products, services, and technical support for the open source Drupal social publishing system. The service works in a similar fashion to Akismet in that it scans messages such as comments to determine whether or not they are spam. <span id=\"more-8706\"></span></p>\n<blockquote><p>This is an important security notice from the Mollom team. On August 21, we identified a breach of one of our Mollom servers. Our subsequent investigation showed that unauthorized users gained access to Mollom servers and were potentially able to access Mollom data. Today we have closed the security loophole used to gain access and taken measures designed to prevent future breaches.</p>\n<p>Data that may have been compromised includes usernames, account contact information, passwords, Mollom public and private keys, and billing transaction logs. PayPal account information was NOT stored on the affected servers.</p>\n<p>At this time, we have no evidence that any malicious activity took place with customer data. To help assure this continues to be the case, in addition to the measures described above, we have changed all Mollom user account passwords. </p></blockquote>\n<p>Mollom has automatically reset all user account passwords to access the administrative interface. This means you&#8217;ll need to access the <a href=\"http://mollom.com/user/password\" title=\"http://mollom.com/user/password\">following URL</a> in order to reset your password. </p>\n<p>The bottom line is if you signed up to use Mollom free or as a paid customer, you should reset your password and keep a close eye on your financial records, especially if you have or had a paid account even though credit card information was not stored on the affected server. The unauthorized access was <strong>NOT</strong> a direct result of a vulnerability within Drupal. If any additional information is discovered during their investigation, the Mollom team will continue to update the blog post.</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/SeNQaf5t6Yo\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 27 Aug 2013 18:45:37 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:44;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"Matt: Harder, Slower, Less Secure\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=42965\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"http://ma.tt/2013/08/harder-slower-less-secure/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:352:\"<p>Jay Rosen (and Barry Eisler) on the surveillance state&#8217;s efforts <a href=\"http://pressthink.org/2013/08/to-make-journalism-harder-slower-less-secure/\">to make journalism harder, slower, less secure</a>. The gist: why would they destroy hard drives they know there are copies of, and detain couriers they know they&#8217;ll have to release?</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 27 Aug 2013 17:16:24 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:45;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"WPTavern: The Full Story Behind WP-Wallpaper\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=8568\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:96:\"http://feedproxy.google.com/~r/WordpressTavern/~3/3luWcT9hGW8/the-full-story-behind-wp-wallpaper\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6406:\"<p>If you&#8217;ve been scouring the web for WordPress specific images to use as your desktop background, have a look at <a href=\"http://wp-wallpaper.com/\" title=\"http://wp-wallpaper.com/\">WP-Wallpaper</a>. The site doesn&#8217;t have a huge variety of images to choose from now but over the course of the next few months, I think that will change. I reached out to Alison Barrett who manages the site to find out about its history and what plans if any she has for the site. <span id=\"more-8568\"></span></p>\n<div id=\"attachment_8569\" class=\"wp-caption aligncenter\"><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/08/WordPressLights.jpg\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/08/WordPressLights.jpg?resize=439%2C275\" alt=\"WordPress Lights by Alison Barrett \" class=\"size-full wp-image-8569\" /></a><p class=\"wp-caption-text\">WordPress Lights by Alison Barrett</p></div>\n<p><strong>Can you provide a brief history of the domain, considering it existed before you purchased it?</strong></p>\n<p>I don&#8217;t know much about the previous owner of the domain. The original site was my main source of desktop wallpapers for a long time, and I had referred dozens of people to it. I was bummed when I learned the site was down. I went searching for the owner, and I didn&#8217;t realize the domain had expired until the whois search turned up empty.</p>\n<p><strong>Do you know of any other sites that have an abundant amount of WordPress desktop wallpapers?</strong></p>\n<p>I can&#8217;t think of any other dedicated WP wallpaper sites off the top of my head, though a Google search might turn up one or two. I didn&#8217;t come across any when I was searching for the creators of the wallpapers on the original site.</p>\n<p>My initial reason for buying the domain was that I felt bad for referring friends to something that wasn&#8217;t even live anymore. Now I&#8217;m enjoying running the site, and I love seeing all the excitement around it. The community&#8217;s response to it is driving me to keep making it even better. I would love to find the creators of the wallpapers from the original site, because there were a lot of gorgeous images up there. I don&#8217;t want to republish them without attribution and permission.</p>\n<p><strong>Any chance of getting this site linked to from the Fan Art section of WordPress.org or having a small dedicated section showing 3-6 wallpapers?</strong></p>\n<p>I hadn&#8217;t thought about getting this site linked under the Fan Art section on .org—that&#8217;s a great idea! I&#8217;ll see what I can do.</p>\n<p><strong>Any chance of adding a ratings system, reviews, or any other social aspects to the images similar to DeviantArt?</strong></p>\n<p>I do plan on implementing a ratings system eventually, though my priority right now is supporting multiple resolutions for each wallpaper (including mobile). I will probably add some sharing tools in the near future as well.</p>\n<p><strong>How can people submit images to the site and how should the submissions be licensed? </strong></p>\n<p>Wallpapers can be submitted through the form on the submit page: <a href=\"http://wp-wallpaper.com/submit/\" title=\"http://wp-wallpaper.com/submit/\">http://wp-wallpaper.com/submit/</a> . Technical requirements are laid out there (and will be updated once I get mobile resolution support in place). Images must be released under the Creative Commons Attribution Share-Alike license, as that is what they are distributed under on the site.</p>\n<h2>Oops: After The Launch</h2>\n<p>After this interview was conducted with Alison, I did some research into the history of the domain since she didn&#8217;t know too much about it. I plugged the domain into the Wayback machine and didn&#8217;t see any results. For a site that Alison pointed to over the years for WordPress wallpapers, it stands to reason it would have some history behind it. Just for experimentation, I added an S to the end of the domain so it was <a href=\"http://wp-wallpapers.com/\" title=\"http://wp-wallpapers.com/\">http://wp-wallpapers.com/</a> and while that particular domain has expired, it did show up with quite a few results in the Wayback machine.</p>\n<p>The first record on the internet archive is for <a href=\"http://web.archive.org/web/20111017210657/http://wp-wallpapers.com/\" title=\"http://web.archive.org/web/20111017210657/http://wp-wallpapers.com/\">October 17th 2011</a>. This entry tells us that WP-Wallpapers.com used the Expose theme from ThemeForest to show off the content of the site. That theme is still available for sale but is not 100% GPL licensed. </p>\n<p><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/08/WPWallPapers.jpg\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/08/WPWallPapers.jpg?resize=500%2C359\" alt=\"WP Wallpapers\" class=\"aligncenter size-large wp-image-8699\" /></a></p>\n<p>The next entry was a WordPress maintenance page. However, <a href=\"http://web.archive.org/web/20120331034901/http://wp-wallpapers.com/\" title=\"http://web.archive.org/web/20120331034901/http://wp-wallpapers.com/?\">On March 31st 2012</a>, the site had a few pages of Wallpapers available. It&#8217;s also during this time that we discover the site was owned and operated by the Envato network. The last working entry is on <a href=\"http://web.archive.org/web/20130323233732/http://wp-wallpapers.com/\" title=\"http://web.archive.org/web/20130323233732/http://wp-wallpapers.com/\">March 23rd, 2013</a> with at least 5 pages worth of wallpaper images. </p>\n<h2>Conclusions</h2>\n<p>So not only has Alison pointed people to the wrong domain over the years, she also purchased the wrong domain. She missed it by one letter. I reached out to Envato to find out what their plans are for the domain:</p>\n<blockquote><p>We&#8217;re always trying to streamline our processes and focus more on the projects that really matter to us, which is why we decided to discontinue WP-Wallpapers.com. But we&#8217;re really happy to see WP-Wallpaper spring up to fill the gap! There are definitely some beautiful, creative WordPress wallpapers around.</p></blockquote>\n<p>Despite everything that&#8217;s happened up to this point with WP-Wallpaper.com, Alison is still excited to see the site grow. </p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/3luWcT9hGW8\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 27 Aug 2013 04:45:35 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:46;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"WPTavern: My Experience – WordCamp Grand Rapids 2013\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=8635\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:102:\"http://feedproxy.google.com/~r/WordpressTavern/~3/Tu_vAh6bwrA/my-experience-wordcamp-grand-rapids-2013\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:15414:\"<h2>Things I Learned About The City</h2>\n<p>This event marks the first time I&#8217;ve visited Grand Rapids, Michigan. I can say without any doubt that Grand Rapids is a beautiful city. I got the impression while being downtown that I was in a large city but it wasn&#8217;t large enough to feel inundated like New York or San Francisco. The skyline has large buildings but you can still see the horizon in some parts of downtown. The city also has a wide river that flows through and around the city which from what I&#8217;ve read, is the origin of the city&#8217;s name. However, I saw the river as wide, shallow, and nothing rapid about it. There is talk in the local community around the idea of placing large boulders back into the river to generate rapids but I&#8217;m unsure of that progress. <span id=\"more-8635\"></span></p>\n<p>The other thing I learned while in Grand Rapids was the number of local breweries in the region. I had the pleasure of eating at two of these breweries. One was called <a href=\"http://foundersbrewing.com/\" title=\"http://foundersbrewing.com/\">Founders</a>, the other was <a href=\"http://www.grbrewingcompany.com/\" title=\"http://www.grbrewingcompany.com/\">Grand Rapids Brewing Company</a>. The food was excellent in both locations and although I didn&#8217;t drink any beer since I&#8217;m not a hoppy kind of guy, the WordCamp attendees I was surrounded by couldn&#8217;t stop raving about some of the beers they tasted at each place. The third place I ate at in which I did try a beer (Brouwerij Lindeman Vlezenbeek, Belgium a raspberry flavored beer) was <a href=\"http://hopcatgr.com/main/About.aspx\" title=\"http://hopcatgr.com/main/About.aspx\">HopCat</a>. A place with something called &#8216;<strong>Crack Fries</strong>&#8216;. These crack fries are considered famous in the area because of the unique blend of spices applied to them. After eating them, you&#8217;ll understand why they have their name.</p>\n<h2>The Event Itself</h2>\n<p>The event was held at the <a href=\"http://www.gvsu.edu/\" title=\"http://www.gvsu.edu/\">DeVos Center on Grand Valley State University’s Pew Campus</a> in downtown Grand Rapids. Out of all the WordCamps I&#8217;ve attended, those that are at some sort of college campus location have gone smoothly. This one was no exception. Although I didn&#8217;t attend very many sessions, I did manage to catch up with quite a few people to talk shop and other interesting things going on in the world of WordPress. At this particular WordCamp, I moderated a panel discussion on the topic of Commercial Themes and Plugins with Pippin Williamson, Adam Pickering, Daniel Espinoza, and Jake Caputo. I think the session went over rather well and we covered a lot of information. The one thing that kept coming up multiple times during the talk was support. It&#8217;s expensive but it&#8217;s also the most valuable and potentially the most vital aspect of any business. We also discussed various methods to handle support as forums are great at the early stage but something like ZenDesk and tickets make sense for larger volumes of support requests. I definitely took some feedback to heart concerning my delivery and approach on stage during the session and if I ever moderate a panel like this again, the second one will be 10 times better than the first. Thanks to Brian Richards, one of the event organizers for giving me the opportunity to moderate the panel.</p>\n<p>The session that opened my eyes was <a href=\"http://2013.grandrapids.wordcamp.org/session/scoping-projects-a-therapy-session-for-those-who-do-client-work/\" title=\"http://2013.grandrapids.wordcamp.org/session/scoping-projects-a-therapy-session-for-those-who-do-client-work/\">Scoping Projects</a> – A Therapy Session For Those Who Do Client Work Lisa Sabin-Wilson. Not so much from the perspective of the consultant but from the perspective of a client, realizing everything the consultant has to go through to get the job done. Her idea of scoping and how important it is to get everything on the table before starting work was key. She also discussed why having assumptions can costs you big bucks, wasted time, and make you look bad in front of the client. There should be 0 assumptions from both parties in a project. As a future client myself, I realized that I could make the process go a lot easier for both parties if I scoped out everything I wanted, every nuance, provided documentation, references for ideas and inspiration, etc. The more information I can provide the consultant about my needs, the better off we&#8217;ll both be. It was a session that I didn&#8217;t think would appeal to me but it was the most eye-opening one I&#8217;ve attended in a long time. It was an interesting experience being in a room full of people and seeing/hearing their reaction when Lisa mentioned that <a href=\"http://lisasabin-wilson.com/tighten-up-those-terms-and-keep-copies-of-everything-forever/\" title=\"http://lisasabin-wilson.com/tighten-up-those-terms-and-keep-copies-of-everything-forever/\">she had been investigated by the FBI</a> and to perform a Google search to read about it. I won&#8217;t spoil it for you, you&#8217;ll just have to read her post. </p>\n<h2>Conclusion</h2>\n<p>Most of the time during the week-end I was involved in multiple conversations with all sorts of people doing awesome things with WordPress. Overall, it was a fantastic event. The organizers as well as the volunteers should be proud of themselves. I had such a good experience within Grand Rapids that I&#8217;m thinking of taking my wife there to experience more of the city. While contributor day was awesome at WordCamp San Francisco, it was nowhere near as effective at WordCamp Grand Rapids. I think a lot of that has to do with the right people not being in attendance such as core contributors, project managers, etc. With that said, those who did show up to contributor day were working with other people on WordPress or were taking the knowledge and ideas they gained the past two days to improve their own sites or projects. This has me wondering if any other WordCamp will be able to have a contributor day as beneficial as the one held at WordCamp San Francisco 2013? </p>\n\n<a href=\"http://www.wptavern.com/my-experience-wordcamp-grand-rapids-2013/attachment/565\" title=\"CedarPoint From The Sky\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/08/565.png?resize=150%2C150\" class=\"attachment-thumbnail\" alt=\"CedarPoint From The Sky\" /></a>\n<a href=\"http://www.wptavern.com/my-experience-wordcamp-grand-rapids-2013/attachment/570\" title=\"Sandwich From Grand Rapids Brewery\"><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/08/570.png?resize=150%2C150\" class=\"attachment-thumbnail\" alt=\"Sandwich From Grand Rapids Brewery\" /></a>\n<a href=\"http://www.wptavern.com/my-experience-wordcamp-grand-rapids-2013/attachment/571\" title=\"View From The Amway Grand\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/08/571.png?resize=150%2C150\" class=\"attachment-thumbnail\" alt=\"View From The Amway Grand\" /></a>\n<a href=\"http://www.wptavern.com/my-experience-wordcamp-grand-rapids-2013/attachment/572\" title=\"Van Andel Arena\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/08/572.png?resize=150%2C150\" class=\"attachment-thumbnail\" alt=\"Van Andel Arena\" /></a>\n<a href=\"http://www.wptavern.com/my-experience-wordcamp-grand-rapids-2013/attachment/573\" title=\"Van Andel Statue\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/08/573.png?resize=150%2C150\" class=\"attachment-thumbnail\" alt=\"Van Andel Statue\" /></a>\n<a href=\"http://www.wptavern.com/my-experience-wordcamp-grand-rapids-2013/attachment/574\" title=\"GR Brewing Company\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/08/574.png?resize=150%2C150\" class=\"attachment-thumbnail\" alt=\"GR Brewing Company\" /></a>\n<a href=\"http://www.wptavern.com/my-experience-wordcamp-grand-rapids-2013/attachment/575\" title=\"GR Brewing Company Sign\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/08/575.png?resize=150%2C150\" class=\"attachment-thumbnail\" alt=\"GR Brewing Company Sign\" /></a>\n<a href=\"http://www.wptavern.com/my-experience-wordcamp-grand-rapids-2013/attachment/576\" title=\"J Gardellas Sign\"><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/08/576.png?resize=150%2C150\" class=\"attachment-thumbnail\" alt=\"J Gardellas Sign\" /></a>\n<a href=\"http://www.wptavern.com/my-experience-wordcamp-grand-rapids-2013/attachment/577\" title=\"Albert Einstein\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/08/577.png?resize=150%2C150\" class=\"attachment-thumbnail\" alt=\"Albert Einstein\" /></a>\n<a href=\"http://www.wptavern.com/my-experience-wordcamp-grand-rapids-2013/attachment/580\" title=\"Blue Bridge Skyline\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/08/580.png?resize=150%2C150\" class=\"attachment-thumbnail\" alt=\"Blue Bridge Skyline\" /></a>\n<a href=\"http://www.wptavern.com/my-experience-wordcamp-grand-rapids-2013/attachment/582\" title=\"Peace Sign In The Grand River\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/08/582.png?resize=150%2C150\" class=\"attachment-thumbnail\" alt=\"Peace Sign In The Grand River\" /></a>\n<a href=\"http://www.wptavern.com/my-experience-wordcamp-grand-rapids-2013/attachment/584\" title=\"River With Skyline\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/08/584.png?resize=150%2C150\" class=\"attachment-thumbnail\" alt=\"River With Skyline\" /></a>\n<a href=\"http://www.wptavern.com/my-experience-wordcamp-grand-rapids-2013/attachment/588\" title=\"Large Bridge\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/08/588.png?resize=150%2C150\" class=\"attachment-thumbnail\" alt=\"Large Bridge\" /></a>\n<a href=\"http://www.wptavern.com/my-experience-wordcamp-grand-rapids-2013/attachment/589\" title=\"Sign About Pew Campus\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/08/589.png?resize=150%2C150\" class=\"attachment-thumbnail\" alt=\"Sign About Pew Campus\" /></a>\n<a href=\"http://www.wptavern.com/my-experience-wordcamp-grand-rapids-2013/attachment/590\" title=\"Front Of DeVos Center\"><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/08/590.png?resize=150%2C150\" class=\"attachment-thumbnail\" alt=\"Front Of DeVos Center\" /></a>\n<a href=\"http://www.wptavern.com/my-experience-wordcamp-grand-rapids-2013/attachment/591\" title=\"DeVos Clock Tower\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/08/591.png?resize=150%2C150\" class=\"attachment-thumbnail\" alt=\"DeVos Clock Tower\" /></a>\n<a href=\"http://www.wptavern.com/my-experience-wordcamp-grand-rapids-2013/attachment/592\" title=\"DeVos Campus\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/08/592.png?resize=150%2C150\" class=\"attachment-thumbnail\" alt=\"DeVos Campus\" /></a>\n<a href=\"http://www.wptavern.com/my-experience-wordcamp-grand-rapids-2013/attachment/593\" title=\"WCGR Badge 1\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/08/593.png?resize=150%2C150\" class=\"attachment-thumbnail\" alt=\"WCGR Badge 1\" /></a>\n<a href=\"http://www.wptavern.com/my-experience-wordcamp-grand-rapids-2013/attachment/594\" title=\"WCGR Badge 2\"><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/08/594.png?resize=150%2C150\" class=\"attachment-thumbnail\" alt=\"WCGR Badge 2\" /></a>\n<a href=\"http://www.wptavern.com/my-experience-wordcamp-grand-rapids-2013/attachment/595\" title=\"WCGR Badge 3\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/08/595.png?resize=150%2C150\" class=\"attachment-thumbnail\" alt=\"WCGR Badge 3\" /></a>\n<a href=\"http://www.wptavern.com/my-experience-wordcamp-grand-rapids-2013/attachment/596\" title=\"WCGR Badge 4\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/08/596.png?resize=150%2C150\" class=\"attachment-thumbnail\" alt=\"WCGR Badge 4\" /></a>\n<a href=\"http://www.wptavern.com/my-experience-wordcamp-grand-rapids-2013/attachment/597\" title=\"WCGR Badge 5\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/08/597.png?resize=150%2C150\" class=\"attachment-thumbnail\" alt=\"WCGR Badge 5\" /></a>\n<a href=\"http://www.wptavern.com/my-experience-wordcamp-grand-rapids-2013/attachment/598\" title=\"Grand Rapids Night Shot 1\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/08/598.png?resize=150%2C150\" class=\"attachment-thumbnail\" alt=\"Grand Rapids Night Shot 1\" /></a>\n<a href=\"http://www.wptavern.com/my-experience-wordcamp-grand-rapids-2013/attachment/599\" title=\"Grand Rapids Night Shot 2\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/08/599.png?resize=150%2C150\" class=\"attachment-thumbnail\" alt=\"Grand Rapids Night Shot 2\" /></a>\n<a href=\"http://www.wptavern.com/my-experience-wordcamp-grand-rapids-2013/attachment/600\" title=\"Grand Rapids Night Shot 3\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/08/600.png?resize=150%2C150\" class=\"attachment-thumbnail\" alt=\"Grand Rapids Night Shot 3\" /></a>\n<a href=\"http://www.wptavern.com/my-experience-wordcamp-grand-rapids-2013/attachment/601\" title=\"Grand Rapids Night Shot 4\"><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/08/601.png?resize=150%2C150\" class=\"attachment-thumbnail\" alt=\"Grand Rapids Night Shot 4\" /></a>\n<a href=\"http://www.wptavern.com/my-experience-wordcamp-grand-rapids-2013/attachment/604\" title=\"Grand Rapids Night Shot 5\"><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/08/604.png?resize=150%2C150\" class=\"attachment-thumbnail\" alt=\"Grand Rapids Night Shot 5\" /></a>\n<a href=\"http://www.wptavern.com/my-experience-wordcamp-grand-rapids-2013/attachment/605\" title=\"Amway Grand Hotel\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/08/605.png?resize=150%2C150\" class=\"attachment-thumbnail\" alt=\"Amway Grand Hotel\" /></a>\n<a href=\"http://www.wptavern.com/my-experience-wordcamp-grand-rapids-2013/attachment/606\" title=\"Front Of The Amway\"><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/08/606.png?resize=150%2C150\" class=\"attachment-thumbnail\" alt=\"Front Of The Amway\" /></a>\n<a href=\"http://www.wptavern.com/my-experience-wordcamp-grand-rapids-2013/attachment/608\" title=\"Hop Cat Menu\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/08/608.png?resize=150%2C150\" class=\"attachment-thumbnail\" alt=\"Hop Cat Menu\" /></a>\n<a href=\"http://www.wptavern.com/my-experience-wordcamp-grand-rapids-2013/attachment/609\" title=\"Hop Cat Bruschetta\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/08/609.png?resize=150%2C150\" class=\"attachment-thumbnail\" alt=\"Hop Cat Bruschetta\" /></a>\n<a href=\"http://www.wptavern.com/my-experience-wordcamp-grand-rapids-2013/attachment/610\" title=\"Crack Fries 1\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/08/610.png?resize=150%2C150\" class=\"attachment-thumbnail\" alt=\"Crack Fries 1\" /></a>\n<a href=\"http://www.wptavern.com/my-experience-wordcamp-grand-rapids-2013/attachment/611\" title=\"Crack Fries 2\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/08/611.png?resize=150%2C150\" class=\"attachment-thumbnail\" alt=\"Crack Fries 2\" /></a>\n\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/Tu_vAh6bwrA\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 27 Aug 2013 03:34:51 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:47;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:41:\"WordPress.tv: Al Davis: After the Install\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=21549\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"http://wordpress.tv/2013/08/26/al-davis-after-the-install-3/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:634:\"<div id=\"v-OTMvdJ53-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/21549/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/21549/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=21549&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/08/26/al-davis-after-the-install-3/\"><img alt=\"Al Davis: After the Install\" src=\"http://videos.videopress.com/OTMvdJ53/video-37ea15f1d5_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 26 Aug 2013 17:09:28 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:48;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"WordPress.tv: Brewster Kahle: Internet Archive and Preserving WordPress Blogs\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=21510\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:94:\"http://wordpress.tv/2013/08/26/brewster-kahle-internet-archive-and-preserving-wordpress-blogs/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:752:\"<div id=\"v-WPFuoh55-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/21510/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/21510/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=21510&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/08/26/brewster-kahle-internet-archive-and-preserving-wordpress-blogs/\"><img alt=\"Brewster Kahle: Internet Archive and Preserving WordPress Blogs\" src=\"http://videos.videopress.com/WPFuoh55/4-brewster-kahle-internet-archive-and-preserving-wordpress-blogs_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 26 Aug 2013 16:20:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:49;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"Joseph: Salt Lake City WordPress Meetup This Wednesday\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"https://josephscott.org/?p=8983\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:88:\"https://josephscott.org/archives/2013/08/salt-lake-city-wordpress-meetup-this-wednesday/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:460:\"<p>The <a href=\"http://wpslc.com/\">Salt Lake City WordPress Meetup</a> is happening this Wednesday, August 28th.  <a href=\"http://wpslc.com/blog/2013/08/21/august-28th-meetup-brian-petty-i-found-a-bug-what-next/\">Brian Petty is going to talk</a> about how to report bugs and submit patches back to the WordPress project.</p>\n<p>It will be at the MoJo Themes office in Draper at 7pm.  Check out <a href=\"http://wpslc.com/\">wpslc.com</a> for all the details.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 26 Aug 2013 13:15:56 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Joseph Scott\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:9:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Sat, 07 Sep 2013 17:45:55 GMT\";s:12:\"content-type\";s:8:\"text/xml\";s:14:\"content-length\";s:6:\"182764\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:13:\"last-modified\";s:29:\"Sat, 07 Sep 2013 17:30:14 GMT\";s:4:\"x-nc\";s:11:\"HIT lax 249\";s:13:\"accept-ranges\";s:5:\"bytes\";}s:5:\"build\";s:14:\"20130902175941\";}", "no");
INSERT INTO `wp_options` VALUES("346", "_transient_timeout_feed_mod_867bd5c64f85878d03a060509cd2f92c", "1378619156", "no");
INSERT INTO `wp_options` VALUES("347", "_transient_feed_mod_867bd5c64f85878d03a060509cd2f92c", "1378575956", "no");
INSERT INTO `wp_options` VALUES("348", "_transient_timeout_dash_aa95765b5cc111c56d5993d476b1c2f0", "1378619156", "no");
INSERT INTO `wp_options` VALUES("349", "_transient_dash_aa95765b5cc111c56d5993d476b1c2f0", "<div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'http://wordpress.tv/2013/09/07/john-james-jacoby-wonderful-wordpress-workflow/\' title=\'     \'>WordPress.tv: John James Jacoby: Wonderful WordPress Workflow</a></li><li><a class=\'rsswidget\' href=\'http://wordpress.tv/2013/09/07/brennen-byrne-employing-best-security-practices-for-wordpress-sites/\' title=\'     \'>WordPress.tv: Brennen Byrne: Employing Best Security Practices for WordPress Sites</a></li><li><a class=\'rsswidget\' href=\'http://feedproxy.google.com/~r/WordpressTavern/~3/n04-e-RlBu8/password-free-login-with-clef-hits-all-the-high-notes\' title=\'Recently I have been reviewing a number of wp-admin login alternatives that allow for login via phone. The first among the plugins tested was LaunchKey, which I spoke about in this LaunchKey Review post. Though the functionality of LaunchKey was promising, it seemed to explode on the launching pad when it came to initial setup. Even with the valiant efforts in an hour-long back-and-forth exchange with their support team on Twitter to get me going, it seemed that the setup challenges were the biggest obstacles. It was so frustrating that I opted to delete LaunchKey altogether and forever give up on the idea of secure, remote smartphone-enabled logins.  Sensing my frustration and desire to get this technology implemented in my installations, the team over at GetClef.com decided to get to work. They created something for me that not only had every piece of functionality that I was looking for, but they did it with an installation process that took no more than 60 seconds to install the app on my iPhone, install the plugin and have them both talking to each other. OK, so they didn’t create it for me specifically, but from how beautifully this integrates, it sure feels like they completely read my mind in regards to the functionality and ease of use that I was looking for! To begin, you simply navigate to the Clef app page which asks for your mobile number. Once entered, Clef will text you the link to install the app on your phone. Currently both iOS and Android versions are available for integration with the Clef plugin. Once installed, the app will have you set up a pin number to protect anyone from using it to login to your sites. So even if you lose your phone, you won’t have to worry that someone out there can login to all your sites. Clef is touted as the simplest way to login to multiple sites without passwords in a secure, encrypted way that is as easy to use as taking a photo. Here’s Clef’s Brennen Byrne giving us a quick walk-through on how the system works and what it does.  As stated in the video, one scan of the QR code enables complete login of ALL your WordPress installations. If you login to one site that is Clef-Enabled, you have access to every other Clef-capable site in your network without having to login again. I can’t stress enough how much of a time-saving feature this is. Often I work with collaboration teams and outsource workers that often require access to one or several of my WordPress web properties. This tool allows me to easily add and remove credentials for an individual within Clef on a network wide basis, so I can assign a person specific properties to work on. When they are finished with the tasks and milestones assigned, I can simply remove them network wide and not have to be burdened to login to each individual site to remove the user credentials or their permissions. From a designer and developer perspective, this is a really great selling point to include in your design proposals and specs to clients. Larger companies and organizations can easily manage user roles and login capabilities by implementing Clef for their WordPress installs. It’s just one more tool that gives WordPress the decided advantage over using other CMS platforms. Let’s also talk about the security reinforcement of this app/plugin combo. How many of you out there use the same admin password for all your installations? Come on, I know there are lots of you out there that do this. It’s a bad practice to get into because once one of your sites is compromised, they all are. Most of us don’t like to use different passwords, especially if our network is 50-100 installations deep. Clef can make it easier for you to keep your logins in one place without exposing yourself by using duplicate passwords across your network. Even if you are just passively intrigued at the concept of remote gadget WordPress logins, Clef is worth investigating. With remarkably quick setup and ease of use, this plugin has earned a permanent spot in my everyday plugin roster. I love the advancements that WordPress is making with device integration and Clef is just another great reinforcement as to why we love using WordPress so much! \'>WPTavern: Password Free Login With Clef Hits All The High Notes</a></li><li><a class=\'rsswidget\' href=\'http://feedproxy.google.com/~r/WordpressTavern/~3/8TOECMZ944s/7-surprising-results-from-the-2013-buddypress-codex-survey\' title=\'The results of the BuddyPress codex survey are in! 178 BuddyPress developers participated in the survey and the information they provided will help the team to prioritize short-term and long-term tasks for improving the BP Codex. Community developers @hnla and @mercime are spearheading the effort to improve the BuddyPress codex for the BP 1.9 release. While this survey is packed full of fascinating results, I’d like to highlight just a few of them here: Nearly 50% of BuddyPress sites are in languages other than English. Respondents hailed from 36 different countries and results show that 56% of BuddyPress sites are built using English as the language and the other half is comprised of various languages from around the world. The top 10 include:  1) English (56%), 2) Spanish, 3) Italian, 4) French, 5) German, 6) Dutch, 7) Swedish, 8) Portugese, 9) Chinese, and 10) Greek.  It’s clear to see that BuddyPress is an international community. We’re spread out all over the globe! If you’re a BuddyPress plugin developer, you need to localize your plugins. Hopefully we can include some more detailed references on localization when it comes time to revamp the codex. Only 15% of BuddyPress sites surveyed make use of the Friends component. When you think about social networks, oftentimes the friends component is what you might assume would be the most important. This survey reveals otherwise:  I was surprised that the Groups component wasn’t activated on more sites, as it is probably the most flexible and has the most extensions. These numbers might indicate that many people are using BuddyPress for its more robust profile and account management capabilities, rather than for its social features. Not one of the social components reached more than 20%. 90% of BuddyPress developers surveyed are male.  Do these numbers surprise you? I would have imagined there would be a few more female developers who responded, but perhaps the survey did not reach them. However, these numbers really should not deter female developers from getting involved. From my experience attending BuddyCamp Vancouver, the BuddyPress community is made up of some of the nicest people you will ever meet. Even in the support forums you will find that people are generally very welcoming and helpful to new developers. BuddyPress is still a relatively small community and it’s easy to start getting involved and making a difference. People prefer to learn BuddyPress through written tutorials.  This has been my suspicion for awhile and now it is confirmed. Developers are not looking for fancy video tutorials and they are only marginally interested in books and in-person training when it comes to learning about BuddydPress. They want written tutorials, references and guides that they can quickly scan and come back to when needed. 39% of BuddyPress sites are installed within a WordPress multisite network.  Perhaps this one isn’t much of a surprise, given that in the beginning you could only use BuddyPress with WordPress multisite. After BuddyPress was made to be compatible with single site WordPress installations, one would have thought that they would become the vast majority, since it’s the easiest way to set up WordPress. But it appears that usage on multisite vs. single site is almost 50/50. What this tells me is that blogs are still a very important aspect of BuddyPress social networks.  What does this mean for the codex? We absolutely need more documentation on using BuddyPress within a multisite environment.  The biggest complaint about the codex is that the documentation is incomplete and difficult to navigate.  It looks like the largest task at hand will be to fill in any bald spots in the codex and improve the navigation. It’s not so much that the content is unclear or outdated but rather it’s just not there at all. Creating new sections and adding to existing ones will probably be the main focus in improving the codex. 35% of BuddyPress developers surveyed are willing to contribute to the codex. Wow, that’s an amazing response from the BuddyPress community developers who are ready and willing to help make the codex a more useful resource. Many thanks to @hnla and @mercime for all their hard work in analyzing the responses from the survey and providing these handy graphs for these results. By far, one of the biggest complaints about BuddyPress is the lack of documentation. With all the capable volunteers stepping forward, things are about to change for the better. \'>WPTavern: 7 Surprising Results From The 2013 BuddyPress Codex Survey</a></li><li><a class=\'rsswidget\' href=\'http://feedproxy.google.com/~r/WordpressTavern/~3/Zf81S3bXaFY/coming-soon-inline-documentation-for-all-wordpress-hooks\' title=\'Something exciting is happening in the world of WordPress documentation. Very soon all of the hooks used throughout the core are going to be documented. An initiative is now underway to bring inline docs for hooks into the upcoming WordPress 3.7 release. I can see some of you jumping up and down and celebrating wildly right now. But there are probably more than a few of you who are wondering “What in the world is a hook?” You will see the terms “actions/filters” and “hooks” throughout the codex and it can get a little confusing. Hooks are split into actions and filters. Essentially, hooks are events that allow you to “hook” into WordPress and make it do stuff. The codex Plugin API/Action Reference page lists all existing hooks, some of which have been documented. Inline documentation of hooks will make it much easier for developers to extend WordPress. Each hook gets a quick explanation and the @since version added as a comment. For example, check out the notes for do_action( ‘welcome_panel’ );  If you wanted to add some content to the WordPress welcome panel but didn’t know how, this inline documentation will help to point you in the right direction. A handful of contributors are currently tackling a massive list of hooks in 195 files. If you can help, leave a comment on the make.wordpress.org post to claim the files you’ll be working on and then add separate patches for each to the Add Inline Docs for Hooks trac ticket. Make sure to review the hook documentation standards before submitting a patch. Developers always say that if you want to learn WordPress, the best way to start is by going through the core to find out how it all works. Inline documentation for hooks will make this easier than ever. Although it’s a monumental task to coordinate, the end result is that WordPress will be much more approachable for developers who are new to the platform. \'>WPTavern: Coming Soon: Inline Documentation For All WordPress Hooks</a></li></ul></div>", "no");
INSERT INTO `wp_options` VALUES("356", "_transient_timeout_feed_mod_77fa140e07ce53fe8c87136636f83d72", "1378619156", "no");
INSERT INTO `wp_options` VALUES("357", "_transient_feed_mod_77fa140e07ce53fe8c87136636f83d72", "1378575956", "no");
INSERT INTO `wp_options` VALUES("360", "_transient_timeout_dash_de3249c4736ad3bd2cd29147c4a0d43e", "1378619156", "no");
INSERT INTO `wp_options` VALUES("361", "_transient_dash_de3249c4736ad3bd2cd29147c4a0d43e", "<h4>Most Popular</h4>\n<h5><a href=\'http://wordpress.org/plugins/better-wp-security/\'>Better WP Security</a></h5>&nbsp;<span>(<a href=\'plugin-install.php?tab=plugin-information&amp;plugin=better-wp-security&amp;_wpnonce=d35891c6d1&amp;TB_iframe=true&amp;width=600&amp;height=800\' class=\'thickbox\' title=\'Better WP Security\'>Install</a>)</span>\n<p>The easiest, most effective way to secure WordPress. Improve the security of any WordPress site in seconds.</p>\n<h4>Newest Plugins</h4>\n<h5><a href=\'http://wordpress.org/plugins/inn-style-widget/\'>Inn Style Widget</a></h5>&nbsp;<span>(<a href=\'plugin-install.php?tab=plugin-information&amp;plugin=inn-style-widget&amp;_wpnonce=c2c79151c4&amp;TB_iframe=true&amp;width=600&amp;height=800\' class=\'thickbox\' title=\'Inn Style Widget\'>Install</a>)</span>\n<p>Inn Style WordPress Widget</p>\n", "no");

/* INSERT TABLE DATA: wp_postmeta */
INSERT INTO `wp_postmeta` VALUES("1", "2", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("6", "6", "_wp_attached_file", "2013/09/file000707145868.jpg");
INSERT INTO `wp_postmeta` VALUES("7", "6", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:223;s:6:\"height\";i:300;s:4:\"file\";s:28:\"2013/09/file000707145868.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:28:\"file000707145868-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:28:\"file000707145868-222x160.jpg\";s:5:\"width\";i:222;s:6:\"height\";i:160;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:16:\"slider-top-large\";a:4:{s:4:\"file\";s:28:\"file000707145868-223x250.jpg\";s:5:\"width\";i:223;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"slider-large\";a:4:{s:4:\"file\";s:28:\"file000707145868-223x250.jpg\";s:5:\"width\";i:223;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"slider-middle\";a:4:{s:4:\"file\";s:28:\"file000707145868-223x250.jpg\";s:5:\"width\";i:223;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:16:\"slider-thumbnail\";a:4:{s:4:\"file\";s:26:\"file000707145868-80x50.jpg\";s:5:\"width\";i:80;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"post-thumbnails\";a:4:{s:4:\"file\";s:28:\"file000707145868-222x160.jpg\";s:5:\"width\";i:222;s:6:\"height\";i:160;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";d:2.5;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:4:\"E990\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:1004650233;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:3:\"8.2\";s:3:\"iso\";s:3:\"100\";s:13:\"shutter_speed\";s:16:\"0.00836820083682\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("8", "7", "_wp_attached_file", "2013/09/file000536952144.jpg");
INSERT INTO `wp_postmeta` VALUES("9", "7", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:199;s:6:\"height\";i:300;s:4:\"file\";s:28:\"2013/09/file000536952144.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:28:\"file000536952144-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:28:\"file000536952144-199x160.jpg\";s:5:\"width\";i:199;s:6:\"height\";i:160;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:16:\"slider-top-large\";a:4:{s:4:\"file\";s:28:\"file000536952144-199x250.jpg\";s:5:\"width\";i:199;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"slider-large\";a:4:{s:4:\"file\";s:28:\"file000536952144-199x250.jpg\";s:5:\"width\";i:199;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"slider-middle\";a:4:{s:4:\"file\";s:28:\"file000536952144-199x250.jpg\";s:5:\"width\";i:199;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:16:\"slider-thumbnail\";a:4:{s:4:\"file\";s:26:\"file000536952144-80x50.jpg\";s:5:\"width\";i:80;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"post-thumbnails\";a:4:{s:4:\"file\";s:28:\"file000536952144-199x160.jpg\";s:5:\"width\";i:199;s:6:\"height\";i:160;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";d:7.0999999999999996447286321199499070644378662109375;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:6:\"DSC-R1\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:1178491397;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:4:\"71.5\";s:3:\"iso\";s:3:\"160\";s:13:\"shutter_speed\";s:4:\"0.01\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("10", "8", "_wp_attached_file", "2013/09/file0001580390516.jpg");
INSERT INTO `wp_postmeta` VALUES("11", "8", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:300;s:6:\"height\";i:200;s:4:\"file\";s:29:\"2013/09/file0001580390516.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:29:\"file0001580390516-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:29:\"file0001580390516-222x160.jpg\";s:5:\"width\";i:222;s:6:\"height\";i:160;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:16:\"slider-thumbnail\";a:4:{s:4:\"file\";s:27:\"file0001580390516-80x50.jpg\";s:5:\"width\";i:80;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"post-thumbnails\";a:4:{s:4:\"file\";s:29:\"file0001580390516-222x160.jpg\";s:5:\"width\";i:222;s:6:\"height\";i:160;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("12", "1", "_edit_lock", "1378240099:1");
INSERT INTO `wp_postmeta` VALUES("13", "1", "_thumbnail_id", "6");
INSERT INTO `wp_postmeta` VALUES("14", "1", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("28", "10", "_wp_attached_file", "2013/09/head.jpg");
INSERT INTO `wp_postmeta` VALUES("17", "1", "_cc_page_slider_on", "0");
INSERT INTO `wp_postmeta` VALUES("18", "1", "_cc_page_slider_cat", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("19", "1", "_cc_page_template_on", "0");
INSERT INTO `wp_postmeta` VALUES("20", "1", "_cc_page_template_cat", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("21", "1", "_cc_page_slider_caption", "0");
INSERT INTO `wp_postmeta` VALUES("22", "1", "_cc_post_template_on", "0");
INSERT INTO `wp_postmeta` VALUES("23", "1", "_cc_post_template_type", "img-left-content-right");
INSERT INTO `wp_postmeta` VALUES("24", "1", "_cc_post_template_avatar", "0");
INSERT INTO `wp_postmeta` VALUES("25", "1", "_cc_post_template_date", "0");
INSERT INTO `wp_postmeta` VALUES("26", "1", "_cc_post_template_tags", "0");
INSERT INTO `wp_postmeta` VALUES("27", "1", "_cc_post_template_comments_info", "0");
INSERT INTO `wp_postmeta` VALUES("29", "10", "_wp_attachment_context", "custom-header");
INSERT INTO `wp_postmeta` VALUES("30", "10", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1000;s:6:\"height\";i:233;s:4:\"file\";s:16:\"2013/09/head.jpg\";s:5:\"sizes\";a:9:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:16:\"head-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:15:\"head-300x69.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:69;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:16:\"head-222x160.jpg\";s:5:\"width\";i:222;s:6:\"height\";i:160;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"slider-large\";a:4:{s:4:\"file\";s:16:\"head-990x233.jpg\";s:5:\"width\";i:990;s:6:\"height\";i:233;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:17:\"slider-responsile\";a:4:{s:4:\"file\";s:16:\"head-925x233.jpg\";s:5:\"width\";i:925;s:6:\"height\";i:233;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"slider-middle\";a:4:{s:4:\"file\";s:16:\"head-756x233.jpg\";s:5:\"width\";i:756;s:6:\"height\";i:233;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:16:\"slider-thumbnail\";a:4:{s:4:\"file\";s:14:\"head-80x50.jpg\";s:5:\"width\";i:80;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"post-thumbnails\";a:4:{s:4:\"file\";s:16:\"head-222x160.jpg\";s:5:\"width\";i:222;s:6:\"height\";i:160;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"single-post-thumbnail\";a:4:{s:4:\"file\";s:16:\"head-598x233.jpg\";s:5:\"width\";i:598;s:6:\"height\";i:233;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("31", "10", "_wp_attachment_is_custom_header", "custom-community");
INSERT INTO `wp_postmeta` VALUES("32", "11", "_wp_attached_file", "2013/09/cropped-header.jpg");
INSERT INTO `wp_postmeta` VALUES("33", "11", "_wp_attachment_context", "custom-header");
INSERT INTO `wp_postmeta` VALUES("34", "11", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1000;s:6:\"height\";i:233;s:4:\"file\";s:26:\"2013/09/cropped-header.jpg\";s:5:\"sizes\";a:9:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:26:\"cropped-header-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:25:\"cropped-header-300x69.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:69;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:26:\"cropped-header-222x160.jpg\";s:5:\"width\";i:222;s:6:\"height\";i:160;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"slider-large\";a:4:{s:4:\"file\";s:26:\"cropped-header-990x233.jpg\";s:5:\"width\";i:990;s:6:\"height\";i:233;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:17:\"slider-responsile\";a:4:{s:4:\"file\";s:26:\"cropped-header-925x233.jpg\";s:5:\"width\";i:925;s:6:\"height\";i:233;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"slider-middle\";a:4:{s:4:\"file\";s:26:\"cropped-header-756x233.jpg\";s:5:\"width\";i:756;s:6:\"height\";i:233;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:16:\"slider-thumbnail\";a:4:{s:4:\"file\";s:24:\"cropped-header-80x50.jpg\";s:5:\"width\";i:80;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"post-thumbnails\";a:4:{s:4:\"file\";s:26:\"cropped-header-222x160.jpg\";s:5:\"width\";i:222;s:6:\"height\";i:160;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"single-post-thumbnail\";a:4:{s:4:\"file\";s:26:\"cropped-header-598x233.jpg\";s:5:\"width\";i:598;s:6:\"height\";i:233;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("35", "11", "_wp_attachment_is_custom_header", "custom-community");
INSERT INTO `wp_postmeta` VALUES("36", "2", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("37", "2", "_wp_trash_meta_time", "1378239889");
INSERT INTO `wp_postmeta` VALUES("38", "2", "_cc_page_slider_on", "0");
INSERT INTO `wp_postmeta` VALUES("39", "2", "_cc_page_slider_cat", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("40", "2", "_cc_page_template_on", "0");
INSERT INTO `wp_postmeta` VALUES("41", "2", "_cc_page_template_cat", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("42", "2", "_cc_page_slider_caption", "0");
INSERT INTO `wp_postmeta` VALUES("43", "2", "_cc_post_template_on", "0");
INSERT INTO `wp_postmeta` VALUES("44", "2", "_cc_post_template_avatar", "0");
INSERT INTO `wp_postmeta` VALUES("45", "2", "_cc_post_template_date", "0");
INSERT INTO `wp_postmeta` VALUES("46", "2", "_cc_post_template_tags", "0");
INSERT INTO `wp_postmeta` VALUES("47", "2", "_cc_post_template_comments_info", "0");
INSERT INTO `wp_postmeta` VALUES("50", "15", "_cc_page_slider_on", "0");
INSERT INTO `wp_postmeta` VALUES("51", "15", "_cc_page_slider_cat", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("52", "15", "_cc_page_template_on", "0");
INSERT INTO `wp_postmeta` VALUES("53", "15", "_cc_page_template_cat", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("54", "15", "_cc_page_slider_caption", "0");
INSERT INTO `wp_postmeta` VALUES("55", "15", "_cc_post_template_on", "0");
INSERT INTO `wp_postmeta` VALUES("56", "15", "_cc_post_template_avatar", "0");
INSERT INTO `wp_postmeta` VALUES("57", "15", "_cc_post_template_date", "0");
INSERT INTO `wp_postmeta` VALUES("58", "15", "_cc_post_template_tags", "0");
INSERT INTO `wp_postmeta` VALUES("59", "15", "_cc_post_template_comments_info", "0");
INSERT INTO `wp_postmeta` VALUES("60", "15", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("61", "15", "_edit_lock", "1378240240:1");
INSERT INTO `wp_postmeta` VALUES("62", "15", "_thumbnail_id", "7");
INSERT INTO `wp_postmeta` VALUES("66", "17", "_cc_page_slider_on", "0");
INSERT INTO `wp_postmeta` VALUES("65", "15", "_cc_post_template_type", "img-left-content-right");
INSERT INTO `wp_postmeta` VALUES("67", "17", "_cc_page_slider_cat", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("68", "17", "_cc_page_template_on", "0");
INSERT INTO `wp_postmeta` VALUES("69", "17", "_cc_page_template_cat", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("70", "17", "_cc_page_slider_caption", "0");
INSERT INTO `wp_postmeta` VALUES("71", "17", "_cc_post_template_on", "0");
INSERT INTO `wp_postmeta` VALUES("72", "17", "_cc_post_template_avatar", "0");
INSERT INTO `wp_postmeta` VALUES("73", "17", "_cc_post_template_date", "0");
INSERT INTO `wp_postmeta` VALUES("74", "17", "_cc_post_template_tags", "0");
INSERT INTO `wp_postmeta` VALUES("75", "17", "_cc_post_template_comments_info", "0");
INSERT INTO `wp_postmeta` VALUES("76", "17", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("81", "19", "_wp_attached_file", "2013/09/file0001099434966.jpg");
INSERT INTO `wp_postmeta` VALUES("79", "17", "_cc_post_template_type", "img-left-content-right");
INSERT INTO `wp_postmeta` VALUES("80", "17", "_edit_lock", "1378240633:1");
INSERT INTO `wp_postmeta` VALUES("82", "19", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:223;s:6:\"height\";i:300;s:4:\"file\";s:29:\"2013/09/file0001099434966.jpg\";s:5:\"sizes\";a:8:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:29:\"file0001099434966-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:29:\"file0001099434966-222x160.jpg\";s:5:\"width\";i:222;s:6:\"height\";i:160;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:16:\"slider-top-large\";a:4:{s:4:\"file\";s:29:\"file0001099434966-223x250.jpg\";s:5:\"width\";i:223;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"slider-large\";a:4:{s:4:\"file\";s:29:\"file0001099434966-223x250.jpg\";s:5:\"width\";i:223;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:17:\"slider-responsile\";a:4:{s:4:\"file\";s:29:\"file0001099434966-223x250.jpg\";s:5:\"width\";i:223;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"slider-middle\";a:4:{s:4:\"file\";s:29:\"file0001099434966-223x250.jpg\";s:5:\"width\";i:223;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:16:\"slider-thumbnail\";a:4:{s:4:\"file\";s:27:\"file0001099434966-80x50.jpg\";s:5:\"width\";i:80;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"post-thumbnails\";a:4:{s:4:\"file\";s:29:\"file0001099434966-222x160.jpg\";s:5:\"width\";i:222;s:6:\"height\";i:160;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";d:3.20000000000000017763568394002504646778106689453125;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:32:\"KODAK DX6490 ZOOM DIGITAL CAMERA\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:1086971003;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:4:\"13.7\";s:3:\"iso\";i:0;s:13:\"shutter_speed\";s:15:\"0.0111111111111\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("83", "20", "_wp_attached_file", "2013/09/file441243117220.jpg");
INSERT INTO `wp_postmeta` VALUES("84", "20", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:300;s:6:\"height\";i:225;s:4:\"file\";s:28:\"2013/09/file441243117220.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:28:\"file441243117220-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:28:\"file441243117220-222x160.jpg\";s:5:\"width\";i:222;s:6:\"height\";i:160;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:16:\"slider-thumbnail\";a:4:{s:4:\"file\";s:26:\"file441243117220-80x50.jpg\";s:5:\"width\";i:80;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"post-thumbnails\";a:4:{s:4:\"file\";s:28:\"file441243117220-222x160.jpg\";s:5:\"width\";i:222;s:6:\"height\";i:160;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";d:3.100000000000000088817841970012523233890533447265625;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:6:\"EX-Z80\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:1243003715;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:3:\"6.3\";s:3:\"iso\";s:3:\"400\";s:13:\"shutter_speed\";s:15:\"0.0166666666667\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("85", "17", "_thumbnail_id", "20");
INSERT INTO `wp_postmeta` VALUES("88", "21", "_cc_page_slider_on", "0");
INSERT INTO `wp_postmeta` VALUES("89", "21", "_cc_page_slider_cat", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("90", "21", "_cc_page_template_on", "0");
INSERT INTO `wp_postmeta` VALUES("91", "21", "_cc_page_template_cat", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("92", "21", "_cc_page_slider_caption", "0");
INSERT INTO `wp_postmeta` VALUES("93", "21", "_cc_post_template_on", "0");
INSERT INTO `wp_postmeta` VALUES("94", "21", "_cc_post_template_avatar", "0");
INSERT INTO `wp_postmeta` VALUES("95", "21", "_cc_post_template_date", "0");
INSERT INTO `wp_postmeta` VALUES("96", "21", "_cc_post_template_tags", "0");
INSERT INTO `wp_postmeta` VALUES("97", "21", "_cc_post_template_comments_info", "0");
INSERT INTO `wp_postmeta` VALUES("98", "21", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("99", "21", "_edit_lock", "1378240862:1");
INSERT INTO `wp_postmeta` VALUES("100", "21", "_thumbnail_id", "19");
INSERT INTO `wp_postmeta` VALUES("104", "23", "_cc_page_slider_on", "0");
INSERT INTO `wp_postmeta` VALUES("103", "21", "_cc_post_template_type", "img-left-content-right");
INSERT INTO `wp_postmeta` VALUES("105", "23", "_cc_page_slider_cat", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("106", "23", "_cc_page_template_on", "0");
INSERT INTO `wp_postmeta` VALUES("107", "23", "_cc_page_template_cat", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("108", "23", "_cc_page_slider_caption", "0");
INSERT INTO `wp_postmeta` VALUES("109", "23", "_cc_post_template_on", "0");
INSERT INTO `wp_postmeta` VALUES("110", "23", "_cc_post_template_avatar", "0");
INSERT INTO `wp_postmeta` VALUES("111", "23", "_cc_post_template_date", "0");
INSERT INTO `wp_postmeta` VALUES("112", "23", "_cc_post_template_tags", "0");
INSERT INTO `wp_postmeta` VALUES("113", "23", "_cc_post_template_comments_info", "0");
INSERT INTO `wp_postmeta` VALUES("114", "23", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("115", "23", "_edit_lock", "1378449263:1");
INSERT INTO `wp_postmeta` VALUES("119", "25", "_cc_page_slider_on", "0");
INSERT INTO `wp_postmeta` VALUES("118", "23", "_cc_post_template_type", "img-left-content-right");
INSERT INTO `wp_postmeta` VALUES("120", "25", "_cc_page_slider_cat", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("121", "25", "_cc_page_template_on", "0");
INSERT INTO `wp_postmeta` VALUES("122", "25", "_cc_page_template_cat", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("123", "25", "_cc_page_slider_caption", "0");
INSERT INTO `wp_postmeta` VALUES("124", "25", "_cc_post_template_on", "0");
INSERT INTO `wp_postmeta` VALUES("125", "25", "_cc_post_template_avatar", "0");
INSERT INTO `wp_postmeta` VALUES("126", "25", "_cc_post_template_date", "0");
INSERT INTO `wp_postmeta` VALUES("127", "25", "_cc_post_template_tags", "0");
INSERT INTO `wp_postmeta` VALUES("128", "25", "_cc_post_template_comments_info", "0");
INSERT INTO `wp_postmeta` VALUES("129", "25", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("130", "25", "_edit_lock", "1378449298:1");
INSERT INTO `wp_postmeta` VALUES("134", "27", "_wp_attached_file", "2013/09/1325760170hmq8xV.jpg");
INSERT INTO `wp_postmeta` VALUES("133", "25", "_cc_post_template_type", "img-left-content-right");
INSERT INTO `wp_postmeta` VALUES("135", "27", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:98;s:6:\"height\";i:130;s:4:\"file\";s:28:\"2013/09/1325760170hmq8xV.jpg\";s:5:\"sizes\";a:1:{s:16:\"slider-thumbnail\";a:4:{s:4:\"file\";s:26:\"1325760170hmq8xV-80x50.jpg\";s:5:\"width\";i:80;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("136", "28", "_wp_attached_file", "2013/09/1162757236E4u58z.jpg");
INSERT INTO `wp_postmeta` VALUES("137", "28", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:120;s:6:\"height\";i:90;s:4:\"file\";s:28:\"2013/09/1162757236E4u58z.jpg\";s:5:\"sizes\";a:1:{s:16:\"slider-thumbnail\";a:4:{s:4:\"file\";s:26:\"1162757236E4u58z-80x50.jpg\";s:5:\"width\";i:80;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:31:\"(c) Marktilley | Dreamstime.com\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:39:\"http://www.dreamstime.com/-image1470177\";}}");
INSERT INTO `wp_postmeta` VALUES("138", "23", "_thumbnail_id", "28");
INSERT INTO `wp_postmeta` VALUES("141", "25", "_thumbnail_id", "27");
INSERT INTO `wp_postmeta` VALUES("144", "29", "_wp_attached_file", "2013/09/NMBC180x260.jpg");
INSERT INTO `wp_postmeta` VALUES("145", "29", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:180;s:6:\"height\";i:257;s:4:\"file\";s:23:\"2013/09/NMBC180x260.jpg\";s:5:\"sizes\";a:8:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"NMBC180x260-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"NMBC180x260-180x160.jpg\";s:5:\"width\";i:180;s:6:\"height\";i:160;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:16:\"slider-top-large\";a:4:{s:4:\"file\";s:23:\"NMBC180x260-180x250.jpg\";s:5:\"width\";i:180;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"slider-large\";a:4:{s:4:\"file\";s:23:\"NMBC180x260-180x250.jpg\";s:5:\"width\";i:180;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:17:\"slider-responsile\";a:4:{s:4:\"file\";s:23:\"NMBC180x260-180x250.jpg\";s:5:\"width\";i:180;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"slider-middle\";a:4:{s:4:\"file\";s:23:\"NMBC180x260-180x250.jpg\";s:5:\"width\";i:180;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:16:\"slider-thumbnail\";a:4:{s:4:\"file\";s:21:\"NMBC180x260-80x50.jpg\";s:5:\"width\";i:80;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"post-thumbnails\";a:4:{s:4:\"file\";s:23:\"NMBC180x260-180x160.jpg\";s:5:\"width\";i:180;s:6:\"height\";i:160;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("146", "30", "_cc_page_slider_on", "0");
INSERT INTO `wp_postmeta` VALUES("147", "30", "_cc_page_slider_cat", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("148", "30", "_cc_page_template_on", "0");
INSERT INTO `wp_postmeta` VALUES("149", "30", "_cc_page_template_cat", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("150", "30", "_cc_page_slider_caption", "0");
INSERT INTO `wp_postmeta` VALUES("151", "30", "_cc_post_template_on", "0");
INSERT INTO `wp_postmeta` VALUES("152", "30", "_cc_post_template_avatar", "0");
INSERT INTO `wp_postmeta` VALUES("153", "30", "_cc_post_template_date", "0");
INSERT INTO `wp_postmeta` VALUES("154", "30", "_cc_post_template_tags", "0");
INSERT INTO `wp_postmeta` VALUES("155", "30", "_cc_post_template_comments_info", "0");
INSERT INTO `wp_postmeta` VALUES("156", "30", "_menu_item_type", "taxonomy");
INSERT INTO `wp_postmeta` VALUES("157", "30", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("158", "30", "_menu_item_object_id", "4");
INSERT INTO `wp_postmeta` VALUES("159", "30", "_menu_item_object", "category");
INSERT INTO `wp_postmeta` VALUES("160", "30", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("161", "30", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("162", "30", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("163", "30", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("165", "31", "_cc_page_slider_on", "0");
INSERT INTO `wp_postmeta` VALUES("166", "31", "_cc_page_slider_cat", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("167", "31", "_cc_page_template_on", "0");
INSERT INTO `wp_postmeta` VALUES("168", "31", "_cc_page_template_cat", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("169", "31", "_cc_page_slider_caption", "0");
INSERT INTO `wp_postmeta` VALUES("170", "31", "_cc_post_template_on", "0");
INSERT INTO `wp_postmeta` VALUES("171", "31", "_cc_post_template_avatar", "0");
INSERT INTO `wp_postmeta` VALUES("172", "31", "_cc_post_template_date", "0");
INSERT INTO `wp_postmeta` VALUES("173", "31", "_cc_post_template_tags", "0");
INSERT INTO `wp_postmeta` VALUES("174", "31", "_cc_post_template_comments_info", "0");
INSERT INTO `wp_postmeta` VALUES("175", "31", "_menu_item_type", "taxonomy");
INSERT INTO `wp_postmeta` VALUES("176", "31", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("177", "31", "_menu_item_object_id", "3");
INSERT INTO `wp_postmeta` VALUES("178", "31", "_menu_item_object", "category");
INSERT INTO `wp_postmeta` VALUES("179", "31", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("180", "31", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("181", "31", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("182", "31", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("184", "32", "_cc_page_slider_on", "0");
INSERT INTO `wp_postmeta` VALUES("185", "32", "_cc_page_slider_cat", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("186", "32", "_cc_page_template_on", "0");
INSERT INTO `wp_postmeta` VALUES("187", "32", "_cc_page_template_cat", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("188", "32", "_cc_page_slider_caption", "0");
INSERT INTO `wp_postmeta` VALUES("189", "32", "_cc_post_template_on", "0");
INSERT INTO `wp_postmeta` VALUES("190", "32", "_cc_post_template_avatar", "0");
INSERT INTO `wp_postmeta` VALUES("191", "32", "_cc_post_template_date", "0");
INSERT INTO `wp_postmeta` VALUES("192", "32", "_cc_post_template_tags", "0");
INSERT INTO `wp_postmeta` VALUES("193", "32", "_cc_post_template_comments_info", "0");
INSERT INTO `wp_postmeta` VALUES("194", "32", "_menu_item_type", "taxonomy");
INSERT INTO `wp_postmeta` VALUES("195", "32", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("196", "32", "_menu_item_object_id", "5");
INSERT INTO `wp_postmeta` VALUES("197", "32", "_menu_item_object", "category");
INSERT INTO `wp_postmeta` VALUES("198", "32", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("199", "32", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("200", "32", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("201", "32", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("203", "33", "_cc_page_slider_on", "0");
INSERT INTO `wp_postmeta` VALUES("204", "33", "_cc_page_slider_cat", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("205", "33", "_cc_page_template_on", "0");
INSERT INTO `wp_postmeta` VALUES("206", "33", "_cc_page_template_cat", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("207", "33", "_cc_page_slider_caption", "0");
INSERT INTO `wp_postmeta` VALUES("208", "33", "_cc_post_template_on", "0");
INSERT INTO `wp_postmeta` VALUES("209", "33", "_cc_post_template_avatar", "0");
INSERT INTO `wp_postmeta` VALUES("210", "33", "_cc_post_template_date", "0");
INSERT INTO `wp_postmeta` VALUES("211", "33", "_cc_post_template_tags", "0");
INSERT INTO `wp_postmeta` VALUES("212", "33", "_cc_post_template_comments_info", "0");
INSERT INTO `wp_postmeta` VALUES("213", "33", "_menu_item_type", "taxonomy");
INSERT INTO `wp_postmeta` VALUES("214", "33", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("215", "33", "_menu_item_object_id", "1");
INSERT INTO `wp_postmeta` VALUES("216", "33", "_menu_item_object", "category");
INSERT INTO `wp_postmeta` VALUES("217", "33", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("218", "33", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("219", "33", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("220", "33", "_menu_item_url", "");

/* INSERT TABLE DATA: wp_posts */
INSERT INTO `wp_posts` VALUES("1", "1", "2013-09-02 12:53:12", "2013-09-02 12:53:12", "<strong>Cat Training Tips - Make Your Furry Friend Obey You </strong>\r\n\r\nA cat can be trained! Never heard of it, right? Although cats possess independent and careless behaviours but believe it or not, your love can change them as obedient creatures like dogs. However, you have to work hard for their true love. Patience is the key when it comes to train a cat. Consider these cat training tips to make your furry friend obsequious.\r\nA cat owner who is familiar with various cat behaviours, can train a cat much better than owners who don\'t know much about them. All cats are different; meaning some can learn faster than others. Give them enough time to learn. You will make a big mistake by getting frustrated at them while a training session. Scolding your cat lead to cat\'s behavioural problems.\r\n\r\nA cat will respond to you if you appreciate their work, and they tend to ignore any punishment. So, be friendly with them always, if you want any positive response. Meticulous studies show that cats always disregard chastisement. Wasting time on scolding will not fetch any result for sure. Cats love being on proper schedules. Make a strict schedule for them. Groom, feed and always play with cats on a fix time daily. This will help them become submissive.\r\n\r\nAfter a hectic day at work, you don\'t want to spruce up your house again. If you don\'t want that your jewellery sets, pens, socks, papers and other small items go missing, make sure you keep kitty toys at home. They can play with their personal belongings to kill time without disturbing your valuable items. Most cats can ruin your furniture by scratching them. You can foil your furniture to avoid any scratch marks.\r\nCats are not known as good tricks performers. However, they can easily be trained to do some tricks, if you follow above mentioned cat training tips. It takes patience and time to teach a cat become an obsequious. Be friendly and know what your little furry friend wants. All in all they are animal, learning to deal with humans!", "Cat Training Tips", "", "publish", "open", "open", "", "hello-world", "", "", "2013-09-03 20:28:18", "2013-09-03 20:28:18", "", "0", "http://blogsforsales.com/cat/?p=1", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("2", "1", "2013-09-02 12:53:12", "2013-09-02 12:53:12", "This is an example page. It\'s different from a blog post because it will stay in one place and will show up in your site navigation (in most themes). Most people start with an About page that introduces them to potential site visitors. It might say something like this:\n\n<blockquote>Hi there! I\'m a bike messenger by day, aspiring actor by night, and this is my blog. I live in Los Angeles, have a great dog named Jack, and I like pi&#241;a coladas. (And gettin\' caught in the rain.)</blockquote>\n\n...or something like this:\n\n<blockquote>The XYZ Doohickey Company was founded in 1971, and has been providing quality doohickies to the public ever since. Located in Gotham City, XYZ employs over 2,000 people and does all kinds of awesome things for the Gotham community.</blockquote>\n\nAs a new WordPress user, you should go to <a href=\"http://blogsforsales.com/cat/wp-admin/\">your dashboard</a> to delete this page and create new pages for your content. Have fun!", "Sample Page", "", "trash", "open", "open", "", "sample-page", "", "", "2013-09-03 20:24:49", "2013-09-03 20:24:49", "", "0", "http://blogsforsales.com/cat/?page_id=2", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("3", "1", "2013-09-02 12:53:12", "0000-00-00 00:00:00", "", "Auto Draft", "", "auto-draft", "open", "open", "", "", "", "", "2013-09-02 12:53:12", "0000-00-00 00:00:00", "", "0", "http://blogsforsales.com/cat/?p=3", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("6", "1", "2013-09-02 18:27:26", "2013-09-02 18:27:26", "", "file000707145868.jpg", "", "inherit", "open", "open", "", "file000707145868-jpg", "", "", "2013-09-02 18:27:26", "2013-09-02 18:27:26", "", "23", "", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("7", "1", "2013-09-02 18:27:53", "2013-09-02 18:27:53", "", "file000536952144.jpg", "", "inherit", "open", "open", "", "file000536952144-jpg", "", "", "2013-09-02 18:27:53", "2013-09-02 18:27:53", "", "0", "", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("8", "1", "2013-09-02 18:28:06", "2013-09-02 18:28:06", "", "file0001580390516.jpg", "", "inherit", "open", "open", "", "file0001580390516-jpg", "", "", "2013-09-02 18:28:06", "2013-09-02 18:28:06", "", "0", "", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("9", "1", "2013-09-02 18:30:13", "2013-09-02 18:30:13", "Welcome to WordPress. This is your first post. Edit or delete it, then start blogging!", "Hello world!", "", "inherit", "open", "open", "", "1-revision-v1", "", "", "2013-09-02 18:30:13", "2013-09-02 18:30:13", "", "1", "http://blogsforsales.com/cat/?p=9", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("10", "1", "2013-09-02 18:34:56", "2013-09-02 18:34:56", "http://blogsforsales.com/cat/wp-content/uploads/2013/09/head.jpg", "head.jpg", "", "inherit", "open", "open", "", "head-jpg", "", "", "2013-09-02 18:34:56", "2013-09-02 18:34:56", "", "0", "http://blogsforsales.com/cat/wp-content/uploads/2013/09/head.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("11", "1", "2013-09-02 18:36:35", "2013-09-02 18:36:35", "http://blogsforsales.com/cat/wp-content/uploads/2013/09/cropped-header.jpg", "cropped-header.jpg", "", "inherit", "closed", "open", "", "cropped-header-jpg", "", "", "2013-09-02 18:36:35", "2013-09-02 18:36:35", "", "0", "http://blogsforsales.com/cat/wp-content/uploads/2013/09/cropped-header.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("12", "1", "2013-09-03 20:24:49", "2013-09-03 20:24:49", "This is an example page. It\'s different from a blog post because it will stay in one place and will show up in your site navigation (in most themes). Most people start with an About page that introduces them to potential site visitors. It might say something like this:\n\n<blockquote>Hi there! I\'m a bike messenger by day, aspiring actor by night, and this is my blog. I live in Los Angeles, have a great dog named Jack, and I like pi&#241;a coladas. (And gettin\' caught in the rain.)</blockquote>\n\n...or something like this:\n\n<blockquote>The XYZ Doohickey Company was founded in 1971, and has been providing quality doohickies to the public ever since. Located in Gotham City, XYZ employs over 2,000 people and does all kinds of awesome things for the Gotham community.</blockquote>\n\nAs a new WordPress user, you should go to <a href=\"http://blogsforsales.com/cat/wp-admin/\">your dashboard</a> to delete this page and create new pages for your content. Have fun!", "Sample Page", "", "inherit", "open", "open", "", "2-revision-v1", "", "", "2013-09-03 20:24:49", "2013-09-03 20:24:49", "", "2", "http://blogsforsales.com/cat/?p=12", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("13", "1", "2013-09-03 20:27:30", "2013-09-03 20:27:30", "Cat Training Tips - Make Your Furry Friend Obey You\n\nA cat can be trained! Never heard of it, right? Although cats possess independent and careless behaviours but believe it or not, your love can change them as obedient creatures like dogs. However, you have to work hard for their true love. Patience is the key when it comes to train a cat. Consider these cat training tips to make your furry friend obsequious.\nA cat owner who is familiar with various cat behaviours, can train a cat much better than owners who don\'t know much about them. All cats are different; meaning some can learn faster than others. Give them enough time to learn. You will make a big mistake by getting frustrated at them while a training session. Scolding your cat lead to cat\'s behavioural problems.\nA cat will respond to you if you appreciate their work, and they tend to ignore any punishment. So, be friendly with them always, if you want any positive response. Meticulous studies show that cats always disregard chastisement. Wasting time on scolding will not fetch any result for sure. Cats love being on proper schedules. Make a strict schedule for them. Groom, feed and always play with cats on a fix time daily. This will help them become submissive.\nAfter a hectic day at work, you don\'t want to spruce up your house again. If you don\'t want that your jewellery sets, pens, socks, papers and other small items go missing, make sure you keep kitty toys at home. They can play with their personal belongings to kill time without disturbing your valuable items. Most cats can ruin your furniture by scratching them. You can foil your furniture to avoid any scratch marks.\nCats are not known as good tricks performers. However, they can easily be trained to do some tricks, if you follow above mentioned cat training tips. It takes patience and time to teach a cat become an obsequious. Be friendly and know what your little furry friend wants. All in all they are animal, learning to deal with humans!", "Hello world!", "", "inherit", "open", "open", "", "1-autosave-v1", "", "", "2013-09-03 20:27:30", "2013-09-03 20:27:30", "", "1", "http://blogsforsales.com/cat/?p=13", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("14", "1", "2013-09-03 20:28:18", "2013-09-03 20:28:18", "<strong>Cat Training Tips - Make Your Furry Friend Obey You </strong>\r\n\r\nA cat can be trained! Never heard of it, right? Although cats possess independent and careless behaviours but believe it or not, your love can change them as obedient creatures like dogs. However, you have to work hard for their true love. Patience is the key when it comes to train a cat. Consider these cat training tips to make your furry friend obsequious.\r\nA cat owner who is familiar with various cat behaviours, can train a cat much better than owners who don\'t know much about them. All cats are different; meaning some can learn faster than others. Give them enough time to learn. You will make a big mistake by getting frustrated at them while a training session. Scolding your cat lead to cat\'s behavioural problems.\r\n\r\nA cat will respond to you if you appreciate their work, and they tend to ignore any punishment. So, be friendly with them always, if you want any positive response. Meticulous studies show that cats always disregard chastisement. Wasting time on scolding will not fetch any result for sure. Cats love being on proper schedules. Make a strict schedule for them. Groom, feed and always play with cats on a fix time daily. This will help them become submissive.\r\n\r\nAfter a hectic day at work, you don\'t want to spruce up your house again. If you don\'t want that your jewellery sets, pens, socks, papers and other small items go missing, make sure you keep kitty toys at home. They can play with their personal belongings to kill time without disturbing your valuable items. Most cats can ruin your furniture by scratching them. You can foil your furniture to avoid any scratch marks.\r\nCats are not known as good tricks performers. However, they can easily be trained to do some tricks, if you follow above mentioned cat training tips. It takes patience and time to teach a cat become an obsequious. Be friendly and know what your little furry friend wants. All in all they are animal, learning to deal with humans!", "Cat Training Tips", "", "inherit", "open", "open", "", "1-revision-v1", "", "", "2013-09-03 20:28:18", "2013-09-03 20:28:18", "", "1", "http://blogsforsales.com/cat/?p=14", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("15", "1", "2013-09-03 20:30:39", "2013-09-03 20:30:39", "<strong>Caring for your cat</strong>\r\n\r\nTo own a cat is fun. A cat is among the most popular pets that are adopted by families. The care for cats creates a good relationship between you and your pet. It also counts a lot on the healthy and lifespan of your cat.\r\n\r\nCats need a special care but one must first understand their behaviour. A part from the type and breed of cats, they generally retain the biological wildcat behaviour. Therefore, this brings the basis of the general idea on what breed of your lovely pet you are going to choose. Having chosen one, it will be your duty to take fully responsibility. Below are tips and guidelines that will greatly assist you in taking maximum care.\r\n\r\nSafety\r\n\r\nKeeping your cat indoors guarantees him with a maximum safety. When traveling, use a good cat carrier for protection. The carrier must be dry and closed always since cats tend to climb up the appliances when open. Always take a visit to your trusted competent physician for vaccinations and advice on medical and nutritional needs.\r\n\r\nFeeding tips\r\n\r\nHealthy feeding for your pet is very essential. Always remember to place food in the bowl of your cat at the right time and quantity. The type of the food maybe homemade or store-bought food. However, the most trusted foods are those scientifically and medically designed and produced by manufacturers.\r\n\r\nGrooming your cat\r\n\r\nAlthough a cat is considered a clean animal, regular grooming makes cats very clean and fresh. Grooming techniques differ depending on the longevity of the hair of your cat.\r\n\r\nExercise\r\n\r\nSome cats sit around if left alone. Helping your cat get exercise is vital. Getting a post where your cat can climb creates a good condition for them to exercise themselves effectively. A scratching post is of equally importance.\r\n\r\nFinally, children usually confuse pets for playing toys hence it necessary to teach your kid to respect and handle your pet with care.", "Caring for your cat", "", "publish", "open", "open", "", "caring-for-your-cat", "", "", "2013-09-03 20:30:39", "2013-09-03 20:30:39", "", "0", "http://blogsforsales.com/cat/?p=15", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("16", "1", "2013-09-03 20:30:39", "2013-09-03 20:30:39", "<strong>Caring for your cat</strong>\r\n\r\nTo own a cat is fun. A cat is among the most popular pets that are adopted by families. The care for cats creates a good relationship between you and your pet. It also counts a lot on the healthy and lifespan of your cat.\r\n\r\nCats need a special care but one must first understand their behaviour. A part from the type and breed of cats, they generally retain the biological wildcat behaviour. Therefore, this brings the basis of the general idea on what breed of your lovely pet you are going to choose. Having chosen one, it will be your duty to take fully responsibility. Below are tips and guidelines that will greatly assist you in taking maximum care.\r\n\r\nSafety\r\n\r\nKeeping your cat indoors guarantees him with a maximum safety. When traveling, use a good cat carrier for protection. The carrier must be dry and closed always since cats tend to climb up the appliances when open. Always take a visit to your trusted competent physician for vaccinations and advice on medical and nutritional needs.\r\n\r\nFeeding tips\r\n\r\nHealthy feeding for your pet is very essential. Always remember to place food in the bowl of your cat at the right time and quantity. The type of the food maybe homemade or store-bought food. However, the most trusted foods are those scientifically and medically designed and produced by manufacturers.\r\n\r\nGrooming your cat\r\n\r\nAlthough a cat is considered a clean animal, regular grooming makes cats very clean and fresh. Grooming techniques differ depending on the longevity of the hair of your cat.\r\n\r\nExercise\r\n\r\nSome cats sit around if left alone. Helping your cat get exercise is vital. Getting a post where your cat can climb creates a good condition for them to exercise themselves effectively. A scratching post is of equally importance.\r\n\r\nFinally, children usually confuse pets for playing toys hence it necessary to teach your kid to respect and handle your pet with care.", "Caring for your cat", "", "inherit", "open", "open", "", "15-revision-v1", "", "", "2013-09-03 20:30:39", "2013-09-03 20:30:39", "", "15", "http://blogsforsales.com/cat/?p=16", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("17", "1", "2013-09-03 20:35:29", "2013-09-03 20:35:29", "<strong>Yikes! How Do I Bathe My Cat?</strong>\r\n\r\nYou all know how much a cat hates to get wet, but many a times when they get exceptionally dirty it’s time to give them a bath. This can be a painful process for you and your cat. To help you out, here are some tips to make this task less challenging and make your cat fresh and lovely again.\r\n\r\nPrepare Yourself\r\n<ol>\r\n	<li>The first thing before taking such a challenging task is to ask yourself if your cat actually needs a bath. There are other ways of cleaning your cat such as brushing, combing or rubbing with a cloth.</li>\r\n	<li>The first precaution you should take is to wear appropriate clothing to save yourself from possible scratches. Prefer a long-sleeved shirt or a jumper so that your cat cannot scratch your bare skin.</li>\r\n	<li>It is always convenient to involve one more person while washing your cat especially when your cat is strong enough to kick you and get out of your grip. Ask another person to hold the legs and jaw of the cat firmly.</li>\r\n</ol>\r\nPrepare the Bath\r\n<ol>\r\n	<li>Always fill the tub with water before bringing your cat to the bathroom and make the water adequately warm.</li>\r\n	<li>Do not use running water while washing your cat as many cats fear the running water and this will worsen the situation.</li>\r\n	<li>Use a rubber mat in the tub to provide a comfortable footing to your cat.</li>\r\n</ol>\r\nBathing\r\n<ol>\r\n	<li>Talk to your cat in a calm and slow voice while bathing and make a firm grip on the neck or shoulders.</li>\r\n	<li>Mix a small amount of shampoo with water to wash your cat’s body. And do not let the shampoo reach cat’s eyes, mouth or ears.</li>\r\n	<li>Rinse the cat thoroughly a couple of times in the tub to remove the shampoo and soap from your cat’s body.</li>\r\n</ol>\r\nThis will ensure that your lovely pet is cleaned and groomed again and make the process less stressful.", "How Do I Bathe My Cat", "", "publish", "open", "open", "", "how-do-i-bathe-my-cat", "", "", "2013-09-03 20:37:12", "2013-09-03 20:37:12", "", "0", "http://blogsforsales.com/cat/?p=17", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("18", "1", "2013-09-03 20:35:29", "2013-09-03 20:35:29", "<strong>Yikes! How Do I Bathe My Cat?</strong>\r\n\r\nYou all know how much a cat hates to get wet, but many a times when they get exceptionally dirty it’s time to give them a bath. This can be a painful process for you and your cat. To help you out, here are some tips to make this task less challenging and make your cat fresh and lovely again.\r\n\r\nPrepare Yourself\r\n<ol>\r\n	<li>The first thing before taking such a challenging task is to ask yourself if your cat actually needs a bath. There are other ways of cleaning your cat such as brushing, combing or rubbing with a cloth.</li>\r\n	<li>The first precaution you should take is to wear appropriate clothing to save yourself from possible scratches. Prefer a long-sleeved shirt or a jumper so that your cat cannot scratch your bare skin.</li>\r\n	<li>It is always convenient to involve one more person while washing your cat especially when your cat is strong enough to kick you and get out of your grip. Ask another person to hold the legs and jaw of the cat firmly.</li>\r\n</ol>\r\nPrepare the Bath\r\n<ol>\r\n	<li>Always fill the tub with water before bringing your cat to the bathroom and make the water adequately warm.</li>\r\n	<li>Do not use running water while washing your cat as many cats fear the running water and this will worsen the situation.</li>\r\n	<li>Use a rubber mat in the tub to provide a comfortable footing to your cat.</li>\r\n</ol>\r\nBathing\r\n<ol>\r\n	<li>Talk to your cat in a calm and slow voice while bathing and make a firm grip on the neck or shoulders.</li>\r\n	<li>Mix a small amount of shampoo with water to wash your cat’s body. And do not let the shampoo reach cat’s eyes, mouth or ears.</li>\r\n	<li>Rinse the cat thoroughly a couple of times in the tub to remove the shampoo and soap from your cat’s body.</li>\r\n</ol>\r\nThis will ensure that your lovely pet is cleaned and groomed again and make the process less stressful.", "How Do I Bathe My Cat", "", "inherit", "open", "open", "", "17-revision-v1", "", "", "2013-09-03 20:35:29", "2013-09-03 20:35:29", "", "17", "http://blogsforsales.com/cat/?p=18", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("19", "1", "2013-09-03 20:36:15", "2013-09-03 20:36:15", "", "file0001099434966.jpg", "", "inherit", "open", "open", "", "file0001099434966-jpg", "", "", "2013-09-03 20:36:15", "2013-09-03 20:36:15", "", "0", "", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("20", "1", "2013-09-03 20:36:41", "2013-09-03 20:36:41", "", "file441243117220.jpg", "", "inherit", "open", "open", "", "file441243117220-jpg", "", "", "2013-09-03 20:36:41", "2013-09-03 20:36:41", "", "0", "", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("21", "1", "2013-09-03 20:41:01", "2013-09-03 20:41:01", "Some Helpful Tips For Correcting Problem Cat Behaviour\r\n\r\nAnimals are considered as a best friend of humans. Animals like dog, cat, and horse have set many examples denoting animal’s love for their master as well as human’s love towards their pet. Mostly people prefer to adopt a dog as a pet as we all know that he is considered as a loyal and faithful animal, but you can also find a great number of people adopting cats as their pet. Cats are considered equally fabulous and amazing in comparison to dog. People belong to any age group whether a kid or an adult person love having a cute small kitten or cat as a pet. They look very cute and lovable. This pet is very cute and lovable but sometimes cat behaviours can cause problems for you. In that case you must wonder for a solution or way for correcting problem cat behaviour.\r\n\r\nIn case you are just adopted a cat as a pet and you are facing behaviour problem with it than you are required to wait for sometime so that your new friend become habituated with the surroundings and can become familiar with new people. In case you can see any change after many days you are required to train your cat according to your set up. In that case you can take help of a professional trainer.\r\n\r\nIn case your old and loved pet is behaving differently or badly you must keep an eye on it. It is a well know fact that a cat behaviours badly or differently when she is going through any kind of problem. You have to find out what wrong is going on with your lovely catty. Sometimes bad health conditions develop a feeling of irritation and anger in cats. So you must keep an eye on your cat and observe her all day activity it will help you in finding the exact reason behind her different behaviour.\r\n\r\nTimely diagnosis can help you in saving your cat from any big issue. It your responsibilities that you must take good care of your speechless friend.", "Tips For Correcting Problem Cat Behaviour", "", "publish", "open", "open", "", "tips-for-correcting-problem-cat-behaviour", "", "", "2013-09-03 20:41:01", "2013-09-03 20:41:01", "", "0", "http://blogsforsales.com/cat/?p=21", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("22", "1", "2013-09-03 20:41:01", "2013-09-03 20:41:01", "Some Helpful Tips For Correcting Problem Cat Behaviour\r\n\r\nAnimals are considered as a best friend of humans. Animals like dog, cat, and horse have set many examples denoting animal’s love for their master as well as human’s love towards their pet. Mostly people prefer to adopt a dog as a pet as we all know that he is considered as a loyal and faithful animal, but you can also find a great number of people adopting cats as their pet. Cats are considered equally fabulous and amazing in comparison to dog. People belong to any age group whether a kid or an adult person love having a cute small kitten or cat as a pet. They look very cute and lovable. This pet is very cute and lovable but sometimes cat behaviours can cause problems for you. In that case you must wonder for a solution or way for correcting problem cat behaviour.\r\n\r\nIn case you are just adopted a cat as a pet and you are facing behaviour problem with it than you are required to wait for sometime so that your new friend become habituated with the surroundings and can become familiar with new people. In case you can see any change after many days you are required to train your cat according to your set up. In that case you can take help of a professional trainer.\r\n\r\nIn case your old and loved pet is behaving differently or badly you must keep an eye on it. It is a well know fact that a cat behaviours badly or differently when she is going through any kind of problem. You have to find out what wrong is going on with your lovely catty. Sometimes bad health conditions develop a feeling of irritation and anger in cats. So you must keep an eye on your cat and observe her all day activity it will help you in finding the exact reason behind her different behaviour.\r\n\r\nTimely diagnosis can help you in saving your cat from any big issue. It your responsibilities that you must take good care of your speechless friend.", "Tips For Correcting Problem Cat Behaviour", "", "inherit", "open", "open", "", "21-revision-v1", "", "", "2013-09-03 20:41:01", "2013-09-03 20:41:01", "", "21", "http://blogsforsales.com/cat/?p=22", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("23", "1", "2013-09-06 06:30:31", "2013-09-06 06:30:31", "<strong>Litter Training and Your Cat</strong>\r\n\r\n<a href=\"http://blogsforsales.com/cat/wp-content/uploads/2013/09/file000707145868.jpg\"><img class=\"alignleft size-thumbnail wp-image-6\" alt=\"file000707145868.jpg\" src=\"http://blogsforsales.com/cat/wp-content/uploads/2013/09/file000707145868-150x150.jpg\" width=\"150\" height=\"150\" /></a>Cats are meticulous pets and ones that are extremely sensitive to hygiene. These pets carry out grooming routines on a daily basis and their preferred choice of relief point is the outdoors. They, however, can be trained to use the litter box in-house gradually until they get used to it.\r\n\r\nThe act of litter training and your cat being stubborn in the beginning might take its toll on the pet’s owner; but with patience and persistence the results are gratifying. As established in the beginning, cats are clean animals. It is therefore important to keep their litter boxes or trays clean; anything to the contrary appears repulsive to these pets.\r\n\r\nFor newly adopted pets, training comes first before allowing the cat to roam freely in the home. Motivate the cat with a reward every time he/she uses the litter box. If the cat is to ease himself/herself regularly, schedule all the feeding times. This way it is easier to predict the next time he/she will use the litter box.\r\nSometimes, even after all these precautions, cats tend to avoid the litter box. The reason for this might be that the litter in the box. Picky as they are, cats may refrain from the box because they do not like the litter in it. For such cases, one can try changing the litter and monitor the changes. If nothing changes, a vet can look for any underlying issues.\r\n\r\nA cat may develop urinary tract infection or other related complications that hinder him/her from utilizing the litter box as prescribed or interacting with people and other pets in an orderly fashion. The general mood in the home also dictates the cats’ behaviour. Normally functioning homes elevates cats’ behaviour while unstable violent homes turn cats into self conscious pets whose demeanour is unpredictable. Cats are good company as long as they desist from relieving themselves all over the house.", "Litter Training and Your Cat", "", "publish", "open", "open", "", "litter-training-and-your-cat", "", "", "2013-09-06 06:34:13", "2013-09-06 06:34:13", "", "0", "http://blogsforsales.com/cat/?p=23", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("24", "1", "2013-09-06 06:30:31", "2013-09-06 06:30:31", "<strong>Litter Training and Your Cat</strong>\r\n\r\n<a href=\"http://blogsforsales.com/cat/wp-content/uploads/2013/09/file000707145868.jpg\"><img class=\"alignleft size-thumbnail wp-image-6\" alt=\"file000707145868.jpg\" src=\"http://blogsforsales.com/cat/wp-content/uploads/2013/09/file000707145868-150x150.jpg\" width=\"150\" height=\"150\" /></a>Cats are meticulous pets and ones that are extremely sensitive to hygiene. These pets carry out grooming routines on a daily basis and their preferred choice of relief point is the outdoors. They, however, can be trained to use the litter box in-house gradually until they get used to it.\r\n\r\nThe act of litter training and your cat being stubborn in the beginning might take its toll on the pet’s owner; but with patience and persistence the results are gratifying. As established in the beginning, cats are clean animals. It is therefore important to keep their litter boxes or trays clean; anything to the contrary appears repulsive to these pets.\r\n\r\nFor newly adopted pets, training comes first before allowing the cat to roam freely in the home. Motivate the cat with a reward every time he/she uses the litter box. If the cat is to ease himself/herself regularly, schedule all the feeding times. This way it is easier to predict the next time he/she will use the litter box.\r\nSometimes, even after all these precautions, cats tend to avoid the litter box. The reason for this might be that the litter in the box. Picky as they are, cats may refrain from the box because they do not like the litter in it. For such cases, one can try changing the litter and monitor the changes. If nothing changes, a vet can look for any underlying issues.\r\n\r\nA cat may develop urinary tract infection or other related complications that hinder him/her from utilizing the litter box as prescribed or interacting with people and other pets in an orderly fashion. The general mood in the home also dictates the cats’ behaviour. Normally functioning homes elevates cats’ behaviour while unstable violent homes turn cats into self conscious pets whose demeanour is unpredictable. Cats are good company as long as they desist from relieving themselves all over the house.", "Litter Training and Your Cat", "", "inherit", "open", "open", "", "23-revision-v1", "", "", "2013-09-06 06:30:31", "2013-09-06 06:30:31", "", "23", "http://blogsforsales.com/cat/?p=24", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("25", "1", "2013-09-06 06:32:44", "2013-09-06 06:32:44", "<strong>Essential Facts about Cat Nutrition</strong>\r\n\r\nPet owners should realize that cat nutrition varies from one cat to another. Moreover, a cat\'s nutritional needs depend on its health, genetic disposition or breed, and age. For instance, long-haired breeds need more supply of fibre that can minimize health risks due to fur ball. There are also breeds of cats that are more susceptible to skin allergies, so they must be fed with foods containing higher amounts of essential fatty acids. Nevertheless, all felines need to receive proper nutrition from their regular diet, and there are also some foods that pet owners should avoid feeding their cats.\r\n\r\nGenerally, cats need a daily supply of taurine, which is an amino acid that supports feline health. When a cat suffers from taurine deficiency, it may be prone to blindness and dilated cardiomyopathy, among several other medical conditions. Since taurine is an essential component that these animals need and tend to use up quickly, most commercial cat food brands sold in the market contain this in their ingredients list. If you are not feeding your cat with commercial food, you may consider giving it meat, which is an excellent source of taurine. Thus, it will not do your cat any good if you adopt a vegetarian diet for your pet.\r\n\r\nIt is also important for owners to be aware of foods that they should never feed their cats. While meat is a great food item for felines, it is unsafe to feed them with raw meat or fish. According to health experts, raw fish is rich in enzymes that stimulate vitamin B1 absorption, which can lead to brain damage. In addition, raw fish may contain some parasites that can transmit infections or diseases to cats.\r\n\r\nBy being aware of safe and healthy foods for your cat, you can ensure its outstanding condition at all times. Aside from feeding your pet with nutritious foods, make it a point to visit the vet for further support on your pet\'s health and growth.", "Essential Facts about Cat Nutrition", "", "publish", "open", "open", "", "essential-facts-about-cat-nutrition", "", "", "2013-09-06 06:34:57", "2013-09-06 06:34:57", "", "0", "http://blogsforsales.com/cat/?p=25", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("26", "1", "2013-09-06 06:32:44", "2013-09-06 06:32:44", "<strong>Essential Facts about Cat Nutrition</strong>\r\n\r\nPet owners should realize that cat nutrition varies from one cat to another. Moreover, a cat\'s nutritional needs depend on its health, genetic disposition or breed, and age. For instance, long-haired breeds need more supply of fibre that can minimize health risks due to fur ball. There are also breeds of cats that are more susceptible to skin allergies, so they must be fed with foods containing higher amounts of essential fatty acids. Nevertheless, all felines need to receive proper nutrition from their regular diet, and there are also some foods that pet owners should avoid feeding their cats.\r\n\r\nGenerally, cats need a daily supply of taurine, which is an amino acid that supports feline health. When a cat suffers from taurine deficiency, it may be prone to blindness and dilated cardiomyopathy, among several other medical conditions. Since taurine is an essential component that these animals need and tend to use up quickly, most commercial cat food brands sold in the market contain this in their ingredients list. If you are not feeding your cat with commercial food, you may consider giving it meat, which is an excellent source of taurine. Thus, it will not do your cat any good if you adopt a vegetarian diet for your pet.\r\n\r\nIt is also important for owners to be aware of foods that they should never feed their cats. While meat is a great food item for felines, it is unsafe to feed them with raw meat or fish. According to health experts, raw fish is rich in enzymes that stimulate vitamin B1 absorption, which can lead to brain damage. In addition, raw fish may contain some parasites that can transmit infections or diseases to cats.\r\n\r\nBy being aware of safe and healthy foods for your cat, you can ensure its outstanding condition at all times. Aside from feeding your pet with nutritious foods, make it a point to visit the vet for further support on your pet\'s health and growth.", "Essential Facts about Cat Nutrition", "", "inherit", "open", "open", "", "25-revision-v1", "", "", "2013-09-06 06:32:44", "2013-09-06 06:32:44", "", "25", "http://blogsforsales.com/cat/?p=26", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("27", "1", "2013-09-06 06:33:13", "2013-09-06 06:33:13", "", "1325760170hmq8xV.jpg", "", "inherit", "open", "open", "", "1325760170hmq8xv-jpg", "", "", "2013-09-06 06:33:13", "2013-09-06 06:33:13", "", "0", "", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("28", "1", "2013-09-06 06:33:36", "2013-09-06 06:33:36", "", "1162757236E4u58z.jpg", "", "inherit", "open", "open", "", "1162757236e4u58z-jpg", "", "", "2013-09-06 06:33:36", "2013-09-06 06:33:36", "", "0", "", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("29", "1", "2013-09-06 06:51:34", "2013-09-06 06:51:34", "", "NMBC180x260", "", "inherit", "open", "open", "", "nmbc180x260", "", "", "2013-09-06 06:51:34", "2013-09-06 06:51:34", "", "0", "http://blogsforsales.com/cat/wp-content/uploads/2013/09/NMBC180x260.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("30", "1", "2013-09-06 06:54:17", "2013-09-06 06:54:17", " ", "", "", "publish", "open", "open", "", "30", "", "", "2013-09-06 06:54:17", "2013-09-06 06:54:17", "", "0", "http://blogsforsales.com/cat/?p=30", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("31", "1", "2013-09-06 06:54:17", "2013-09-06 06:54:17", " ", "", "", "publish", "open", "open", "", "31", "", "", "2013-09-06 06:54:17", "2013-09-06 06:54:17", "", "0", "http://blogsforsales.com/cat/?p=31", "2", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("32", "1", "2013-09-06 06:54:17", "2013-09-06 06:54:17", " ", "", "", "publish", "open", "open", "", "32", "", "", "2013-09-06 06:54:17", "2013-09-06 06:54:17", "", "0", "http://blogsforsales.com/cat/?p=32", "3", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("33", "1", "2013-09-06 06:54:17", "2013-09-06 06:54:17", " ", "", "", "publish", "open", "open", "", "33", "", "", "2013-09-06 06:54:17", "2013-09-06 06:54:17", "", "0", "http://blogsforsales.com/cat/?p=33", "4", "nav_menu_item", "", "0");

/* INSERT TABLE DATA: wp_term_relationships */
INSERT INTO `wp_term_relationships` VALUES("1", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("1", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("2", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("3", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("4", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("5", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("6", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("7", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("15", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("17", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("21", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("23", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("25", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("30", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("31", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("32", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("33", "6", "0");

/* INSERT TABLE DATA: wp_term_taxonomy */
INSERT INTO `wp_term_taxonomy` VALUES("1", "1", "category", "", "0", "2");
INSERT INTO `wp_term_taxonomy` VALUES("2", "2", "link_category", "", "0", "7");
INSERT INTO `wp_term_taxonomy` VALUES("3", "3", "category", "", "0", "2");
INSERT INTO `wp_term_taxonomy` VALUES("4", "4", "category", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("5", "5", "category", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("6", "6", "nav_menu", "", "0", "4");

/* INSERT TABLE DATA: wp_terms */
INSERT INTO `wp_terms` VALUES("1", "Cat Training", "cattraining", "0");
INSERT INTO `wp_terms` VALUES("2", "Blogroll", "blogroll", "0");
INSERT INTO `wp_terms` VALUES("3", "Cat Care", "catcare", "0");
INSERT INTO `wp_terms` VALUES("4", "Cat Behaviour", "catproblems", "0");
INSERT INTO `wp_terms` VALUES("5", "Cat Nutrition", "cat-nutrition", "0");
INSERT INTO `wp_terms` VALUES("6", "menu", "menu", "0");

/* INSERT TABLE DATA: wp_usermeta */
INSERT INTO `wp_usermeta` VALUES("1", "1", "first_name", "");
INSERT INTO `wp_usermeta` VALUES("2", "1", "last_name", "");
INSERT INTO `wp_usermeta` VALUES("3", "1", "nickname", "admin");
INSERT INTO `wp_usermeta` VALUES("4", "1", "description", "");
INSERT INTO `wp_usermeta` VALUES("5", "1", "rich_editing", "true");
INSERT INTO `wp_usermeta` VALUES("6", "1", "comment_shortcuts", "false");
INSERT INTO `wp_usermeta` VALUES("7", "1", "admin_color", "fresh");
INSERT INTO `wp_usermeta` VALUES("8", "1", "use_ssl", "0");
INSERT INTO `wp_usermeta` VALUES("9", "1", "show_admin_bar_front", "true");
INSERT INTO `wp_usermeta` VALUES("10", "1", "wp_capabilities", "a:1:{s:13:\"administrator\";s:1:\"1\";}");
INSERT INTO `wp_usermeta` VALUES("11", "1", "wp_user_level", "10");
INSERT INTO `wp_usermeta` VALUES("13", "1", "show_welcome_panel", "1");
INSERT INTO `wp_usermeta` VALUES("14", "1", "wp_dashboard_quick_press_last_post_id", "3");
INSERT INTO `wp_usermeta` VALUES("15", "1", "wp_user-settings", "align=left&imgsize=thumbnail&editor=tinymce&galfile=1&ngg_upload_resize=1&uploader=1&mfold=o&libraryContent=browse&urlbutton=file&hidetb=1&wplink=1");
INSERT INTO `wp_usermeta` VALUES("16", "1", "wp_user-settings-time", "1378144759");
INSERT INTO `wp_usermeta` VALUES("17", "1", "dismissed_wp_pointers", "wp330_toolbar,wp350_media,wp340_choose_image_from_library");
INSERT INTO `wp_usermeta` VALUES("18", "1", "managenav-menuscolumnshidden", "a:4:{i:0;s:11:\"link-target\";i:1;s:11:\"css-classes\";i:2;s:3:\"xfn\";i:3;s:11:\"description\";}");
INSERT INTO `wp_usermeta` VALUES("19", "1", "metaboxhidden_nav-menus", "a:2:{i:0;s:8:\"add-post\";i:1;s:12:\"add-post_tag\";}");
INSERT INTO `wp_usermeta` VALUES("20", "1", "nav_menu_recently_edited", "6");

/* INSERT TABLE DATA: wp_users */
INSERT INTO `wp_users` VALUES("1", "catlover", "$P$B8BBeU76LcaiZBpYD0Ef/IYrwUdcVH/", "admin", "anton241@herbalcuresandremedies.info", "", "2013-09-02 12:53:13", "", "0", "admin");

SET FOREIGN_KEY_CHECKS = 1;